/*
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES 
PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
NECESSARY SERVICING, REPAIR OR CORRECTION.
Original Author: Jeffrey Nygaard
Company: Northern Lights Electronic Design, LLC
Date: May 20, 2016
Contact: JNygaard@NLEDshop.com
NLED Aurora Control Software Version: 1f
Written in Processing v3.1.1
Copyright© 2016 by Northern Lights Electronic Design, LLC. All Rights Reserved
This is proprietary software and the source code is not available. If you have any questions on customization or bug fixes
please contact above author.
Code is mostly obfuscated so don't even try to reverse engineer it! Why are you even reading this?
*/
import processing.serial.*;
import javax.swing.ImageIcon;
java.awt.Insets insets;
import java.awt.Dimension;
//import java.io.BufferedWriter;
//import java.io.FileWriter;
//BufferedWriter bw = null;
import processing.net.*; 
/*
Specs: 
Max Frames: 256
Max Channels: 512
Max USB Live Control: 121 channels
Max Index Sequences: 32
Max Sequences In Software: 32(want 64)
Hotkeys:
s - autosaves
m - empty command request, test if alive
left and right arrow - adjust previously slected slider
right click to stop dragging an icon
REVISIONS 1c to 1d:
- Fixed color picker indicator
- Fixed start values reset functions
- Misc Graphics fixes/optimizations
- Ported to Processing 3.0.1
- Revised timeline scrollbar mouse wheel functions
- Revised/Optimized GUI backend
- Revised the Graphic Layout Tools, both functions and GUI
- Added Radial Gradient Option
- Added Linear Gradient Option
- Added Gradient Adjustment scrollbar
- Changed config.ini to software.ini to avoid any confusion with hardware configurations	
- Added color palette to color picker, stores 6 previously used colors
- Fixed user channel amount text filed issue
- Changed how patch files are loaded
REVISIONS 1b to 1c:
- Added device.FillUpperData to device files, all device files needed updating
- Added global intensity and adjusted connection tab GUI
- Added patch file compatiblity, loads it as custom, so no need to keep the patch file around
- Added copy and paste frame to slide out menu
- Added bootloader command
- Added functions to strip non-readable characters from textfields and sequence IDs
- Edited how tabs are refreshed, alot faster now
- Updated how LED icons are saved and displayed
- Revamped how timeline graphic buffer is generated and managed
- Forced increase maximum memory usage to 384MB, less will cause problems with high amounts of pixels
- Changed how buffers are cached and read
- Enabled Mouse wheel for timeline, index, and sequence side bar
- Added COM port name shrinker to InitCOMButtons()	
REVISIONS 1d to 1e:	
- Updated how pixel chipsets are selected and listed. Added function to recommended Color Order/Swap
- Added POV Usage Mode - merged it with POV config for saving and loading, separate in code
- Timeline layout completely revamped and optimized
- Pevented 0 sequences from being sent that could brick controllers.
- Lowered Maximum Memory Usage from 384 to self-allocated
- Disabled Escape key
- Revised WriteBlockSize usage for new controllers
- Added Index byte build function for 16 or 32 bit index values
- Added GRBW global color swap
- Fixed and optimized Color Picker usage
- Fixed Duplicate Sequence function, wasn't copying all variables
REVISIONS 1e to 1f:	
- updated Patch loading so it won't error/stop if coordinates are missing
- Made maximize window work better
- Added Dual Communication Configuration
REVISIONS 1f to 1g:  
- Fixed Dual Communication issue
- Disabled some debug hot keys that were accidently enabled
*/
final color cColButtonsBG = color(43, 55, 144);
final color cColButtonsHL = color(180, 20, 20);
final color cColButtonsOut = color(255);
final color cBackgroundColor = color(65);
final color cBorderColor = color(190);
final color cStrokeColor = color(200);
final color cMenuColor = color(160);
final color cScrollBoxColor = color(100);
final color cWorkspaceFontColor = color(255);
final color cButtonBG2 = color(0, 104, 55);
final color cWorkspaceFont = color(255);
final color cPurpleColor = color(90,0,255);
final String[] cPixelChipsetStrings = {"DEFAULT", "WS2801", "WS2811", "WS2812", "WS2812B", "LPD1886", "LPD6803", "LPD8806", "TM1803", "TM1814", "APA102", "APA104", "SK6812"};
final String[] cPixelChipsetColorID = {"varies / unknown", "varies / R>G>B", "varies", "G>R>B", "G>R>B", "TEST", "TEST", "TEST", "varies / G>B>R", "TEST", "B>G>R", "TEST", "G>R>B>W"};
final String cModeString[] = {"Stall", "Fade", "Instant", "Gradient", "Combo", "Linked", "POV", "DMX", "Serial", "USB"};
final String cPixelIDStr[] = {"Single", "RGB", "RGBW"};
final String cNoneStr[] = {"None"};
final String cColorSwapStr[] = {"None", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B", "Increase", "Decrease"};
final String cGlobalColSwapStr[] = {"R>G>B(>W)", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B","G>R>B>W"};
final String cDDBaudstring[] = {"9600", "19200", "38400", "57600", "115200", "230400", "250000", "460800", "500000", "1Mbit"}; 
final String cDDLEDMstring[] = {"RX", "Stand-Alone", "Both", "Disabled"};
final String cDDPOVModeString[] = {"Normal Mode", "Mode 1", "Mode 2", "Mode 3", "Mode 4", "Mode 5", "Mode 6", "Mode 8", "Mode 16"};
final int cDDPOVModeValues[] = {0, 1, 2, 3, 4, 5, 6, 8, 16};
final String cRevisionIDstr[] = {"a", "b", "c", "d", "e", "f", "g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"};
final String cDDAutoDetectModesT1[] = {"None/Disabled", "Auto-Detect DMX", "Auto-Detect Serial"};
final String cDDAutoDetectModesT2[] = {"None/Disabled", "Auto-Detect DMX"};
final String cDDMasterModes8Bit[] = {"None/Slave", "Master Full Pkts", "Master Partial Pkts"};
final String cDDMasterModesMultiBit[] = {"None/Slave", "Master Full Pkts 8-Bit", "Master Full Pkts 16-Bit", "Master Partial Pkts 8-Bit", "Master Partial Pkts 16-Bit"};
final String cDDDisplayModes[] = {"Always On", "Countdown", "Dim", "Countdown+Dim"};
final String cDDShapeOptions[] = {"Round", "Square", "Spiral", "Line", "Patch", "Image"};
final String cDDAccMeterShutOff[] = {"Disabled", "5 Sec.", "10 Sec.", "20 Sec.", "30 Sec", "40 Sec.", "60 Sec.","80 Sec."};
final int cAccMeterShutOffVals[] = {16,16,32,64,96,128,192,250};
final String cDDPowerTimeOut[] = {"Disabled", "5 Min.", "10 Min.", "15 Min."};
final String cDDAccMeterTapMode[] = {"Disabled", "X Axis", "Y Axis", "Z Axis"};
final String cConfirmBoxText[] = {"Null-Bad ID Number",
"Confirm Full Upload to connected device. Device sequence data will be erased and new data uploaded",
"Are you sure you would like to delete ", 
"Are you sure you want to delete all sequences?",
"Are you sure you would like to reset the index and clear it?", 
"Would you like to update the utilized Channel amount? Doing so may make some sequences not work til updated.",
"The selected Sequences file is corrupt or errored. Either load a different file, contact support for help recovering the file. Or try restarting the software.",
"Bad Start Values have been detected, various issues can occur, recommend fixing them. Ignore and Send Anyway?",
"This device has a firmware update available, see the included 'Update' folder for details", 
"This will enter the device into bootloader mode, you wil need to close the software and open the bootloader software.",
"Loaded save file specifies a different device than connected. Errors may occur",			
"Device has responded with unverified firmware, functions disabled. Contact Support.",
"Are you sure you would like to upload the configurations currently shown the the hardware tab?"};	
final String cNotificationText[] = {"none", "Command Successful","Start Values Reset","QuickSave Successful","Not Enough Memory","Sequence to Large to Preview","Device Timeout", 
"Command Timeout","Port Not Open","Not Yet Added","Frame Data Copied","No Painting Gradients","Disable Paint Before Closing", 
"Can Not Change Channel Amount","Reached Maximum Linked Sequences","Cannot Send With 0 Sequences On Index","Bad ID's, Attempt Reconnect",
"Coordinates Missing, Check Patch"
};	
final String cPOVDescriptions[] = {"First Pixel Is On The Left. Rows Are Displayed Top To Bottom.",
"First Pixel Is Bottom Left. Columns Are Displayed Left To Right.",
"First Pixel Is On The Right. Rows Are Displayed Top To Bottom.",
"First Pixel Is Top Left. Columns Are Displayed Left To Right."								 									
};		
final String cPOVDescriptionsSecond[] = {"Width Is Amount Of Pixels, Height Is Frames.",
"Height is Amount Of Pixels, Width is Frames",
"Width Is Amount Of Pixels, Height Is Frames.",
"Height is Amount Of Pixels, Width is Frames"								 									
};										
							
final int mStall = 0;
final int mFade = 1;
final int mInstant = 2;
final int mGradient = 3;
final int mCombo = 4;
final int mLinked = 5;
final int mPOV = 6;
final int mSelect = 7;
final int mDMX = 10;
final int mSerial = 11;
final int mUSB = 12;
final int cCMDSpeed = 70;
final int cCMDColShift = 99;
final int cCMDSelSeq = 80;
final int cCMDInstStep = 82;
final int cCMDFadeCtrl = 85;
final int cCMDSeqUp = 91;
final int cCMDSeqDwn = 90;
final int cCMDTogPause = 62;
final int cSoftwareMaxFrames = 256;	
final int cSoftwareMaxChans = 512;	
final int cSoftwareMaxSequences = 32;
final int cSoftwareV = 1;
final int cSoftwareR = 6;
final int cIMwZLgR = 20;
final int cTLChBufH = 30;
final int cTLChBufY = 100;  
final int cTLChBufX = 85;  
final int cTLGraphBufH = 20;
final int cTabGraphic = 0;	
final int cTabTimeline = 1;	
final int cImgBufferX = 85;
final int cImgBufferY = 35;
final color[] IconGroupColors = {color(255,0,0), color(0,255,0), color(0,0,255), color(255,0,255), color(255,255,0), color(0,255,255), color(255,255,255), color(0,0,0)};
int OqJQsXJ = height;  
int BkvHOVd = width;
float ThUIWJw = 1;
int AeQGRRm = 0; 
int ahEjFLw = 0;
int gWdKDuq = 0;
int jgvztaS = 1; 
int MHixUhI = 1;
int yxtcfxi = 0;
int yrsmlGD = 0;
int LWAPDwF = 0;
boolean qAuRcYr = false;
boolean QzQTRuy = false;
boolean YyryBXy = false;
boolean gsgdPHO = false;
boolean rnuvvRs = false;
boolean hkZcTKJ = false;
boolean vLvSrbC = false;
boolean KZdjFXA = false;
boolean oMQaBmH = false;
boolean vTJocgz = false;
boolean VvhyvBZ = false;
int cAkjvcj = 0;
boolean uJwNffD = false;
int BKYieeA = 0;
String dyfVXdN = "None";
String OmWQXCr = "Unconnected";
String vrXaZIu = "192.168.4.1"; 
int DCrfRAK = 23;
boolean QFfuPVT = false;
int KqHwDQs = 0;
int zDLkfrA = 0; 
int RVeDwhC = 0;
boolean OcNYMio = false;
boolean deIRAFp = false;
boolean oxCwaGB = false;
int DIWlYpw = 0;
int lXrpjlY = 0;
int LMORxyF = 1;
int fQlhEcU = 0;
int yJIRxDo = 0;
int oCYGgny = 1;
int zQjfRqq = 0;
int TqwTJFO = 0;
int PDBLtrJ = 0;
int ZVgbanO = 0; 
int MDmgrxQ = 3; 
int fYArHTo = 1; 
int wtkyhyk = 0;
int hoGoqRP = 0;
boolean KUNEdsh = false;
color zpfDQQc = color(0);
float Ohsuixc  = 0;
float OfkiYaD = 0;
float TmzyKzO = 0;
float qeeOUAC = 0;
String oyEwXgK = "";
String glYkgZR = "";
int zJypjQP = 0;
byte[] nZGATrb = new byte[64];
int kjvybLg = 0;
int[] JzvVShV = new int[33]; 
int YsOnDkT = -1;
int OefqCkP = 0; 
int LdDeBhf = 0;
int ezSfeSN = 0;
int sxOzTpa = -1;    
int JQNPFti = 0;
int pPucQLc = 0;
int BqCeyBf = 0;
int aMBxKxp = 0;
int MYEjGAS = 0;
boolean hdESbSC = false;
boolean MuRkHZb = false;
boolean XFdpqPd = false;
boolean QXWMJZB = false;
boolean mBQOSqm = false;
boolean PEMuQZm = false;
boolean OoJfuuV = false;
int yFhUYmK = 0; 
int EBWUsXC = 0; 
int QGxXgDU = 0;
int wLEAfPX = 0; 
int ixQxYRX = 0;
int AINddib = 0;
int PoeHNaw = 0;
int xhPzZot = 4; 
int hgwvVkk[] = {0, 0, 0, 0};
int uDInFJD = 0; 
int QVhoOtU = 3; 
int FmxWQSR = 1; 
int XKRcKWc = 255; 
float ggBWveR = 0;
int molKaUt = 1; 
int RkNigLx = 1;
int GUOIdiy = 1;
int DdSpzLs = 90;
int jQLgPRK = 380;
int FbBzWRr = 0;
int fOVDUFW = 0;
int ndWzZJi = 0;
int UCUaKHp = 1000; 
String PmuCQks = "";
int[] IBzMEJI = new int[10];
int[] zppAzXD = new int[10];
int[] tDYkOHG = new int[1];
int[] exntrzO = new int[10];
int[] mDPegwE = new int[10];
byte[] XsXSdbA;
boolean BTVNeSA = false;
boolean yAtBugw = false;
boolean jgMnfDa = false;
boolean UPJfpbQ = false;
boolean HwGFczd = false;
int AHCacLc = 1000;
int xWhYcfF = 0;
int xOaCPWV = -1000; 
int ZtOnJEO = 0;
int IMwZLgR = cIMwZLgR;
int tGrissw = 2;
int INyauIU = 0;
int UDMnaMJ = 0;
int tVJyYzv = 0; 
int jBfTygi = 0;
int gSPmmNm = 0;
int KqDBNTS = 0;
int XYfpIvO = 0;
int LodQDil = 0;
int xRcScjl, X2, Y1, Y2, X3, Y3, X4, Y4;
int[] PVvDSxb  = new int[2];
int[] lAAqduc = {0,0,0,0};
int[][] paletteColors = new int[6][4];
int FllyozX = 0;
int WrfKRqE = 0;
PFont fNormal, fDigital;
PImage sequencesImg, fullNameImg, gradientImg, POVImg, auroraLogoImg, fullNameRGB, graphicImg;
PGraphics TimeLineBuffer, ConnectionScrollBuffer, GraphicLayoutBuffer, LinkedScrollBuffer, SeqIconBuffer, POVBuffer;
PGraphics[] PreviewBuffer = new PGraphics[cSoftwareMaxChans]; 
PGraphics[] SeqIconPreview = new PGraphics[33];
PGraphics POVGraphicBuffer;
PImage[] povButtonsImgs = new PImage[4];
Serial myPort;      
DeviceObj device;
SpecHWModules[] InputModule;
ColorPickerObj ColorSelector;
UserSequenceObj[] slBNIJT;
DropDown FrameOptionsDD, DMXModesDD, PixelChipsetDD;
DropDown BaudRateDD, LEDModeDD, DropDownPointer, POVModeDD;
DropDown StandAloneDD, DisplayModeDD, ShapeOptionsDD;
DropDown AutoDetectDD, MasterModeDD, HardwareColSwapDD;
DropDown AccMeterAutoModeDD, AccMeterTapDD, PowerDownTimeOutDD;
TabButton[] MenuTabs;
TLButton[] TimeLineLabelButtons;
Button[] TimeLineFrameButtons;
TLTriangle[] TLStartIndicators;
ColorRect[] GradientRects, ControlRects;
ColorRect PaintRect;
Button[] COMButtons, FrameButtons, CommonButtons, FrameOptionsButtons;
Button[] HardwareButtons, SoftwareButtons, ConnectionButtons;
Button[] LiveControlRects, StandaloneButtons, POVOptionButtons;
Button LiveControlClose, LiveControlToggle, HardwarePrevIcon, DMXSequenceIcon, SerialSequenceIcon, StartValReset;
Button DeviceConnect, POVModeAccMeter, ConfirmButtonYes, ConfirmButtonNo, StandAloneClose, GraphicLayoutExpandOpt;
Button ColorSelectorApply, ColorSelectorCancel, GraphicLayoutAllSame, DeviceWebpage, GraphicLayoutColorGroup;
Button GradientGenerate, GradientForward, GradientReverse, POVModeButton, GraphicFuncPaintButton, EnableGroupMode;
Button RequestConfigurations, CopyFrameButton, PasteFrameButton, EnterBootloaderButton;
Button GradientDrawRadialButton, GradientDrawLinearButton, OpenTCPButton, HardwareTabUploadConfigurations;
SliderBar SequenceScrollBar, TimeLineScrollBar, IndexScrollBar, LinkedScrollBar;
SliderBar  GradientStepsSlider, GradientDrawSlider;
SliderBar[] ColorSelectorSliders,MenuSliders, LinkedSliders, ControlSliders, StandaloneSliders;
SliderBar  SequenceSpeedSlider, FrameSpeedSlider, SliderPointer, UserChannelsSlider;
CheckBox[] SeqCheckBoxes, FrameCheckBoxes;
CheckBox[] HardwareCheckBox, SoftwareCheckBox;
CheckBox[] LiveControlCheckBox;
CheckBox[] StandaloneCheckBox;
CheckBox[] LinkedCheckBox;
TextField[] TextFields;
TextField[] LinkedIterationFields;
TextField textFieldPtr;
LEDgraphic[] LEDIcon;
Client TCPClient; 
int[] HoldChanSz = new int[cSoftwareMaxChans];
int[] HoldFullSz = new int[cSoftwareMaxFrames];
int[][] HoldDataFrames = new int[cSoftwareMaxFrames][cSoftwareMaxChans];
int temp = 0;
public void settings() 
{
size(800, 600); 
}
void setup() 
{
if (oxCwaGB == false) 
{
OqJQsXJ = height;  
BkvHOVd = width;   
insets = frame.getInsets();
sequencesImg = loadImage("sequences.png");
fullNameImg = loadImage("logo.png");
fullNameRGB = loadImage("NLED-full-rainbow-1.png");
gradientImg = loadImage("gradient-1.png");
auroraLogoImg = loadImage("aurora-logo.png");
ImageIcon titlebaricon = new ImageIcon(loadBytes("favicon.gif"));
frame.setIconImage(titlebaricon.getImage());
surface.setTitle("NLED Aurora Control Software - "+cSoftwareV+""+cRevisionIDstr[cSoftwareR]+" - Northern Lights Electronic Design, LLC");
surface.setResizable(true);
frameRate(20);
frame.setMinimumSize(new Dimension(480, 360));
fNormal = loadFont("SansSerif.bold-48.vlw");
fDigital = loadFont("IrisUPCBold-48.vlw");
textFont(fNormal, 48);
zQjfRqq = 1; 
ConnectionScrollBuffer = createGraphics(180, 800);
LinkedScrollBuffer = createGraphics(545, 470);  
SeqIconBuffer = createGraphics(140, 580); 
}
int x = 0;
int q = 0;
FrameButtons = new Button[cSoftwareMaxFrames]; 
for (int i =0; i != FrameButtons.length; i++) 
{
if (i%15 == 0 && i != 0) 
{
x++;
q+=15;
}
if (x == 2) x = 0;
switch(x)
{
case 0: 
FrameButtons[i] = new Button(""+(i+1), (85+((i-q)*35)), (525+(x*35)), 30, 30, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
break;
case 1:
FrameButtons[i] = new Button(""+(i+1), (85+((i-q)*35)), (525+(x*35)), 30, 30, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
break;
}
}
FrameButtons[lXrpjlY].Selected = true;
MenuTabs = new TabButton[5];
MenuTabs[0] = new TabButton("Graphic Layout", 130, 10, 90, 20, cBorderColor, color(255), color(0), false, true);
MenuTabs[1] = new TabButton("Timeline", 230, 10, 90, 20, cBorderColor, color(255),  color(0), false, true);
MenuTabs[2] = new TabButton("Connection", 330, 10, 90, 20, cStrokeColor, color(255), color(0), false, true);
MenuTabs[3] = new TabButton("Software Config", 430, 10, 100, 20, cBorderColor, color(255), color(0), false, true);
MenuTabs[4] = new TabButton("Hardware Config", 540, 10, 100, 20, cBorderColor, color(255), color(0), false, true);
MenuTabs[LMORxyF].Selected = true;
CommonButtons = new Button[11]; 
CommonButtons[0] = new Button("Add", 10, 525, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
CommonButtons[1] = new Button("Remove", 10, 550, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
CommonButtons[2] = new Button("Reset", 10, 575, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
CommonButtons[3] = new Button("Up", 620, 535, 35, 20, cColButtonsHL, cColButtonsBG, cColButtonsOut, false, false);
CommonButtons[4] = new Button("Down", 620, 560, 35, 20, cColButtonsHL, cColButtonsBG, cColButtonsOut, false, false);
CommonButtons[5] = new Button("Fade", 670, 550, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
CommonButtons[6] = new Button("Instant", 735, 550, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
CommonButtons[7] = new Button("Gradient", 670, 525, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
CommonButtons[8] = new Button("Combo", 735, 525, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
CommonButtons[9] = new Button("Linked", 670, 575, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
CommonButtons[10] = new Button("POV", 735, 575, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
FrameOptionsButtons = new Button[4]; 
FrameOptionsButtons[0] = new Button("Fade", 5, 250, 65, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, true);
FrameOptionsButtons[1] = new Button("Instant", 5, 280, 65, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
FrameOptionsButtons[2] = new Button("Slide Up", 5, 310, 65, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
FrameOptionsButtons[3] = new Button("Slide Down", 5, 340, 65, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
SeqCheckBoxes = new CheckBox[3];
SeqCheckBoxes[0] = new CheckBox(680, 460, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[1] = new CheckBox(720, 460, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[2] = new CheckBox(765, 460, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[fYArHTo].Selected = true; 
FrameCheckBoxes = new CheckBox[3];
FrameCheckBoxes[0] = new CheckBox(5, 495, 15, 15, color(255), color(0), color(0), false);
FrameCheckBoxes[1] = new CheckBox(30, 495, 15, 15, color(255), color(0), color(0), false);
FrameCheckBoxes[2] = new CheckBox(55, 495, 15, 15, color(255), color(0), color(0), false);
HandleFrameCheckBoxes(0);
ZVgbanO = 0;
SoftwareCheckBox = new CheckBox[3];
SoftwareCheckBox[0] = new CheckBox(605, 435, 20, 20, color(255), color(0), color(0), false); 
SoftwareCheckBox[1] = new CheckBox(605, 463, 20, 20, color(255), color(0), color(0), false);
SoftwareCheckBox[2] = new CheckBox(605, 491, 20, 20, color(255), color(0), color(0), true);
MenuSliders = new SliderBar[1];
MenuSliders[0] = new SliderBar(90, 475, 120, 14, MHixUhI, 1, 32, color(255), color(0), cBorderColor, color(0), true, false, 3); 
SoftwareButtons = new Button[15]; 
SoftwareButtons[0] = new Button("Save Sequences", 470, 40, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[1] = new Button("Load Sequences", 470, 75, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[2] = new Button("Manual", 345, 95, 70, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[3] = new Button("Load File", 445, 410, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[4] = new Button("Edit User ID Text", 470, 325, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
SoftwareButtons[5] = new Button("Delete Sequence", 470, 290, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
SoftwareButtons[6] = new Button("Website", 255, 95, 70, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[7] = new Button("Duplicate Sequence", 470, 255, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
SoftwareButtons[8] = new Button("Load Device File", 485, 110, 130, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[9] = new Button("Clear Sequences", 470, 160, 150, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[10] = new Button("Apply", 365, 365, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[11] = new Button("800 x 600", 90, 550, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[12] = new Button("1024 x 768", 200, 550, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[13] = new Button("1280 x 960", 310, 550, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
SoftwareButtons[14] = new Button("Reset LED Icons", 315, 485, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
HardwareButtons = new Button[6];
HardwareButtons[0] = new Button("Enabled", 125, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
HardwareButtons[1] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
HardwareButtons[2] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
HardwareButtons[3] = new Button("Dot Correction", 255, 330, 130, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false); 
HardwareButtons[4] = new Button("Enabled", 300, 470, 80, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);  
HardwareCheckBox = new CheckBox[2];
HardwareCheckBox[0] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);
HardwareCheckBox[1] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);
ConnectionButtons = new Button[5];
ConnectionButtons[0] = new Button("Upload Sequences & Index", 440, 560, 200, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConnectionButtons[1] = new Button("Upload Configurations", 440, 515, 200, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConnectionButtons[2] = new Button("Reset Index", 300, 160, 110, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConnectionButtons[3] = new Button("USB Live Control", 450, 285, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConnectionButtons[4] = new Button("Stand-Alone Control", 450, 320, 160, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
POVOptionButtons  = new Button[4];
POVOptionButtons[3] = new Button("", 600,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
POVOptionButtons[2] = new Button("", 540,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
POVOptionButtons[1] = new Button("", 480,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
POVOptionButtons[0] = new Button("", 420,85,50,50, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
POVOptionButtons[molKaUt].Selected = true;
povButtonsImgs = new PImage[4]; 
povButtonsImgs[0] = loadImage("pov-button-graphic-1.png");
povButtonsImgs[1] = loadImage("pov-button-graphic-2.png");
povButtonsImgs[2] = loadImage("pov-button-graphic-3.png");
povButtonsImgs[3] = loadImage("pov-button-graphic-4.png");
POVModeDD = new DropDown(cDDPOVModeString, cDDPOVModeString.length, 0, 100, 110, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
ColorSelectorSliders = new SliderBar[4];
ColorSelectorSliders[0] = new SliderBar(160, 325, 120, 10, 0, 0, 255, color(255), color(0), color(255, 0, 0), color(0), true, false, 1); 
ColorSelectorSliders[1] = new SliderBar(160, 345, 120, 10, 0, 0, 255, color(255), color(0), color(0, 255, 0), color(0), true, false, 1); 
ColorSelectorSliders[2] = new SliderBar(160, 365, 120, 10, 0, 0, 255, color(255), color(0), color(0, 0, 255), color(0), true, false, 1); 
ColorSelectorSliders[3] = new SliderBar(160, 385, 120, 10, 0, 0, 255, color(255), color(0), color(128), color(0), true, false, 1); 
ColorSelectorApply = new  Button("Apply", 5, 5, 40, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ColorSelectorCancel = new  Button("Cancel", 5, 5, 45, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
GraphicLayoutAllSame = new  Button("Color All", 10, 470, 60, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false); 
GraphicLayoutColorGroup = new  Button("Color Group", 5, 290, 70, 18, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false); 
GraphicFuncPaintButton = new  Button("Paint", 10, 445, 60, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false);
EnableGroupMode = new  Button("Grouping", 10, 225, 60, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false);
CopyFrameButton = new Button("Copy", 10, 170, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
PasteFrameButton = new Button("Paste", 10, 195, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
GraphicLayoutExpandOpt = new  Button(">", 85, 490, 20, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
PaintRect = new ColorRect(30, 420, 20, 20, 0, 0, 0, 0);	
GradientDrawSlider = new SliderBar(5, 400, 70, 10, 100, 0, 500, color(255), color(0), cBorderColor, color(0), true, false, 12);
GradientDrawRadialButton = new  Button("Radial", 10, 335, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false); 
GradientDrawLinearButton  = new  Button("Linear", 10, 360, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false); 
TextFields = new TextField[17];
TextFields[0] = new TextField("Enter#", 15, 450, 40, 20, color(255), color(200, 40, 40), true, false); 
TextFields[1] = new TextField("Enter#", 225, 470, 50, 20, color(255), color(200, 40, 40), true, false); 
TextFields[2] = new TextField("1", 120, 195, 80, 20, color(255), color(200, 40, 40), true, false); 
TextFields[3] = new TextField("Enter Text ID", 480, 360, 130, 25, color(255), color(200, 40, 40), true, false); 
TextFields[4] = new TextField("1", 155, 45, 50, 25, color(255), color(200, 40, 40), true, false); 
TextFields[5] = new TextField("0", 290, 45, 70, 25, color(255), color(200, 40, 40), true, false); 
TextFields[6] = new TextField("1", 15, 380, 50, 25, color(255), color(200, 40, 40), true, false); 
TextFields[7] = new TextField("Enter#", 265, 145, 60, 25, color(255), color(200, 40, 40), true, false); 
TextFields[8] = new TextField("1", 270, 200, 80, 25, color(255), color(200, 40, 40), true, false); 
TextFields[9] = new TextField("1", 305, 350, 50, 25, color(255), color(200, 40, 40), true, false); 
TextFields[10] = new TextField("", 0, 0, 50, 20, color(255), color(200, 40, 40), true, false); 
TextFields[11] = new TextField("Enter#", 295, 365, 60, 25, color(255), color(200, 40, 40), true, false); 
TextFields[12] = new TextField("1", 730, 480, 60, 20, color(255), color(200, 40, 40), true, false); 
TextFields[13] = new TextField("0", 20, 265, 40, 20, color(255), color(200, 40, 40), true, false); 
TextFields[14] = new TextField("100", 335, 545, 50, 25, color(255), color(200, 40, 40), true, false); 
TextFields[15] = new TextField("0", 0, 0, 50, 25, color(255), color(200, 40, 40), true, false); 
TextFields[16] = new TextField("0", 0, 0, 50, 25, color(255), color(200, 40, 40), true, false); 
LiveControlCheckBox = new CheckBox[4];
LiveControlCheckBox[0] = new CheckBox(120, 55, 20, 20, color(255), color(0), color(0), false);
LiveControlCheckBox[1] = new CheckBox(160, 55, 20, 20, color(255), color(0), color(0), true);
LiveControlCheckBox[2] = new CheckBox(200, 55, 20, 20, color(255), color(0), color(0), false);
LiveControlCheckBox[3] = new CheckBox(395, 55, 20, 20, color(255), color(0), color(0), false);
StandAloneClose = new  Button("Close", 480, 55, 140, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false);
LiveControlClose = new  Button("Close", 570, 45, 80, 25, cPurpleColor, cColButtonsHL, cColButtonsOut, false, false);
LiveControlToggle = new  Button("Sliders/Color", 460, 45, 100, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneSliders = new   SliderBar[3];
StandaloneSliders[0] = new SliderBar(95, 230, 260, 16, 0, 1, 65535, color(255), color(0), cBorderColor, color(0), true, false, 9);  
StandaloneSliders[1] = new SliderBar(175, 350, 120, 16, 0, 0, 1023, color(255), color(0), cBorderColor, color(0), true, false, 9); 
StandaloneSliders[2] = new SliderBar(175, 380, 120, 16, 1, 1, 64, color(255), color(0), cBorderColor, color(0), true, false, 9);  
StandAloneDD = new DropDown(cColorSwapStr, 8, 0, 215, 60, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
StandaloneButtons = new Button[9];
StandaloneButtons[0] = new  Button("Send", 370, 55, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[1] = new  Button("Send", 370, 130, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[2] = new  Button("Send", 370, 210, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[3] = new  Button("Step Up", 160, 285, 90, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[4] = new  Button("Step Down", 260, 285, 90, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[5] = new  Button("Send", 370, 350, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false); 
StandaloneButtons[6] = new  Button("Sequence Up", 480, 125, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[7] = new  Button("Sequence Down", 480, 165, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneButtons[8] = new  Button("Play/Pause", 480, 205, 140, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StandaloneCheckBox = new CheckBox[2];
StandaloneCheckBox[0] = new CheckBox(190, 135, 20, 20, color(255), color(0), color(0), false);
StandaloneCheckBox[1] = new CheckBox(190, 150, 20, 20, color(255), color(0), color(0), false);
AccMeterAutoModeDD = new DropDown(cDDAccMeterShutOff, cDDAccMeterShutOff.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
AccMeterTapDD  = new DropDown(cDDAccMeterTapMode, cDDAccMeterTapMode.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
LEDModeDD = new DropDown(cDDLEDMstring, cDDLEDMstring.length, 0, 420, 180, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
FrameOptionsDD = new DropDown(cColorSwapStr, cColorSwapStr.length, 0, 5, 210, 65, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
DMXModesDD = new DropDown(cNoneStr, 1, 0, 85, 280, 150, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
BaudRateDD = new DropDown(cDDBaudstring, cDDBaudstring.length, 0, 260, 215, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
DisplayModeDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);		
DisplayModeDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
MasterModeDD = new DropDown(cDDMasterModes8Bit, cDDMasterModes8Bit.length, 0, 90, 340, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
AutoDetectDD = new DropDown(cDDAutoDetectModesT1, cDDAutoDetectModesT1.length, 0, 405, 300, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
HardwareColSwapDD = new DropDown(cGlobalColSwapStr, cGlobalColSwapStr.length, 0, 480, 470, 100, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
PixelChipsetDD = new DropDown(cNoneStr, cNoneStr.length, 0, 350, 470, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false); 
ShapeOptionsDD = new DropDown(cDDShapeOptions, cDDShapeOptions.length, 0, 310, 410, 120, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
PowerDownTimeOutDD = new DropDown(cDDPowerTimeOut, cDDPowerTimeOut.length, 0, 405, 300, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);	
DropDownPointer = new DropDown(cNoneStr, 1, 0, 405, 360, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false);
HardwarePrevIcon = new  Button("Drag and Drop\na Sequence to\nPreview it on\nthe Device", 500, 170, 110, 70, cScrollBoxColor, cColButtonsHL, color(255), false, false);
DMXSequenceIcon = new  Button("DMX Reception\n\nDrag and Drop\nInto Index Field", 300, 200, 110, 70, cBorderColor, cColButtonsHL, color(0), false, false);
SerialSequenceIcon = new  Button("Serial Reception\n\nDrag and Drop\nInto Index Field", 300, 280, 110, 70, cBorderColor, cColButtonsHL, color(0), false, false);
GradientGenerate = new Button("Generate", 480, 525, 60, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
GradientForward = new Button(">", 585, 525, 20, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, true);
GradientReverse = new Button("<", 555, 525, 20, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
DeviceConnect = new Button("Connect", 5, 115, 70, 20, cColButtonsHL, color(0,155,0), cColButtonsOut, true, false);
POVModeButton = new Button("Load Image File", 280, 40, 120, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConfirmButtonYes = new Button("Yes", 325, 325, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
ConfirmButtonNo = new Button("No", 415, 325, 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
DeviceWebpage = new Button("Open Device Webpage", 515, 40, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
RequestConfigurations = new Button("Request Configurations", 505, 160, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
HardwareTabUploadConfigurations = new Button("Upload Configurations", 350, 160, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
EnterBootloaderButton = new Button("Enter Bootloader Mode", 515, 70, 140, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
StartValReset = new Button("Reset Start Values", 90, 40, 110, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
OpenTCPButton = new Button("Open TCP", 5, 180, 70, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, false, false);
TimeLineScrollBar = new SliderBar(630, 100, 24, 410, 0, 0, (zQjfRqq*cTLChBufH) - 470, color(255), cColButtonsHL, color(255), color(0), true, true, 0);
IndexScrollBar = new SliderBar(265, 35, 24, 560, 0, 0, 2, color(255), cColButtonsHL, color(255), color(0), false, true, 5);
SequenceScrollBar = new SliderBar(780, 40, 20, 390, 0, 0, 1, color(255), cColButtonsHL, color(255), color(0), false, true, 4);
LinkedScrollBar = new SliderBar(630, 40, 24, 465, 0, 0, (zQjfRqq*80) - 470, color(255), cColButtonsHL, color(255), color(0), false, true, 6);
SliderPointer= new SliderBar(0, 0, 0, 0, 0, 0, 0, color(255), cColButtonsHL, color(255), color(0), false, false, 255); 
SequenceSpeedSlider = new SliderBar(670, 505, 120, 12, 1, 1, 0xFFFF, color(255), color(0), cBorderColor, color(0), true, false, 7); 
FrameSpeedSlider = new SliderBar(5, 410, 65, 12, 1, 1, 255, color(255), color(0), cBorderColor, color(0), true, false, 9); 
GradientStepsSlider = new SliderBar(330, 525, 140, 16, 0, 0, 1024, color(255), color(0), color(200), color(0), true, false, 2); 
UserChannelsSlider = new SliderBar(95, 375, 180, 14, 0, 1, 256, color(255), color(0), color(200), color(0), true, false, 11);
device = new DeviceObj(0, "No Device", 0, 0, 0, 0, 0, 0, 0, 0, false, false, false, cRevisionIDstr, 0, 0);
GradientRects = new ColorRect[1]; 
ColorSelector = new ColorPickerObj(100, 100, 270, 290, 0, 0, 0,0,0,0);
InputModule = new SpecHWModules[20];
InputModule[0] = new SpecHWModules(0,"Serial RS-485 Enable:\n(Disable for TTL Serial)",0, 0,140, 90);
InputModule[1] = new SpecHWModules(1,"16-Bit DMX Master:\n(Disabled is Standard 8-bit)",0, 0,130, 90);
InputModule[2] = new SpecHWModules(2,"Select Correct Color Order For Chipset:",0, 0,120, 90);
InputModule[3] = new SpecHWModules(3,"Select The Pixel Chipset:\n\n\nRecommended Color: varies / R>G>B",0, 0,160, 90);
InputModule[4] = new SpecHWModules(4,"Enable Serial Reception Instead of DMX reception. Auto-Detect is disabled during serial reception.",0,0, 200, 90);
InputModule[5] = new SpecHWModules(5,"DMX Address:\n(Enter Number)\n\n\n(1-512)",0,0, 120, 90);
InputModule[6] = new SpecHWModules(6,"DMX Reception\nMode - ID Number: "+device.SelDMXMode,0,0, 170, 90); 
InputModule[7] = new SpecHWModules(7,"DMX Master Mode:",0,0, 160, 90); 
InputModule[8] = new SpecHWModules(8,"Serial Baud Rate:\nID Number: "+device.SelBaudRate,0,0, 120, 90); 
InputModule[9] = new SpecHWModules(9,"Indicator\nLED Mode:",0,0, 120, 90); 
InputModule[10] = new SpecHWModules(10,"External\nLED Display Mode:",0,0, 140, 90); 
InputModule[11] = new SpecHWModules(11,"Auto-Detect Option:",0,0, 140, 90); 
InputModule[12] = new SpecHWModules(12,"Open Current\nCorrection:",0,0, 140, 90); 
InputModule[13] = new SpecHWModules(13,"Automatic Shut Off/Resume\n & Time Out Value",0,0, 120, 90); 
InputModule[14] = new SpecHWModules(14,"Enable Accelerometer Speed Adjustment",0,0, 140, 90); 
InputModule[15] = new SpecHWModules(15,"Enable Accelerometer Double Tap Button Press",0,0, 140, 90); 
InputModule[16] = new SpecHWModules(16,"Power Down\nTime Out",0,0, 140, 90); 
InputModule[17] = new SpecHWModules(17,"Pixel Data Packet Cloning:\n(0 is Disabled)",0,0, 120, 90); 
InputModule[18] = new SpecHWModules(18,"Sequence Fade Transition:\n(0 is Disabled)",0,0, 120, 90); 
InputModule[19] = new SpecHWModules(19,"Dual Communication Mode (WiFi/Bluetooth)",0,0, 120, 90); 
for (int i=0; i != paletteColors.length;i++) for (int z=0; z != paletteColors[i].length;z++) paletteColors[i][z] = 0;
device.WebpageURL = "www.NLEDshop.com"; 
oyEwXgK = "log-"+hour()+"-"+minute()+"-"+day()+"-"+month()+"-"+year()+".txt";
POVBuffer = createGraphics(560, 360);
POVBuffer.beginDraw();
POVBuffer.background(0, 0, 0, 0);
POVBuffer.endDraw();
POVImg = createGraphics(1, 1);
graphicImg = loadImage("imagelayouts/default.png"); 	
if(oxCwaGB == false) InitNoSequences();
oxCwaGB = true; 
AppendLogFile("====Starting Software Version "+cSoftwareV+" Revision "+cSoftwareR+"====");	
InitCOMButtons();
LoadConfigFile(); 
}
void InitCOMButtons()
{
AppendLogFile("InitCOMButtons()");
try 
{
COMButtons = new Button[Serial.list().length];  
String[] COMPortNames = new String[Serial.list().length];
int varStart = 0;
int varEnd = 0;
for (int i=0; i != Serial.list().length;i++)
{
if (Serial.list()[i].length() > 8) { 
varStart = Serial.list()[i].length() - 8; 
varEnd =  Serial.list()[i].length();
} else 
{ 
varStart = 0; 
varEnd = Serial.list()[i].length();
}
COMPortNames[i] = Serial.list()[i].substring(varStart, varEnd);
COMButtons[i] = new Button(COMPortNames[i], 10, 245+(i*30), 60, 25, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, false);
}  
for (int x =0; x != Serial.list().length; x++) 
{
if(dyfVXdN.equals(Serial.list()[x]))
{		
AppendLogFile("This ran, but shouldn't during setup()");	
OpenCOMPort(dyfVXdN);
}
}	
}
catch(Exception e) {AppendLogFile("Exception in InitCOMButtons()"); }	
}	
public class DeviceObj
{
int HardwareID;
String Name;
int HardwareVersion;
int FirmwareVersion;
int FirmwareRevision;
int Channels;
int DataSpace;
int HPVBlockSize;
int SeqMemoryBlockSize; 
int IndexBlockSize; 
int CurrentBlockSize;
int EraseBlockSize;
int HPVSpace;
int DMXModeAmt;
boolean CurrentCorrection;
boolean LinkedSupport;  
boolean Bit16Capable;
boolean Serial16Bit; 
boolean LEDDisplayCapable;
boolean LEDIndicatorCapable;
boolean RS485Capable; 
boolean DMXMasterCapable;
boolean FillUpperData;
int BasicVersion;
int BasicMaxSequences; 
int BasicSeqLength;
boolean SerialInput;
boolean AutoDetection;
boolean PowerDownTimer;
boolean Bit16Processor;
boolean GlobalColorShift; 
boolean EvenDataFlag; 
boolean SequenceTransition;
int AccelerometerMode;
int SelBaudRate;  
String[] DMXModeLabels;
int SelDMXMode;
int SelPixelType;
int IndexMemoryModel;
String WebpageURL;
String MemorySpaceString;
DeviceObj(int iHardwareID, String iName, int iHardwareVersion, int FirmwareVersion, int FirmwareRevision, int iChannels, int iDataSpace, 
int iEraseBlockSize, int iHPVSpace, int iDMXModeAmt, boolean iCurrentCorrection, boolean iLinkedSupport, boolean iBit16Capable, 
String[] iDMXModeLabels, int iSelDMXMode, int iSelBaudRate)
{
HardwareID = iHardwareID;
Name = iName;
HardwareVersion = iHardwareVersion;
FirmwareVersion = FirmwareVersion;
FirmwareRevision = FirmwareRevision;  
Channels = iChannels;
DataSpace = iDataSpace;
EraseBlockSize = iEraseBlockSize;
HPVSpace = iHPVSpace;
DMXModeAmt = iDMXModeAmt;
CurrentCorrection = iCurrentCorrection;
LinkedSupport = iLinkedSupport;
Bit16Capable = iBit16Capable;
DMXModeLabels = iDMXModeLabels;   
SelDMXMode = iSelDMXMode;
SelBaudRate = iSelBaudRate;
}
} 
public class UserSequenceObj
{
String UserID;
int IndexNum;
int Length;
int SeqFrameAmount;
int DataFrameAmount;
int Speed;
int DataSize; 
int SeqMode; 
int DataType; 
int[] StartValues;
int[] SpecialFrameVar;
int[] DataFrameVar;
int[] FrameSpecial;
int[] SlideValues;
int[] SpeedValues; 
int[][] DataFrames;
int bWidth = 110;
int bHeight = 70;
boolean Highlighted;
boolean LinkerUtilized;
int assignedIDNum; 
boolean IDassigned;
int assignedLinkedIDNum;  
int MappedAdr;
boolean StartValError;
int gradientSteps;
int molKaUt;
int POVUsageMode;
UserSequenceObj(String iUserID, int iIndexNum, int iLength, int iSeqFrameAmount, int iDataFrameAmount, int iSpeed, int iDataSize, int iSeqMode, int iDataType, 
int[] iStartValues, int[] iSpecialFrameVar, int[] iDataFrameVar, int[] iFrameSpecial, int[] iSlideValues, int[] iSpeedValues, int[][] iDataFrames, boolean iHighlighted)
{
UserID = iUserID;
IndexNum = iIndexNum;
Length = iLength;
SeqFrameAmount = iSeqFrameAmount;
DataFrameAmount =iDataFrameAmount;
Speed = iSpeed;
DataSize = iDataSize;
SeqMode = iSeqMode;
DataType = iDataType;
StartValues = iStartValues;
SpecialFrameVar = iSpecialFrameVar;
DataFrameVar = iDataFrameVar;
FrameSpecial = iFrameSpecial;
SlideValues = iSlideValues;
SpeedValues = iSpeedValues;
DataFrames = iDataFrames;
Highlighted = iHighlighted;
}
void displayIcon(int xposB, int yposB)
{
SeqIconBuffer.noStroke();
SeqIconBuffer.fill(cBackgroundColor);
SeqIconBuffer.rect(xposB-3, yposB-3, bWidth+10, bHeight+10);
SeqIconBuffer.fill(cBorderColor);
SeqIconBuffer.strokeWeight(2);
if (Highlighted == true)  SeqIconBuffer.stroke(cColButtonsHL);
else SeqIconBuffer.noStroke();  
SeqIconBuffer.rect(xposB, yposB, bWidth, bHeight);
SeqIconBuffer.textSize(12);
SeqIconBuffer.fill(0);
SeqIconBuffer.text(UserID, xposB+5, yposB+15);
if(SeqMode != mLinked)	SeqIconBuffer.text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
SeqIconBuffer.text("Mode: "+cModeString[SeqMode], xposB+5, yposB+45); 		
SeqIconBuffer.image(SeqIconPreview[IndexNum], xposB+5, yposB+50, bWidth*0.9, bHeight*0.2);
}  
void displayIconDrag(int xposB, int yposB)
{
strokeWeight(2);
stroke(0);  
fill(cBorderColor);
rect(xposB, yposB, bWidth, bHeight);
noStroke();
textSize(12);
fill(0);
text(UserID, xposB+5, yposB+15);
if(SeqMode != mLinked)	text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
text("Mode: "+cModeString[SeqMode], xposB+5, yposB+45);     
image(SeqIconPreview[IndexNum], xposB+5, yposB+50, (bWidth*0.9), (bHeight*0.2));
}
void displayIconB(int xposB, int yposB)
{
ConnectionScrollBuffer.fill(cBorderColor);
ConnectionScrollBuffer.stroke(0);  
ConnectionScrollBuffer.rect(xposB, yposB, bWidth, bHeight);
ConnectionScrollBuffer.textSize(12);
ConnectionScrollBuffer.fill(0);
ConnectionScrollBuffer.text(UserID, xposB+5, yposB+15);
ConnectionScrollBuffer.text("Mode: "+cModeString[SeqMode], xposB+5, yposB+45);    
if(SeqMode != mLinked)	
{
ConnectionScrollBuffer.text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
ConnectionScrollBuffer.image(SeqIconPreview[IndexNum], xposB+5, yposB+50, bWidth*0.9, bHeight*0.2);
}
} 
void displayIconC(int xposB, int yposB)
{
LinkedScrollBuffer.fill(cBorderColor);
LinkedScrollBuffer.stroke(0);  
LinkedScrollBuffer.rect(xposB, yposB, bWidth, bHeight);
LinkedScrollBuffer.textSize(12);
LinkedScrollBuffer.fill(0);
LinkedScrollBuffer.text(UserID, xposB+5, yposB+15);
if(SeqMode != mLinked)	LinkedScrollBuffer.text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
LinkedScrollBuffer.text("Mode: "+cModeString[SeqMode], xposB+5, yposB+45);     
LinkedScrollBuffer.image(SeqIconPreview[IndexNum], xposB+5, yposB+50, bWidth*0.9, bHeight*0.2);
}   
boolean over(int xposB, int yposB)
{
if ( yrsmlGD >= (660+xposB) && yrsmlGD <= (660+xposB+bWidth) && LWAPDwF >= 35+(yposB-(SequenceScrollBar.Value*80)) && LWAPDwF <= (35+bHeight)+(yposB-(SequenceScrollBar.Value*80))) 
{      
return true;
} 
else {
return false;
}
}
}
void pressHandlerDraggingIcon()
{
if (HardwarePrevIcon.over() && VvhyvBZ == true && device.HPVSpace > 0) 
{
AppendLogFile("Over HardwarePreview Rect"); 
VvhyvBZ = false;
RequestToSendPreview();
return;
}
if(OcNYMio == true) cAkjvcj = 1000; 
else if(deIRAFp == true) cAkjvcj = 1001; 
if((device.BasicVersion == 0 || device.BasicMaxSequences > 8) || YsOnDkT < 7)
{
for (int i =0; i != YsOnDkT+2; i++)
{
if (i <= YsOnDkT)
{
try {
if (yrsmlGD >= (60+85) && yrsmlGD <= (60+85+110) && LWAPDwF >= 35+((5+(i*80))-(IndexScrollBar.Value*80)) && LWAPDwF <= (35+70)+((5+(i*80))-(IndexScrollBar.Value*80)))     
{
AppendLogFile("Over Connection SeqIcon "+i);
JzvVShV[i] = cAkjvcj; 
DrawIndexScrollArea();
break; 
}
}
catch(Exception e) {
}
}
else
{
if(YsOnDkT == 31) break; 
if (yrsmlGD >= (60+85) && yrsmlGD <= (60+85+110) && LWAPDwF >= 35+((5+((YsOnDkT+1)*80))-(IndexScrollBar.Value*80)) &&  LWAPDwF <= (35+70)+((5+((YsOnDkT+1)*80))-(IndexScrollBar.Value*80)))     
{
AppendLogFile("Over Add Sequence Icon "+cAkjvcj);
if(cAkjvcj == 1001 || cAkjvcj == 1000)
{
YsOnDkT++;
JzvVShV[YsOnDkT] = cAkjvcj;
DrawIndexScrollArea();	
}
else if((LdDeBhf+slBNIJT[cAkjvcj].Length) <= device.DataSpace)
{
YsOnDkT++;
JzvVShV[YsOnDkT] = cAkjvcj;
DrawIndexScrollArea();					
}
else
{	
AppendLogFile("Sequence Would Overflow the memory");
EBWUsXC = 4; 
}		
break;
}
}
} 
} 
OcNYMio = false;
deIRAFp = false;
VvhyvBZ = false;
return;
}
boolean pressHandlerSeqOptions()
{
if(TextFields[12].over()) { TextFields[12].SelectField(12); return true; } 
for(int i =0; i != CommonButtons.length; i++)  if (CommonButtons[i].over()) { HandleCommonButtons(i); return true; }
if (SequenceSpeedSlider.over()) { SequenceSpeedSlider.selectSlider(); return true; } 
for (int i =0; i != SeqCheckBoxes.length; i++)
{
if (SeqCheckBoxes[i].over())
{
AppendLogFile("SeqCheckBox "+i+" pressed"); 
if(slBNIJT[DIWlYpw].DataType != i)
{
slBNIJT[DIWlYpw].DataType = i;
UpdateSequence(DIWlYpw);
}
return true;
}
}	
if((slBNIJT[DIWlYpw].SeqMode == mGradient && LMORxyF == 1) == false)
{	
for (int i =0; i != slBNIJT[DIWlYpw].SeqFrameAmount+1; i++)
{
if (FrameButtons[i].over() && floor(i/30) == wtkyhyk)
{
AppendLogFile("FrameButtons "+i+" pressed "+wtkyhyk); 
SetlXrpjlY(i);
FillFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial);   
fQlhEcU = lXrpjlY;
if(LMORxyF == 1)
{
TimeLineFrameButtons[lXrpjlY].Selected = true;
}
else
{
AppendLogFile("updating LEDIcon objects "+INyauIU);
try 
{
for (int q =0; q != INyauIU; q++)  LEDIcon[q].display(); 
}
catch(Exception e)
{
AppendLogFile("ERROR - LEDIcon NullPointer"); 
}
}
return true; 
}
} 
} 
return false;
} 
boolean pressHandlerGraphicTools()
{
if(TextFields[13].over()) { TextFields[13].SelectField(13); return true; }
if(GradientDrawSlider.over()) { GradientDrawSlider.selectSlider(); return true; }
if (GraphicFuncPaintButton.over() && EnableGroupMode.Selected == false)
{			
if(slBNIJT[DIWlYpw].SeqMode == mGradient) { EBWUsXC = 11; return true; }
GraphicFuncPaintButton.Selected =! GraphicFuncPaintButton.Selected;
if(GraphicFuncPaintButton.Selected == true)
{	
GraphicFuncPaintButton.Selected = true;
AppendLogFile("Enable Paint - Choose Color");
YyryBXy = true;  
ColorSelector.InitPosition();
}
else GraphicFuncPaintButton.Selected = false;
return true;
}		
else if (GraphicLayoutAllSame.over() && EnableGroupMode.Selected == false)
{
AppendLogFile("Apply Color to All");
GraphicFuncPaintButton.Selected = false;		
YyryBXy = true;  
fQlhEcU = 10000;
ColorSelector.InitPosition();
return true;
}
else if(GraphicLayoutColorGroup.over())
{
if(slBNIJT[DIWlYpw].SeqMode == mGradient) { EBWUsXC = 11; return true; }
AppendLogFile("Apply Color to Group");
GraphicFuncPaintButton.Selected = false;		
YyryBXy = true;  
fQlhEcU = 10000+1+ZtOnJEO;
ColorSelector.InitPosition();
return true;				
}	
else if(EnableGroupMode.over())
{
EnableGroupMode.Selected =! EnableGroupMode.Selected;	
return true;
}
else if(CopyFrameButton.over() && EnableGroupMode.Selected == false)
{
CopyFrameButton.Selected = true;
CopyFrameButton.display();
EBWUsXC = 10; 
exntrzO = expand(exntrzO, yxtcfxi); 
arrayCopy(slBNIJT[DIWlYpw].DataFrames[lXrpjlY], exntrzO, yxtcfxi); 
return true;
}
else if(PasteFrameButton.over() && EnableGroupMode.Selected == false)
{
PasteFrameButton.Selected = true;
PasteFrameButton.display();		
arrayCopy(exntrzO, slBNIJT[DIWlYpw].DataFrames[lXrpjlY], yxtcfxi); 
MenuTabs[0].refresh();
MenuTabs[1].refresh();
return true;
}
else if(GradientDrawRadialButton.over())
{
if(GradientDrawRadialButton.Selected == true)
{
GradientDrawRadialButton.Selected = false;
tVJyYzv = 0;
return true;
}
GradientDrawRadialButton.Selected = true;
GradientDrawLinearButton.Selected = false;
tVJyYzv = 1;
return true;
}
else if(GradientDrawLinearButton.over())
{
if(GradientDrawLinearButton.Selected == true)
{
GradientDrawLinearButton.Selected = false;
tVJyYzv = 0;
return true;
}
GradientDrawLinearButton.Selected = true;
GradientDrawRadialButton.Selected = false;
tVJyYzv = 2;
return true;
}
return false;
} 
boolean pressHandlerMenuTabs()
{
for (int i =0; i != MenuTabs.length; i++) 
{
if (MenuTabs[i].over())
{
MenuTabs[LMORxyF].Selected = false;  
LMORxyF = i;
MenuTabs[i].Selected = true;
AppendLogFile("Changed Menu Tabs, SelectedMenuTab ="+LMORxyF);
yAtBugw = false; 
GraphicFuncPaintButton.Selected = false; 
GradientDrawRadialButton.Selected = false; 
GradientDrawLinearButton.Selected = false; 
tVJyYzv = 0;
if (RVeDwhC == 1 || RVeDwhC == 2 && LMORxyF != 2)
{
RVeDwhC = 0;
xhPzZot = 60; 
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
}
if (i == 0 || i == 1)  SequenceScrollBar.slHeight = 390;
else SequenceScrollBar.slHeight = 555; 
if(slBNIJT.length > 1)
{
if(LMORxyF == 0 || LMORxyF == 1) 
SequenceScrollBar.Maximum = (slBNIJT.length)-5;
else
SequenceScrollBar.Maximum = (slBNIJT.length)-7;
if(SequenceScrollBar.Maximum < 1) SequenceScrollBar.Maximum = 1;
if(SequenceScrollBar.Value > SequenceScrollBar.Maximum) SequenceScrollBar.Value = SequenceScrollBar.Maximum;
}	
if(MenuTabs[0].ReqRefresh || MenuTabs[1].ReqRefresh) MenuTabs[2].ReqRefresh = true; 
if (MenuTabs[i].ReqRefresh == true) { MenuTabs[i].refresh(); AppendLogFile("REFRESHED =========== "+i); }
return true;
}
}
return false;
}
boolean pressHandlerRightClick()
{
AppendLogFile("X: "+yrsmlGD+" - Y: "+LWAPDwF);
if(LMORxyF == 2)
{
AppendLogFile("Checking Index Icons");
for (int i =0; i != YsOnDkT+2; i++)
{
if (i <= YsOnDkT)
{
if (yrsmlGD >= (60+85) && yrsmlGD <= (60+85+110) && LWAPDwF >= 35+((5+(i*80))-(IndexScrollBar.Value*80)) && LWAPDwF <= (35+70)+((5+(i*80))-(IndexScrollBar.Value*80)))     
{
AppendLogFile("Clicked Populated Connection SeqIcon "+i+"   IndexPointer: "+YsOnDkT);
JzvVShV[i] = 255; 
if(YsOnDkT > i)
{
AppendLogFile("need to shift data down");
for (int q = i; q != YsOnDkT+1; q++)
{
AppendLogFile("shifting slot "+i+" to "+(i+1));
if(q != 32)
{	
JzvVShV[q] = JzvVShV[q+1]; 
}
else JzvVShV[q] = 255; 
}
}
YsOnDkT--;
DrawIndexScrollArea();
break; 
}
}
} 
} 
else if(LMORxyF == 0 && jgvztaS == 6)
{
for (int i =0; i != INyauIU; i++)
{
try {
if (LEDIcon[i].over())
{
AppendLogFile("LEDIcon "+i+" right clicked");
xOaCPWV = i;
GraphicLayoutBuild();
LEDIcon[i] = null;			
return true;
}
}
catch(Exception e)
{
AppendLogFile("Error check over() for LEDicons");
}
}	
return true;
} 
VvhyvBZ = false;
OcNYMio = false;
deIRAFp = false;
YyryBXy = false;
QFfuPVT = false;
jgMnfDa = false;
return true;		
}
boolean pressHandlerFrameOptions()
{
if (LMORxyF == cTabGraphic || LMORxyF == cTabTimeline) 
{
if (TextFields[0].over() && PDBLtrJ > 2)  {TextFields[0].SelectField(0); return true; }  
if (TextFields[6].over() && slBNIJT[DIWlYpw].SeqMode == mCombo) { TextFields[6].SelectField(6); return true; }  
for (int i =0; i != FrameCheckBoxes.length; i++)
{
if (FrameCheckBoxes[i].over() && PDBLtrJ > 2) 
{
AppendLogFile("FrameCheckBox "+i+" pressed"); 
HandleFrameCheckBoxes(i+1); 
ZVgbanO = i+1;
SetFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial);
return true;
}
}
if (FrameOptionsDD.over() && device.BasicVersion == 0 && slBNIJT[DIWlYpw].SeqMode != mLinked && slBNIJT[DIWlYpw].SeqMode != mPOV) 
{
FrameOptionsDD.selectDD();
AppendLogFile("Pressed FrameOptionsDD");
return true;
}
else if (FrameOptionsDD.overOpen() != 0 && FrameOptionsDD.Selected == true)
{
AppendLogFile("Pressed FrameOptionsDD DropDown "+FrameOptionsDD.overOpen() );
TqwTJFO = (FrameOptionsDD.overOpen()-1);
FrameOptionsDD.Selected = false;
FrameOptionsDD.SelStr = (FrameOptionsDD.overOpen()-1);
SetFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial);
return true;
} 
for (int i = 0; i != FrameOptionsButtons.length; i++)
{
if (FrameOptionsButtons[i].over())
{
AppendLogFile("FrameOptionsButtons "+i+" pressed"); 
if (slBNIJT[DIWlYpw].SeqMode != mCombo && slBNIJT[DIWlYpw].SeqMode != mInstant) return true;
if (slBNIJT[DIWlYpw].SeqMode == mInstant && i == 0) return true;
FrameOptionsButtons[0].Selected = false;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;   
FrameOptionsButtons[i].Selected = true;       
switch(i)
{
case 0: 
PDBLtrJ = 1;
ZVgbanO = 1; 
HandleFrameCheckBoxes(0); 
break; 
case 1:
PDBLtrJ = 2;  
ZVgbanO = 1; 
HandleFrameCheckBoxes(0);  
break;
case 2:
PDBLtrJ = 6;
ZVgbanO = fYArHTo+1;  
HandleFrameCheckBoxes(ZVgbanO);
break; 
case 3:
PDBLtrJ = 3;
ZVgbanO = fYArHTo+1;  
HandleFrameCheckBoxes(ZVgbanO);
break;
}
SetFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial);
MenuTabs[0].refresh();
MenuTabs[1].refresh();
return true;
}
}
}
return false;
}
boolean pressHandlerSeqIcons()
{
for (int i = 1; i != slBNIJT.length; i++) 
{
if (slBNIJT[i].over(5, 5+((i-1)*80)) || (LMORxyF == 2 && slBNIJT[i].over(5, 5+((i-1)*80))))
{
if((LMORxyF == cTabTimeline || LMORxyF == cTabGraphic) && LWAPDwF > 425) break; 
AppendLogFile("UserSeq "+i+" pressed"); 
if (LMORxyF == 2) 
{
AppendLogFile("Starting to Drag");
VvhyvBZ = true;
cAkjvcj = i;  
return true;
}
else if (LMORxyF == cTabTimeline && slBNIJT[DIWlYpw].SeqMode == mLinked && QFfuPVT == true)
{
if (slBNIJT[i].SeqMode != mLinked)
{
QFfuPVT = false;
slBNIJT[DIWlYpw].DataFrames[0][KqHwDQs] = i; 
AppendLogFile("ID set to: "+slBNIJT[DIWlYpw].DataFrames[0][KqHwDQs]);
DrawLinkedBuffer();
}
return true;
}
else if (vLvSrbC == true)
{
TextFields[yJIRxDo].Selected = false;
yJIRxDo = 3;
QzQTRuy = true;
TextFields[yJIRxDo].Label = "";
TextFields[yJIRxDo].Selected = true;
zDLkfrA = i;
SoftwareButtons[4].Selected = false;
return true;
}
else if (KZdjFXA == true)
{
wLEAfPX = 2;
zDLkfrA = i;
return true;
} 
else if (oMQaBmH == true)
{
oMQaBmH = false;
zDLkfrA = i;
SoftwareButtons[7].Selected = false;  
DuplicateSequence();
return true;
} 
if(i == DIWlYpw) return true; 
MeasureOefqCkP(DIWlYpw);
slBNIJT[DIWlYpw].Highlighted = false;
DrawUserSeqIconBuffer(DIWlYpw); 
slBNIJT[i].Highlighted = true;
DIWlYpw = i;
LoadSequence();
DrawUserSeqIconBuffer(i);	
AppendLogFile("Removed a DrawUserSeqIconBuffer() here");
return true;
}
} 
if (slBNIJT[0].over(5, 5+((slBNIJT.length-1)*80))  && LWAPDwF < 425 && (LMORxyF == 0 || LMORxyF == 1) && device.HardwareID != 0) 
{
AppendLogFile("Attempting to Add Sequence "+slBNIJT.length);
if (slBNIJT.length < 33) 
{
AddSequence();
return true;
}
}
return false;
}
boolean pressHandlerYyryBXy()
{
if (ColorSelector.overPicker())
{
ColorSelector.PickColor();
return true;
}
else if (ColorSelector.over())
{
for (int i =0; i != ColorSelectorSliders.length; i++)
{
if (ColorSelectorSliders[i].over())
{
AppendLogFile("ColorSelectSlider "+i);
ColorSelectorSliders[i].selectSlider();
}
} 
if(TextFields[10].over()) TextFields[10].SelectField(10);
if (ColorSelectorCancel.over())
{
YyryBXy = false;
return true;
}
if (ColorSelectorApply.over())
{
int tempVar = (slBNIJT[DIWlYpw].SeqFrameAmount+1);
YyryBXy = false;
if(TextFields[10].Selected == true)
{
TextFields[10].Selected = false; 
if(!TextFields[10].Label.equals("")) 
{
if(int(TextFields[10].Label) > ColorSelectorSliders[0].Maximum) TextFields[10].Label = ""+ColorSelectorSliders[0].Maximum; 
SliderPointer.Value = int(TextFields[10].Label); 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;
}			
}			
if(GraphicFuncPaintButton.Selected == true)
{
lAAqduc[0] = ColorSelectorSliders[0].Value;
lAAqduc[1] = ColorSelectorSliders[1].Value;
lAAqduc[2] = ColorSelectorSliders[2].Value;
lAAqduc[3] = ColorSelectorSliders[3].Value;
PaintRect.Red = lAAqduc[0];
PaintRect.Green = lAAqduc[1];
PaintRect.Blue = lAAqduc[2];
PaintRect.White = lAAqduc[3];
return true;
}
else if (LMORxyF == 2 && RVeDwhC == 2) 
{
AppendLogFile("LiveConDataType: "+FmxWQSR);
switch(FmxWQSR)
{
case 0: 
ControlSliders[fQlhEcU*QVhoOtU].Value = ColorSelectorSliders[3].Value;
break;
case 1: 
ControlSliders[(fQlhEcU*QVhoOtU)].Value = ColorSelectorSliders[0].Value;
ControlSliders[(fQlhEcU*QVhoOtU)+1].Value = ColorSelectorSliders[1].Value;
ControlSliders[(fQlhEcU*QVhoOtU)+2].Value = ColorSelectorSliders[2].Value;
break;
case 2: 
ControlSliders[(fQlhEcU*QVhoOtU)].Value = ColorSelectorSliders[0].Value;
ControlSliders[(fQlhEcU*QVhoOtU)+1].Value = ColorSelectorSliders[1].Value;
ControlSliders[(fQlhEcU*QVhoOtU)+2].Value = ColorSelectorSliders[2].Value;
ControlSliders[(fQlhEcU*QVhoOtU)+3].Value = ColorSelectorSliders[3].Value;            
break;
}
hkZcTKJ = true;
}				
else if (fQlhEcU >= 10000 || slBNIJT[DIWlYpw].SeqMode == mGradient) 
{
int tempValue = 0;
if(fQlhEcU > 10000)
{
tempValue = fQlhEcU - 10001;
AppendLogFile("Run Apply to Group");
for (int q = 0; q != INyauIU; q++)  
{  
if(LEDIcon[q].GroupID == tempValue)
{
AppendLogFile("LED Icon "+q+" is in group "+tempValue);
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[3].Value;
break;
case 1: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+2] = ColorSelectorSliders[2].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+3] = ColorSelectorSliders[3].Value;
break;
}
}	
} 
}
else
{
AppendLogFile("Run Apply All");
for (int q = 0; q != zQjfRqq; q++)  
{  
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[3].Value;
break;
case 1: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][q * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+2] = ColorSelectorSliders[2].Value;
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(q * MDmgrxQ)+3] = ColorSelectorSliders[3].Value;
break;
}
} 
}
if(slBNIJT[DIWlYpw].SeqMode == mGradient)
{
GradientRects[lXrpjlY].Red = ColorSelectorSliders[0].Value;
GradientRects[lXrpjlY].Green = ColorSelectorSliders[1].Value;
GradientRects[lXrpjlY].Blue = ColorSelectorSliders[2].Value;
GradientRects[lXrpjlY].White = ColorSelectorSliders[3].Value;
}
}
else
{
AppendLogFile("Filling Color Normally");
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ] = ColorSelectorSliders[3].Value;
break;
case 1: 
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ] = ColorSelectorSliders[0].Value;
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+1] = ColorSelectorSliders[1].Value;
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+2] = ColorSelectorSliders[2].Value;
slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+3] = ColorSelectorSliders[3].Value;
break;
}
}
for (int i=0; i != paletteColors.length;i++)
{
if(paletteColors[i][0] == ColorSelectorSliders[0].Value && paletteColors[i][1] == ColorSelectorSliders[1].Value && paletteColors[i][2] == ColorSelectorSliders[2].Value && paletteColors[i][3] == ColorSelectorSliders[3].Value)
{
AppendLogFile("Color already on palette, not added");
break; 
}
if(i == 5)
{
paletteColors[FllyozX][0] = ColorSelectorSliders[0].Value;
paletteColors[FllyozX][1] = ColorSelectorSliders[1].Value;
paletteColors[FllyozX][2] = ColorSelectorSliders[2].Value;
paletteColors[FllyozX][3] = ColorSelectorSliders[3].Value;
FllyozX++;
if(FllyozX == 6) FllyozX = 0;
}
} 
switch(LMORxyF)
{
case 0:
GraphicLayoutBuffer.beginDraw();
try {
for (int q =0; q != INyauIU; q++)  LEDIcon[q].display(); 
}
catch(Exception e) { }
GraphicLayoutBuffer.endDraw();  
if(fQlhEcU == 10000 || slBNIJT[DIWlYpw].SeqMode == mGradient)
{
MenuTabs[1].refresh(); 
}
else UpdateColorChannelBuffer((fQlhEcU / tempVar));
break;
case 1:
if(fQlhEcU == 10000 || slBNIJT[DIWlYpw].SeqMode == mGradient)
{
BuildGradientMenu();
DrawTimeLineBuffer();
}
else UpdateColorChannelBuffer((fQlhEcU / tempVar));
MenuTabs[0].refresh(); 
break;
}
}
}		
else
{	
YyryBXy = false; 
}	
return true;
} 
boolean pressHandlerConfirmBox()
{	
if(EBWUsXC > 0)
{
if(QGxXgDU > 5) EBWUsXC = 0;
return true;
}
if(wLEAfPX > 0) 
{		
if(ConfirmButtonYes.over())
{
AppendLogFile("Pressed Yes on ID#: "+wLEAfPX);
AppendLogFile(cConfirmBoxText[wLEAfPX]);
ConfirmButtonYes.Selected = true;
ConfirmButtonYes.display();
int holdwLEAfPX = wLEAfPX;
wLEAfPX = 0;
switch(holdwLEAfPX)
{
case 0:
break;		
case 1:
RequestFullUpload();	
break;		
case 2: 
KZdjFXA = false;
SoftwareButtons[5].Selected = false;  
DeleteSequence();		
break;		
case 3: 
InitNoSequences();
case 4:
for (int q =0; q != JzvVShV.length; q++) JzvVShV[q] = 255;
YsOnDkT = 1;   
IndexScrollBar.Value = 0;
DrawIndexScrollArea(); 			
break;	
case 5: 
if(device.BasicVersion > 0) 
{
EBWUsXC = 13;
}
else
{
if(device.EvenDataFlag == true && (int(TextFields[11].Label)%2) == 1) TextFields[11].Label = ""+(int(TextFields[11].Label)+1);
ResizeSequences(int(TextFields[11].Label));
yxtcfxi = int(TextFields[11].Label);
if(yxtcfxi > device.Channels)
{
yxtcfxi = device.Channels;
TextFields[11].Label = ""+yxtcfxi;
}
for(int q = 1; q != slBNIJT.length;q++) UpdateSequence(q); 
MenuTabs[1].refresh(); 
MenuTabs[0].refresh();
}				
TextFields[11].Selected = false; 
break;	
case 6: 
break;
case 7: 
KUNEdsh = true;
RequestFullUpload();
break;	
case 8: 
break;
case 9: 
xhPzZot = 140; 
hgwvVkk[0] = 0;
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
break;
case 10: 
break;
case 12:		
if(device.BasicVersion == 2) RequestConfigurationUploadType2();
else RequestConfigurationUpload();
break;			
} 
}
if(ConfirmButtonNo.over())
{
AppendLogFile("Pressed No on");
AppendLogFile(cConfirmBoxText[wLEAfPX]);
ConfirmButtonNo.Selected = true;
ConfirmButtonNo.display();						
switch(wLEAfPX)
{
case 0:
break;
case 1:
break;
case 2:
vLvSrbC = false;
oMQaBmH = false;
SoftwareButtons[4].Selected = false;
SoftwareButtons[7].Selected = false;		  
KZdjFXA = SoftwareButtons[5].Selected;
break;		
case 3:
break;
case 4:
break;
case 5: 
TextFields[11].Label = ""+yxtcfxi;
break;	
case 6: 
break;
case 7: 
slBNIJT[DIWlYpw].Highlighted = false;
DrawUserSeqIconBuffer(DIWlYpw); 
DIWlYpw = hoGoqRP;
slBNIJT[DIWlYpw].Highlighted = true;
DrawUserSeqIconBuffer(DIWlYpw); 
MenuTabs[LMORxyF].Selected = false;  
LMORxyF = 1;
MenuTabs[LMORxyF].Selected = true;
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
LoadSequence();
break;		
case 8: 
break;
case 9: 
break;
}	
wLEAfPX = 0;
}
return true;
}
return false;
}
void SetlXrpjlY(int passedID)
{
try {
TimeLineFrameButtons[lXrpjlY].Selected = false;
}
catch(Exception e) { }
FrameButtons[lXrpjlY].Selected = false;
lXrpjlY = passedID;
try {
TimeLineFrameButtons[lXrpjlY].Selected = true;
}
catch(Exception e) { }
FrameButtons[lXrpjlY].Selected = true;
}
void CheckStartVals(int passedSequence)
{
int tempFrameVar = 0;
int RStart = 0;
int GStart = 0;
int BStart = 0;
int WStart = 0;
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0;
for (int i = 0; i != zQjfRqq; i++)
{
if (slBNIJT[passedSequence].SeqMode != mInstant)
{
switch(fYArHTo)
{
case 2: 
WStart = slBNIJT[passedSequence].StartValues[(i*MDmgrxQ)+3]; 
case 1: 
RStart = slBNIJT[passedSequence].StartValues[(i*MDmgrxQ)];
GStart = slBNIJT[passedSequence].StartValues[(i*MDmgrxQ)+1];
BStart = slBNIJT[passedSequence].StartValues[(i*MDmgrxQ)+2];
break;
case 0: 
WStart = slBNIJT[passedSequence].StartValues[(i*MDmgrxQ)]; 
break;	
}	
tempFrameVar = slBNIJT[passedSequence].SpecialFrameVar[(i*MDmgrxQ)];
switch(fYArHTo)
{
case 2: 
CurrentStartW = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+3];
case 1: 
CurrentStartR = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)];
CurrentStartG = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+1];
CurrentStartB = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+2];
break;
case 0: 
CurrentStartW = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)];
break;	
}	  	  
if (tempFrameVar < slBNIJT[passedSequence].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(fYArHTo)
{
case 2: 
CurrentEndW = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+3];
case 1: 
CurrentEndR = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)];
CurrentEndG = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+1]; 
CurrentEndB = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)+2];
break;
case 0: 
CurrentEndW = slBNIJT[passedSequence].DataFrames[tempFrameVar][(i*MDmgrxQ)];
break;	
}	 	  
tempFrameVar = slBNIJT[passedSequence].SpecialFrameVar[(i*MDmgrxQ)];
switch(fYArHTo)
{
case 0: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) slBNIJT[passedSequence].StartValError = true;
break;	
case 2: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) slBNIJT[passedSequence].StartValError = true;
case 1: 
if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) slBNIJT[passedSequence].StartValError = true;
if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) slBNIJT[passedSequence].StartValError = true;
if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) slBNIJT[passedSequence].StartValError = true;
break;
}					
}
} 
} 
void AddSequence()
{
slBNIJT = (UserSequenceObj[]) expand(slBNIJT, slBNIJT.length+1);
AppendLogFile("AddSequence() - Length is now "+slBNIJT.length);
slBNIJT[slBNIJT.length-1] = slBNIJT[slBNIJT.length-1] = new UserSequenceObj("User Added "+(slBNIJT.length-1), (slBNIJT.length-1), 0, 1, 1, 1, 0, mFade, 1, HoldChanSz, HoldChanSz, HoldChanSz, HoldFullSz, HoldFullSz, HoldFullSz, HoldDataFrames, false); 
slBNIJT[slBNIJT.length-1].DataFrameVar = new int[device.Channels];
slBNIJT[slBNIJT.length-1].StartValues = new int[device.Channels];
slBNIJT[slBNIJT.length-1].SpecialFrameVar = new int[device.Channels];
slBNIJT[slBNIJT.length-1].FrameSpecial = new int[cSoftwareMaxFrames]; 
slBNIJT[slBNIJT.length-1].SlideValues = new int[cSoftwareMaxFrames]; 
slBNIJT[slBNIJT.length-1].SpeedValues = new int[cSoftwareMaxFrames];
slBNIJT[slBNIJT.length-1].DataFrames = new int[cSoftwareMaxFrames][device.Channels];   
slBNIJT[slBNIJT.length-1].DataSize = yxtcfxi;
slBNIJT[slBNIJT.length-1].SeqMode = mFade;
slBNIJT[DIWlYpw].Highlighted = false;
DIWlYpw = (slBNIJT.length-1);
FrameButtons[lXrpjlY].Selected = false;
lXrpjlY = 0;
FrameButtons[lXrpjlY].Selected = true;
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 10;
slBNIJT[DIWlYpw].Highlighted = true;
UpdateSequence(DIWlYpw);
CommonButtonsState(5); 
TextFields[12].Label = "1"; 
DrawUserSeqIconBuffer(9999); 
} 
void MeasureOefqCkP(int SelSeq)
{
if(device.BasicVersion > 0)
{
if(slBNIJT[SelSeq].SeqMode == mLinked)
{
slBNIJT[SelSeq].Length = 0;
return;
}
slBNIJT[SelSeq].Length = ((slBNIJT[SelSeq].SeqFrameAmount+1) * device.Channels);
return;
}
int SeqLength = 10; 
int tempDataSize = slBNIJT[SelSeq].DataSize;
int tempDataSizeDbl = slBNIJT[SelSeq].DataSize*2; 
int tempSeqFrameAmt = slBNIJT[SelSeq].SeqFrameAmount+1;
int tempSeqFrameAmtDbl = (slBNIJT[SelSeq].SeqFrameAmount+1)*2;
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mPOV)
{
CalculateDataFrameAmt(SelSeq);
}
if(slBNIJT[SelSeq].SeqMode == mLinked)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}	
}
else 
{
if(device.Bit16Capable) SeqLength += tempDataSizeDbl;
else SeqLength+=tempDataSize; 
SeqLength += tempDataSize; 	
SeqLength += tempDataSize; 	
if(device.Bit16Capable || device.Bit16Processor)  SeqLength += tempSeqFrameAmtDbl;
else SeqLength += tempSeqFrameAmt; 
if(slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo) 
{
if(device.Bit16Capable || device.Bit16Processor)  SeqLength += tempSeqFrameAmtDbl;
else SeqLength += tempSeqFrameAmt; 
}
if (slBNIJT[SelSeq].SeqMode == mCombo) 
{
if(device.Bit16Capable || device.Bit16Processor)  SeqLength += tempSeqFrameAmtDbl;
else SeqLength += tempSeqFrameAmt; 
}	
if (slBNIJT[SelSeq].SeqMode == mGradient)
{
if(device.Bit16Capable) SeqLength += (tempSeqFrameAmt*8);
else SeqLength += (tempSeqFrameAmt*4); 			
}
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 30 ) 
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
if(device.Bit16Capable) SeqLength += 2;
else SeqLength++;
}
} 
}
}
else
{
if(device.Bit16Capable) SeqLength += (tempSeqFrameAmt*tempDataSizeDbl);
else SeqLength += (tempSeqFrameAmt*tempDataSize); 
}	
} 
slBNIJT[SelSeq].Length = SeqLength; 
AppendLogFile("MeasureSequenceLength() with "+SelSeq+"   Result: "+SeqLength);
} 
void ResizeSequences(int NewUsrChnAmt)
{
AppendLogFile("ResizeSequences()");	
if(yxtcfxi < NewUsrChnAmt)
{	
for (int i = 1; i != slBNIJT.length; i++)
{
slBNIJT[i].DataFrameVar = expand(slBNIJT[i].DataFrameVar, NewUsrChnAmt);
slBNIJT[i].StartValues = expand(slBNIJT[i].StartValues, NewUsrChnAmt);
slBNIJT[i].SpecialFrameVar = expand(slBNIJT[i].SpecialFrameVar, NewUsrChnAmt);
slBNIJT[i].FrameSpecial = expand(slBNIJT[i].FrameSpecial, NewUsrChnAmt);
slBNIJT[i].SlideValues = expand(slBNIJT[i].SlideValues, NewUsrChnAmt);
slBNIJT[i].SpeedValues = expand(slBNIJT[i].SpeedValues, NewUsrChnAmt);
slBNIJT[i].DataFrames = (int[][])expand(slBNIJT[i].DataFrames, NewUsrChnAmt);
}
}
else
{
}
yxtcfxi = NewUsrChnAmt;
DrawUserSeqIconBuffer(9999); 
} 
void InitNoSequences()
{
slBNIJT = new UserSequenceObj[1];
for (int i =0; i != slBNIJT.length; i++)
{
slBNIJT[i] = new UserSequenceObj("EMPTY", i, 0, 0, 0, 1, cSoftwareMaxChans, 1, 1, HoldChanSz, HoldChanSz, HoldChanSz, HoldFullSz, HoldFullSz, HoldChanSz, HoldDataFrames, false);
slBNIJT[i].DataFrameVar = new int[cSoftwareMaxChans];
slBNIJT[i].StartValues = new int[cSoftwareMaxChans];
slBNIJT[i].SpecialFrameVar = new int[cSoftwareMaxChans];
slBNIJT[i].FrameSpecial = new int[cSoftwareMaxFrames]; 
slBNIJT[i].SlideValues = new int[cSoftwareMaxFrames]; 
slBNIJT[i].SpeedValues = new int[cSoftwareMaxFrames];
slBNIJT[i].DataFrames = new int[cSoftwareMaxFrames][cSoftwareMaxChans];     
} 
DIWlYpw = 0;
for (int i =0; i != JzvVShV.length; i++) JzvVShV[i] = 255; 
SequenceScrollBar.Value = 0;	
DrawUserSeqIconBuffer(9999);
FillFrameSpecial(slBNIJT[0].FrameSpecial); 
} 
void DuplicateSequence()
{
AppendLogFile("DuplicateSequence() "+zDLkfrA+" : "+slBNIJT.length);
slBNIJT = (UserSequenceObj[]) expand(slBNIJT, slBNIJT.length+1);
slBNIJT[slBNIJT.length-1] = new UserSequenceObj("User Added "+(slBNIJT.length-1), (slBNIJT.length-1), 0, 0, 0, 0, slBNIJT[zDLkfrA].DataSize, 0, 0, HoldChanSz, HoldChanSz, HoldChanSz, HoldFullSz, HoldFullSz, HoldFullSz, HoldDataFrames, false); 
slBNIJT[slBNIJT.length-1].DataFrameVar = new int[device.Channels];
slBNIJT[slBNIJT.length-1].StartValues = new int[device.Channels];
slBNIJT[slBNIJT.length-1].SpecialFrameVar = new int[device.Channels];
slBNIJT[slBNIJT.length-1].FrameSpecial = new int[cSoftwareMaxFrames]; 
slBNIJT[slBNIJT.length-1].SlideValues = new int[cSoftwareMaxFrames]; 
slBNIJT[slBNIJT.length-1].SpeedValues = new int[cSoftwareMaxFrames];
slBNIJT[slBNIJT.length-1].DataFrames = new int[cSoftwareMaxFrames][device.Channels];   
for(int i = 0; i != yxtcfxi; i++) 
{
slBNIJT[slBNIJT.length-1].DataFrameVar[i] = slBNIJT[zDLkfrA].DataFrameVar[i];
slBNIJT[slBNIJT.length-1].StartValues[i] = slBNIJT[zDLkfrA].StartValues[i];
slBNIJT[slBNIJT.length-1].SpecialFrameVar[i] = slBNIJT[zDLkfrA].SpecialFrameVar[i];  
}
for(int i = 0; i != cSoftwareMaxFrames; i++)
{
slBNIJT[slBNIJT.length-1].FrameSpecial[i] = slBNIJT[zDLkfrA].FrameSpecial[i];
slBNIJT[slBNIJT.length-1].SlideValues[i] = slBNIJT[zDLkfrA].SlideValues[i];
slBNIJT[slBNIJT.length-1].SpeedValues[i] = slBNIJT[zDLkfrA].SpeedValues[i];
for(int q = 0; q != yxtcfxi; q++)
{
slBNIJT[slBNIJT.length-1].DataFrames[i][q] = slBNIJT[zDLkfrA].DataFrames[i][q];
}
}
slBNIJT[slBNIJT.length-1].UserID = slBNIJT[zDLkfrA].UserID;
slBNIJT[slBNIJT.length-1].IndexNum = slBNIJT[zDLkfrA].IndexNum;
slBNIJT[slBNIJT.length-1].Length = slBNIJT[zDLkfrA].Length;
slBNIJT[slBNIJT.length-1].SeqFrameAmount = slBNIJT[zDLkfrA].SeqFrameAmount;
slBNIJT[slBNIJT.length-1].DataFrameAmount = slBNIJT[zDLkfrA].DataFrameAmount;
slBNIJT[slBNIJT.length-1].Speed = slBNIJT[zDLkfrA].Speed;
slBNIJT[slBNIJT.length-1].DataSize = slBNIJT[zDLkfrA].DataSize;
slBNIJT[slBNIJT.length-1].SeqMode = slBNIJT[zDLkfrA].SeqMode;
slBNIJT[slBNIJT.length-1].DataType = slBNIJT[zDLkfrA].DataType;
slBNIJT[slBNIJT.length-1].gradientSteps = slBNIJT[zDLkfrA].gradientSteps;
slBNIJT[slBNIJT.length-1].molKaUt = slBNIJT[zDLkfrA].molKaUt;
slBNIJT[slBNIJT.length-1].POVUsageMode = slBNIJT[zDLkfrA].POVUsageMode;
DrawUserSeqIconBuffer(9999);	  
} 
void DeleteSequence()
{
AppendLogFile("DeleteSequence() "+zDLkfrA+" : "+slBNIJT.length);
if (zDLkfrA == 0 && slBNIJT.length < 2) return;
for (int i = zDLkfrA; i < slBNIJT.length; i++) 
{
try 
{
slBNIJT[i] = slBNIJT[i+1];
}
catch(Exception e) {
AppendLogFile("Exception attempting to shift sequence objects down");
}
} 
for (int q = 0; q != 32; q++) 
{
if(JzvVShV[q] == zDLkfrA) 
{
JzvVShV[q] = 255;
for (int i = q; i != 31; i++) 
{
JzvVShV[i] = JzvVShV[i+1]; 
}
}		
}
for (int q = 0; q != 32; q++) 
{	
if(JzvVShV[q] < 233 && JzvVShV[q] > zDLkfrA)
{
AppendLogFile("IndexMapArray: "+JzvVShV[q]);
JzvVShV[q]--;
}		
} 
slBNIJT[DIWlYpw].Highlighted = false;
slBNIJT = (UserSequenceObj[])shorten(slBNIJT);
for (int i = 0; i != slBNIJT.length; i++) slBNIJT[i].IndexNum = i;
DIWlYpw = 1;
slBNIJT[DIWlYpw].Highlighted = true;
DrawUserSeqIconBuffer(9999); 
DrawUserSeqIconBuffer(DIWlYpw);
LoadSequence();
DrawIndexScrollArea();
} 
void UpdateSequence(int passedID)
{
AppendLogFile("UpdateSequence() "+passedID);
MDmgrxQ = 1; 
if (slBNIJT[passedID].DataType == 1) MDmgrxQ  = 3;
else if (slBNIJT[passedID].DataType == 2) MDmgrxQ  =  4;  
SeqCheckBoxes[0].Selected = false; 
SeqCheckBoxes[1].Selected = false; 
SeqCheckBoxes[2].Selected = false; 
SeqCheckBoxes[slBNIJT[passedID].DataType].Selected = true; 
fYArHTo = slBNIJT[passedID].DataType;
slBNIJT[passedID].DataSize = yxtcfxi;
if (slBNIJT[passedID].DataType == 0) zQjfRqq = slBNIJT[passedID].DataSize;
else zQjfRqq = slBNIJT[passedID].DataSize / MDmgrxQ;
TimeLineBuffer = createGraphics(570, (zQjfRqq*cTLChBufH)+5);
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
MenuTabs[2].refresh(); 
GradientStepsSlider.Minimum = 1;
if(slBNIJT[passedID].molKaUt > 3) slBNIJT[passedID].molKaUt = 0;
for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].Selected = false;
POVOptionButtons[slBNIJT[passedID].molKaUt].Selected = true; 
if(slBNIJT[passedID].gradientSteps > zQjfRqq) slBNIJT[passedID].gradientSteps = zQjfRqq;
if(slBNIJT[passedID].gradientSteps == 0) slBNIJT[passedID].gradientSteps = zQjfRqq;
GradientStepsSlider.Value = slBNIJT[passedID].gradientSteps; 
if (slBNIJT[passedID].SeqMode == mLinked) 
{
LinkedScrollBar.Maximum = (slBNIJT[passedID].SeqFrameAmount*100) - 470;
if(LinkedScrollBar.Maximum < 0) LinkedScrollBar.Maximum = 0;
LinkedScrollBar.Value = 0;
}
else
{
TimeLineScrollBar.Maximum = (zQjfRqq*cTLChBufH) - 410; 
TimeLineScrollBar.Value = 0;
}	
MeasureOefqCkP(passedID);
DrawUserSeqIconBuffer(passedID);
} 
void LoadSequence()
{
AppendLogFile("LoadSequence() "+DIWlYpw);
FrameButtons[lXrpjlY].Selected = false;
lXrpjlY = 0;
FrameButtons[lXrpjlY].Selected = true;
SequenceSpeedSlider.Value = slBNIJT[DIWlYpw].Speed;
TextFields[12].Label = ""+slBNIJT[DIWlYpw].Speed;
UpdateSequence(DIWlYpw);
if (slBNIJT[DIWlYpw].SeqMode != 0)CommonButtonsState(4+slBNIJT[DIWlYpw].SeqMode);
FillFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial); 
AeQGRRm = 0; 
if(slBNIJT[DIWlYpw].SeqMode == mGradient)  BuildGradientMenu();
if(slBNIJT[DIWlYpw].SeqMode == mPOV)
{
AppendLogFile("LoadSeq: "+(slBNIJT[DIWlYpw].DataSize / MDmgrxQ)+" : "+slBNIJT[DIWlYpw].DataFrameAmount);
POVModeDD.SelStr = slBNIJT[DIWlYpw].POVUsageMode;
}	
} 
void GenerateGradient()
{
AppendLogFile("GenerateGradient()");  
float LocationVar = (256 * (slBNIJT[DIWlYpw].SeqFrameAmount+1)); 
float StepFactorH = LocationVar  / (float)GradientStepsSlider.Value;
int FrameVarCurrent = 0; 
int FrameVarNext = 1; 
float StepFactor = 0; 
AppendLogFile("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH); 
LocationVar = 0;
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].StartValues[0] = slBNIJT[DIWlYpw].DataFrames[0][0];
break;  
case 1:
slBNIJT[DIWlYpw].StartValues[0] = slBNIJT[DIWlYpw].DataFrames[0][0];
slBNIJT[DIWlYpw].StartValues[1] = slBNIJT[DIWlYpw].DataFrames[0][1];
slBNIJT[DIWlYpw].StartValues[2] = slBNIJT[DIWlYpw].DataFrames[0][2];
break;
case 2: 
slBNIJT[DIWlYpw].StartValues[0] = slBNIJT[DIWlYpw].DataFrames[0][0];
slBNIJT[DIWlYpw].StartValues[1] = slBNIJT[DIWlYpw].DataFrames[0][1];
slBNIJT[DIWlYpw].StartValues[2] = slBNIJT[DIWlYpw].DataFrames[0][2];
slBNIJT[DIWlYpw].StartValues[3] = slBNIJT[DIWlYpw].DataFrames[0][3];
break;
}
/*
c1(current) - c2(next) = 155(difference) * StepFactor + c1
100 - 255 = 155 * 0.5 = 77 + 100 = 177
Fucking Simple................  
*/
int HoldCurrent=0;
int HoldNext=0;
for (int i=MDmgrxQ; i != slBNIJT[DIWlYpw].DataSize; i++) 
{
if ((i%MDmgrxQ) == 0)
{
LocationVar+= StepFactorH; 
if (LocationVar > 255)
{
LocationVar -= 256;    
if (FrameVarNext == (slBNIJT[DIWlYpw].SeqFrameAmount))
{
FrameVarNext = 0; 
FrameVarCurrent = (slBNIJT[DIWlYpw].SeqFrameAmount);
}
else
{
FrameVarNext++;
FrameVarCurrent++;	
if(FrameVarCurrent > slBNIJT[DIWlYpw].SeqFrameAmount) FrameVarCurrent = 0;
}
} 
}
StepFactor = (float)LocationVar / 256; 
HoldCurrent = slBNIJT[DIWlYpw].DataFrames[FrameVarCurrent][i];
HoldNext = slBNIJT[DIWlYpw].DataFrames[FrameVarNext][i];
if (HoldCurrent == HoldNext) 
{ 
slBNIJT[DIWlYpw].StartValues[i] = HoldCurrent;
}  
else if (HoldCurrent < HoldNext)  
{
slBNIJT[DIWlYpw].StartValues[i] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
}
else
{
slBNIJT[DIWlYpw].StartValues[i] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
}
slBNIJT[DIWlYpw].SpecialFrameVar[i] = FrameVarCurrent;
slBNIJT[DIWlYpw].DataFrameVar[i] = FrameVarCurrent;
} 
if(GradientReverse.Selected == true)
{
int x =0;
arrayCopy(slBNIJT[DIWlYpw].SpecialFrameVar, HoldChanSz, slBNIJT[DIWlYpw].DataSize);
x = slBNIJT[DIWlYpw].DataSize -1;
for(int i = 0; i != slBNIJT[DIWlYpw].DataSize; i++)
{
slBNIJT[DIWlYpw].SpecialFrameVar[i] = HoldChanSz[x];
x--;
}	
arrayCopy(slBNIJT[DIWlYpw].DataFrameVar, HoldChanSz, slBNIJT[DIWlYpw].DataSize);
x = slBNIJT[DIWlYpw].DataSize -1;
for(int i = 0; i != slBNIJT[DIWlYpw].DataSize; i++) 
{
slBNIJT[DIWlYpw].DataFrameVar[i] = HoldChanSz[x];
x--;
}	 
switch(fYArHTo)
{
case 0: 
arrayCopy(slBNIJT[DIWlYpw].StartValues, HoldChanSz, slBNIJT[DIWlYpw].DataSize);
x = slBNIJT[DIWlYpw].DataSize; 
for(int i = 0; i != slBNIJT[DIWlYpw].DataSize; i++) 
{
slBNIJT[DIWlYpw].StartValues[i] = HoldChanSz[x];
x--;									
} 
break;  
case 1:
arrayCopy(slBNIJT[DIWlYpw].StartValues, HoldChanSz, slBNIJT[DIWlYpw].DataSize);
x = slBNIJT[DIWlYpw].DataSize - 3;
for(int i = 0; i != slBNIJT[DIWlYpw].DataSize; i++) 
{ 
if(i%3 == 0 && i != 0) x = (slBNIJT[DIWlYpw].DataSize - ((i/3)*3)-3);
slBNIJT[DIWlYpw].StartValues[i] = HoldChanSz[x];
x++;													
} 
break;
case 2: 
break;
} 
} 
MenuTabs[1].refresh(); 
}  
void mousePressed()
{
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);
if(pressHandlerConfirmBox() == true) return;
if (mouseButton == RIGHT)
{
pressHandlerRightClick(); 
return;
} 
if (VvhyvBZ == true || OcNYMio == true || deIRAFp == true) pressHandlerDraggingIcon();
if (YyryBXy == true) 
{
if(pressHandlerYyryBXy() == true) return; 
}
if(pressHandlerSeqIcons() == true) return; 
if(DeviceConnect.over()) 
{
if(DeviceConnect.Selected == true) OpenConnection(); 
else InitCOMButtons();	
}
if(yAtBugw == true) {
if(pressHandlerGraphicTools() == true) return;
}
else {
if(pressHandlerFrameOptions() == true) return; 
}
if(pressHandlerMenuTabs() == true) return; 
if (SequenceScrollBar.over())  {SequenceScrollBar.selectSlider(); return;}	
switch(LMORxyF) 
{
case 0: 
if(pressHandlerSeqOptions() == true) return; 
if(GraphicLayoutExpandOpt.over()) 		
{
if(yAtBugw == true)
{	
GraphicLayoutExpandOpt.Label = ">"; 
yAtBugw = false;
EnableGroupMode.Selected = false;
tVJyYzv = 0;
GradientDrawRadialButton.Selected = false; 
GradientDrawLinearButton.Selected = false; 
GraphicFuncPaintButton.Selected = false;			
}
else 
{
GraphicLayoutExpandOpt.Label = "<";
yAtBugw = true;
}
return;	
}		
if(tVJyYzv > 0) 
{
if(yrsmlGD >= 85 && yrsmlGD <= (85+570) && LWAPDwF >= 35 && LWAPDwF <= (35+475)) 
{      	
if(jgMnfDa == false) 
{
jBfTygi = yrsmlGD; 
gSPmmNm = LWAPDwF;
jgMnfDa = true;
}
else
{
jgMnfDa = false;
KqDBNTS = yrsmlGD; 
XYfpIvO = LWAPDwF;
if(tVJyYzv == 1)GenerateRadialGradient();
else if(tVJyYzv == 2)GenerateLinearGradient();
}
return; 
} 
} 
if(PDBLtrJ != 3 && PDBLtrJ != 6 &&  tVJyYzv == 0)
{
for (int i =0; i != INyauIU; i++)
{
try {
if (LEDIcon[i].over())
{
AppendLogFile("LEDIcon Pressed: "+i);
if(EnableGroupMode.Selected == true && yAtBugw == true)
{
AppendLogFile("Attempting to assign Group ID");	
LEDIcon[i].GroupID = ZtOnJEO;
LEDIcon[i].displayGroup();
}	
else if(GraphicFuncPaintButton.Selected == true)
{
AppendLogFile("Painting from Value");
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i] = lAAqduc[3];
break;
case 1: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ] = lAAqduc[0];
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ+1] = lAAqduc[1];
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ+2] = lAAqduc[2];
break;
case 2: 
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ] = lAAqduc[0];
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ+1] = lAAqduc[1];
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ+2] = lAAqduc[2];
slBNIJT[DIWlYpw].DataFrames[lXrpjlY][i * MDmgrxQ+3] = lAAqduc[3];
break;
}
LEDIcon[i].display();			
MenuTabs[1].refresh();	
}
else
{
YyryBXy = true;  
fQlhEcU = lXrpjlY+(LEDIcon[i].ChanID*(slBNIJT[DIWlYpw].SeqFrameAmount+1));
UDMnaMJ = LEDIcon[i].ChanID;
ColorSelector.InitPosition();
}
return;
} 
}
catch(Exception e)
{
AppendLogFile("Error at: "+i+"  Total Length: "+INyauIU);
if(jgvztaS == 6)
{	
AppendLogFile("Building Icon with ID#: "+(i%zQjfRqq)+" : "+zQjfRqq);
if(yrsmlGD < 90 || yrsmlGD > 650 || LWAPDwF < 40 || LWAPDwF > 505) break;
if(GraphicFuncPaintButton.over() || GraphicLayoutExpandOpt.over() || GraphicLayoutAllSame.over() || GraphicLayoutColorGroup.over() || EnableGroupMode.over()) break;
CalcIMwZLgR();
LEDIcon[i] = new LEDgraphic(i%zQjfRqq, yrsmlGD-(80+5), LWAPDwF-(30+5), IMwZLgR, color(255));
IBzMEJI[i] = LEDIcon[i].xpos;
zppAzXD[i] = LEDIcon[i].ypos;
AppendLogFile(LEDIcon.length+" : "+tDYkOHG.length);
LEDIcon[i].GroupID = tDYkOHG[i];
LEDIcon[i].display();  	
} 
break;		
} 
} 
} 
break;
case 1: 
if(pressHandlerSeqOptions() == true) return; 
if(StartValReset.over() && TimeLineBuffer != null)
{
ResetStartValuesCommon(DIWlYpw);
EBWUsXC = 2; 
TimeLineBuffer.beginDraw();		
for(BKYieeA = 0; BKYieeA != zQjfRqq;BKYieeA++)
{
TimeLineBuffer.fill(cBackgroundColor); 
TimeLineBuffer.rect(TLStartIndicators[BKYieeA].xpos-(TLStartIndicators[BKYieeA].bSize)-1, TLStartIndicators[BKYieeA].ypos-2, (float)(TLStartIndicators[BKYieeA].bSize*2.25), (float)(TLStartIndicators[BKYieeA].bSize*1.35));
TLStartIndicators[BKYieeA].xpos = 35;
TLStartIndicators[BKYieeA].ColBG = color(cColButtonsHL);
if(slBNIJT[DIWlYpw].SeqMode == mGradient) TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(BKYieeA*cTLChBufH), 500, cTLGraphBufH);
else TimeLineBuffer.image(PreviewBuffer[BKYieeA], 35, 5+(BKYieeA*cTLChBufH), 500, cTLGraphBufH);
TimeLineLabelButtons[BKYieeA].display();
TLStartIndicators[BKYieeA].display();
}
TimeLineBuffer.endDraw();	
MenuTabs[0].refresh();	
return;
} 
if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
if (LinkedScrollBar.over())	LinkedScrollBar.selectSlider();
for (int i =0; i != slBNIJT[DIWlYpw].SeqFrameAmount; i++)
{
if (yrsmlGD >= (60+85) && yrsmlGD <= (60+85+110) && LWAPDwF >= 35+((15+(i*100))-LinkedScrollBar.Value) &&  LWAPDwF <= (35+70)+((15+(i*100))-LinkedScrollBar.Value))     
{
AppendLogFile("Clicked the thing! "+i+" : "+slBNIJT[DIWlYpw].SeqFrameAmount);
QFfuPVT = true;
KqHwDQs = i;
return;
}
}
try 
{
for (int i =0; i != LinkedSliders.length; i++)
{     
if (LinkedSliders[i].overLinked())
{
AppendLogFile("Over LinkedSlider: "+i);        
LinkedSliders[i].selectSlider(); 
SetlXrpjlY(i);
return;
}
}
}
catch(Exception e) {  }
try 
{
for (int i =0; i != LinkedCheckBox.length; i++)
{     
if (LinkedCheckBox[i].overLinked())
{
AppendLogFile("Over Linked Check Box: "+i+" : "+(i%2));
if((i%2) == 0) 
{
LinkedCheckBox[i].Selected = true;
LinkedCheckBox[i+1].Selected = false;      
LinkedCheckBox[i+1].displayLinked(); 
slBNIJT[DIWlYpw].SpecialFrameVar[ceil(i/2)]= 0;
}
else
{
AppendLogFile("Elsed");
LinkedCheckBox[i].Selected = true;
LinkedCheckBox[i-1].Selected = false;     
LinkedCheckBox[i-1].displayLinked();
slBNIJT[DIWlYpw].SpecialFrameVar[ceil(i/2)]= 1;
}
LinkedCheckBox[i].displayLinked();
AppendLogFile("Saved as: "+slBNIJT[DIWlYpw].SpecialFrameVar[ceil(i/2)]+" to "+(i/2));
return;
}
}
}
catch(Exception e) {  }     
try 
{
for (int i =0; i != LinkedIterationFields.length; i++)
{     
if (LinkedIterationFields[i].overLinked())
{
AppendLogFile("Over Linked Iteration TextField: "+i);
LinkedIterationFields[i].QFfuPVTField(i);
LinkedScrollBuffer.beginDraw();
LinkedIterationFields[i].displayLinked();
LinkedScrollBuffer.endDraw();
return;
}
}
}
catch(Exception e) {  AppendLogFile("Eception Selecting Iteration Textfield"); }  			
}
else if(slBNIJT[DIWlYpw].SeqMode == mPOV) 
{	
if (POVModeDD.over())
{
POVModeDD.selectDD();
AppendLogFile("Pressed POVModeDD DropDown Open");
return;
}
else if (POVModeDD.overOpen() != 0 && POVModeDD.Selected == true)
{
AppendLogFile("Pressed POVModeDD DropDown "+POVModeDD.overOpen() );
POVModeDD.Selected = false;
POVModeDD.SelStr = (POVModeDD.overOpen()-1);				
slBNIJT[DIWlYpw].POVUsageMode = POVModeDD.SelStr;
return;
}    		
if(POVModeButton.over())
{
AppendLogFile("Pressed Open Image File Button");
zJypjQP = 4; 
selectInput("Select an image file to load:", "fileSelected");	
}
for (int i =0; i != POVOptionButtons.length; i++)
{
if(POVOptionButtons[i].over())
{
POVOptionButtons[slBNIJT[DIWlYpw].molKaUt].Selected = false;
slBNIJT[DIWlYpw].molKaUt = i;
POVOptionButtons[slBNIJT[DIWlYpw].molKaUt].Selected = true;
slBNIJT[DIWlYpw].molKaUt = i;
AppendLogFile("============"+POVGraphicBuffer.width+" : "+POVGraphicBuffer.height);
LoadPOVFile(POVGraphicBuffer);
}
}
} 
else if (TimeLineScrollBar.over() && LMORxyF == 1 && YyryBXy == false) 
{
TimeLineScrollBar.selectSlider();
}   
try {
if(slBNIJT[DIWlYpw].SeqMode != mPOV && slBNIJT[DIWlYpw].SeqMode != mLinked)
{	
if(yrsmlGD >= cTLChBufX && yrsmlGD <= (cTLChBufX+570) && LWAPDwF >= (cTLChBufY-40) && LWAPDwF <= ((cTLChBufY-40)+475))
{	
for (int i =0; i != TLStartIndicators.length; i++)
{
if (TLStartIndicators[i].over() && LWAPDwF < 510)   
{
AppendLogFile("Indicator: "+i);
uJwNffD = true;
BKYieeA = i;
return;
}
}
for (int i =0; i != TimeLineFrameButtons.length; i++) 
{
if(TimeLineFrameButtons[i].over())
{
AppendLogFile("TimeLineFrameButtons: "+i);
SetlXrpjlY(i);
return;
}
}
for (int i =0; i != zQjfRqq; i++) 
{
for (int q =0; q != (slBNIJT[DIWlYpw].SeqFrameAmount+1); q++) 
{	
if(yrsmlGD >= cTLChBufX+35+(q*LodQDil) && yrsmlGD <= cTLChBufX+35+((q+1)*LodQDil))
{
if(LWAPDwF >= (cTLChBufY+(i*cTLChBufH))-AeQGRRm && LWAPDwF <= (cTLChBufY+((i+1)*cTLChBufH))-AeQGRRm && LWAPDwF < 515)
{				
AppendLogFile("Selected Cell, Frame: "+q+"   ColorChannel: "+i);
SetlXrpjlY(q);
fQlhEcU = (i*(slBNIJT[DIWlYpw].SeqFrameAmount+1))+lXrpjlY;
UDMnaMJ = i;
YyryBXy = true;
ColorSelector.InitPosition();	
return;					
}
}
} 
}
}
}	
} 
catch(Exception e) 
{ 
AppendLogFile("Exception, buttons not yet created");
}   
try {
if(slBNIJT[DIWlYpw].SeqMode != mPOV && slBNIJT[DIWlYpw].SeqMode != mLinked)
{	
for (int i =0; i != TimeLineLabelButtons.length; i++)
{
if(TimeLineLabelButtons[i].over())
{
AppendLogFile("Clicked TimeLineLabelButtons "+i);
fQlhEcU = (i*(slBNIJT[DIWlYpw].SeqFrameAmount+1))+lXrpjlY;
UDMnaMJ = i;
YyryBXy = true;
ColorSelector.InitPosition();		
return;
}
}
}
}
catch(Exception e) 
{ 
AppendLogFile("Exception, TL Label buttons not yet created");
} 
if (slBNIJT[DIWlYpw].SeqMode == mGradient)
{
if (GradientStepsSlider.over()) { GradientStepsSlider.selectSlider(); return; }
if(GradientForward.over())
{
GradientForward.Selected = true;
GradientReverse.Selected = false;
return;
}
if(GradientReverse.over())
{
GradientForward.Selected = false;
GradientReverse.Selected = true;
return;
}
if (GradientGenerate.over())
{
AppendLogFile("Generate Offset");
GradientGenerate.Selected = true;
GradientGenerate.display(); 
GenerateGradient();
return;
}
for (int i =0; i != slBNIJT[DIWlYpw].SeqFrameAmount+1; i++) 
{
try {
if (GradientRects[i].over())
{
AppendLogFile("Pressed Rect: "+i);
SetlXrpjlY(i);
MenuTabs[0].refresh(); 
		
YyryBXy = true;  
fQlhEcU = 10000;
ColorSelector.InitPosition();
return;
}
}
catch(Exception e) {
}
}
}
break;
case 2: 
switch(RVeDwhC)
{
case 1: 
case 2: 
if (LiveControlToggle.over())
{
AppendLogFile("Pressed");
if(RVeDwhC == 1) 
{
RVeDwhC = 2; 
if(device.Bit16Capable == false)	LiveControlCheckBox[3].Selected = false; 
else LiveControlCheckBox[3].Selected = true;
xhPzZot = 60; 
hgwvVkk[0] = 1; 
if(device.Bit16Capable == true) hgwvVkk[1] = 1; 
else hgwvVkk[1] = 0; 
hgwvVkk[2] = (yxtcfxi >> 8) & 0xFF;  
hgwvVkk[3] = yxtcfxi & 0xFF;  
RequestCommand();  
}
else RVeDwhC = 1;
LiveControlToggle.Selected = true;
LiveControlToggle.display();
} 
if (LiveControlClose.over()) 
{
LiveControlClose.Selected = true;
LiveControlClose.display();
RVeDwhC = 0;
xhPzZot = 60; 
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
}       
break;    
}
switch(RVeDwhC)
{
case 0: 
if (IndexScrollBar.over())  IndexScrollBar.selectSlider();
for (int i =0; i != ConnectionButtons.length; i++)
{
if (ConnectionButtons[i].over() && device.HardwareID != 0)
{
if(device.BasicVersion > 0 && i == 4) return; 
ConnectionButtons[i].Selected =! ConnectionButtons[i].Selected;
switch(i)
{
case 0: 
wLEAfPX = 1; 
break;
case 1: 
wLEAfPX = 12; 
break;
case 2:  
wLEAfPX = 4; 
break;
case 3:  
RVeDwhC = 1;
OpenLiveControlMenu(); 
break;
case 4:  
RVeDwhC = 3;
break;
}          
}
}
if (TextFields[14].over()) TextFields[14].SelectField(14);	
if(DMXSequenceIcon.over() && device.BasicVersion == 0) 
{
AppendLogFile("Clicked DMXSequenceIcon"); 
OcNYMio = true;  
}
if(SerialSequenceIcon.over() && device.BasicVersion == 0) 
{
AppendLogFile("Clicked SerialSequenceIcon"); 
deIRAFp = true;
}      
break;
case 1: 
if (LiveControlCheckBox[3].over() && device.Serial16Bit == true)
{
LiveControlCheckBox[3].Selected =! LiveControlCheckBox[3].Selected; 
OpenLiveControlMenu(); 
return;
}    
for (int i = 0; i != ControlSliders.length; i++) 
{
if (ControlSliders[i].over())
{
ControlSliders[i].selectSlider();
TextFields[4].Label = ""+(i+1);
TextFields[5].Label = ""+ControlSliders[i].Value;
}
}
if (TextFields[4].over()) TextFields[4].SelectField(4);   
if (TextFields[5].over()) TextFields[5].SelectField(5);  
break;    
case 2: 
for (int i =0; i != LiveControlCheckBox.length; i++) 
{
if (LiveControlCheckBox[i].over())
{
AppendLogFile("LiveControlCheckBox "+i+" pressed"); 
LiveControlCheckBox[0].Selected = false; 
LiveControlCheckBox[1].Selected = false; 
LiveControlCheckBox[2].Selected = false; 
LiveControlCheckBox[i].Selected = true;
FmxWQSR = i;
QVhoOtU = 1; 
if (FmxWQSR == 1) QVhoOtU  = 3;
else if (FmxWQSR == 2) QVhoOtU  =  4;
return;
}
}
for (int i = 0; i != uDInFJD; i++) 
{
try {
if(ControlRects[i].over())
{
AppendLogFile("Clicked Live Control Square: "+i); 
YyryBXy = true;  
ColorSelector.InitPosition();  
fQlhEcU = i;
return;
}
}
catch(Exception e) { AppendLogFile("No ControlRect");}
}    
break;   
case 3: 
if (StandAloneDD.over())
{
StandAloneDD.selectDD();
AppendLogFile("Pressed StandAloneDD DropDown Open");
return;
}
else if (StandAloneDD.overOpen() != 0 && StandAloneDD.Selected == true)
{
AppendLogFile("Pressed StandAloneDD DropDown "+StandAloneDD.overOpen() );
StandAloneDD.Selected = false;
StandAloneDD.SelStr = (StandAloneDD.overOpen()-1);
return;
}    
if(StandAloneClose.over()) 
{
StandAloneClose.Selected = true;
StandAloneClose.display();
RVeDwhC = 0;
}
for (int i = 0; i != StandaloneButtons.length; i++) 
{
if(StandaloneButtons[i].over())
{
StandaloneButtons[i].Selected = true;
AppendLogFile("Pressed StandAlone Button "+i);
int temp = 0;
switch(i)
{
case 0: 
xhPzZot = cCMDColShift;
hgwvVkk[0] = StandAloneDD.SelStr;
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
break;
case 1: 
xhPzZot = cCMDSelSeq; 
hgwvVkk[0] = int(TextFields[7].Label);
hgwvVkk[1] = 0; 
if(StandaloneCheckBox[1].Selected == true)  hgwvVkk[2] = 1;  
else  hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();        
break;       
case 2: 
temp = int(TextFields[8].Label);
xhPzZot = cCMDSpeed;     
hgwvVkk[0] = (temp >> 8) & 0xFF; 
hgwvVkk[1] = temp & 0xFF; 
hgwvVkk[2] = 0;
hgwvVkk[3] = 0;  
RequestCommand();
AppendLogFile("Speed Vals: "+temp+" : "+hgwvVkk[0]+" : "+hgwvVkk[1]+" : "+hgwvVkk[2]);          
break;     
case 3: 
xhPzZot = cCMDInstStep;
hgwvVkk[0] = 1; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();     
break;
case 4: 
xhPzZot = cCMDInstStep;
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();             
break;  
case 5: 
temp = int(TextFields[9].Label);
AppendLogFile("temp = "+temp);
xhPzZot = cCMDFadeCtrl;
hgwvVkk[0] = (temp >> 8) & 0xFF; 
hgwvVkk[1] = (temp & 0x00FF); 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
break;        
case 6: 
xhPzZot = cCMDSeqUp;
hgwvVkk[0] = 1; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();         
break;       
case 7: 
xhPzZot = cCMDSeqDwn;
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0;
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();         
break;    
case 8: 
xhPzZot = cCMDTogPause;
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0;
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();           
break;       
}
}
}
if(TextFields[7].over()) TextFields[7].SelectField(7);  
if(TextFields[8].over()) TextFields[8].SelectField(8);  
if(TextFields[9].over()) TextFields[9].SelectField(9);  
if(StandaloneCheckBox[0].over()) StandaloneCheckBox[0].Selected =! StandaloneCheckBox[0].Selected;
if(StandaloneCheckBox[1].over()) StandaloneCheckBox[1].Selected =! StandaloneCheckBox[1].Selected;
for (int i = 0; i != StandaloneSliders.length; i++)  if (StandaloneSliders[i].over())  StandaloneSliders[i].selectSlider(); 
break;
}
break; 
case 3: 
if (ShapeOptionsDD.over())
{
ShapeOptionsDD.selectDD();
AppendLogFile("Pressed ShapeOptionsDD DropDown Open");
return;
}
else if (ShapeOptionsDD.overOpen() != 0 && ShapeOptionsDD.Selected == true)
{
AppendLogFile("Pressed ShapeOptionsDD DropDown "+ShapeOptionsDD.overOpen() );
ShapeOptionsDD.Selected = false;
ShapeOptionsDD.SelStr = (ShapeOptionsDD.overOpen()-1);
jgvztaS = ShapeOptionsDD.SelStr+1;
if(jgvztaS == 6)
{
IBzMEJI = new int[MHixUhI*yxtcfxi]; 
zppAzXD = new int[MHixUhI*yxtcfxi];
for (int q = 0; q != INyauIU; q++)
{
IBzMEJI[q] = 0;
zppAzXD[q] = 0;
}
} 
GraphicLayoutBuild();		
return;
}  	
for (int i =0; i != SoftwareCheckBox.length; i++)
{
if(SoftwareCheckBox[i].over())
{
SoftwareCheckBox[0].Selected = false;
SoftwareCheckBox[1].Selected = false;
SoftwareCheckBox[2].Selected = false;
SoftwareCheckBox[i].Selected = true;
GraphicLayoutBuild();
}
}
for (int i =0; i != SoftwareButtons.length; i++)
{
if (SoftwareButtons[i].over())
{
AppendLogFile("Pressed: "+i);
SoftwareButtons[i].Selected =! SoftwareButtons[i].Selected;
switch(i)
{
case 0:
zJypjQP = 2; 
selectOutput("Select a file to Save:", "fileSelected");
break;
case 1:
zJypjQP = 1; 
selectInput("Select a file to Load:", "fileSelected");
break;  
case 2:
launch(sketchPath("README.TXT"));
break;
case 3: 
if(jgvztaS < 5) return;
zJypjQP = 5;
if(jgvztaS == 5) zJypjQP = 6;
AppendLogFile("Pressed Load Shape Image Button");
selectInput("Select an image file to load:", "fileSelected");	
break;  
case 4: 
KZdjFXA = false;
oMQaBmH = false;
SoftwareButtons[5].Selected = false;
SoftwareButtons[7].Selected = false;		  
vLvSrbC = SoftwareButtons[4].Selected;
BTVNeSA = false;
break;
case 5: 
vLvSrbC = false;
oMQaBmH = false;
SoftwareButtons[4].Selected = false;
SoftwareButtons[7].Selected = false;		  
KZdjFXA = SoftwareButtons[5].Selected;
break;
case 6:
link("http://www.NLEDshop.com");
break;
case 7: 
vLvSrbC = false;
KZdjFXA = false;
SoftwareButtons[4].Selected = false;
SoftwareButtons[5].Selected = false;
oMQaBmH = SoftwareButtons[7].Selected;
break;
case 8: 
selectInput("Select a Device file to Load:", "fileSelected");
zJypjQP = 3; 
break;
case 9: 
wLEAfPX = 3;
break;	
case 10: 
if(int(TextFields[11].Label) == 0) return;
wLEAfPX = 5;
break;						
case 11: 
surface.setSize(800, 600);							
break;						
case 12: 
surface.setSize(1024, 768);
break;		
case 13: 
surface.setSize(1280, 960);					
break;	
case 14: 
for (int q=0; q != INyauIU;q++)
{
IBzMEJI[q] = 0;
zppAzXD[q] = 0;
}	
LEDIcon = new LEDgraphic[MHixUhI*device.Channels];
INyauIU = MHixUhI*zQjfRqq;
MenuTabs[0].refresh();
break;									
}
return;
}
}
if (TextFields[1].over()) { TextFields[1].SelectField(1); return; }
if (TextFields[11].over()) { TextFields[11].SelectField(11); return; }
if (MenuSliders[0].over()) { MenuSliders[0].selectSlider(); return; }	
if (UserChannelsSlider.over()) { UserChannelsSlider.selectSlider(); return; }
break;    
case 4: 
if(DeviceWebpage.over())
{
link(device.WebpageURL);	
return;	
}
if(RequestConfigurations.over())
{
EBWUsXC = 9;
return;
}		
if(EnterBootloaderButton.over())
{
wLEAfPX = 9;
return;
}		
if(OpenTCPButton.over())
{
thread("OpenTCP");
return;
}		
if(HardwareTabUploadConfigurations.over())
{
wLEAfPX = 12; 
return;
}	
for (int i =0; i != COMButtons.length; i++)
{
if (COMButtons[i].over())
{
if(COMButtons[i].Selected == true)
{
COMButtons[i].Selected = false;
CloseCOMPort();	
AppendLogFile("COM Port Closed");
}
else
{
try
{
OpenCOMPort(Serial.list()[i]);
COMButtons[i].Selected = true;
}
catch(Exception e)
{
AppendLogFile("Port Stopped");
CloseCOMPort();
}
}
return;	
}
}
if (HardwareColSwapDD.over() && InputModule[2].Enabled == true)
{
HardwareColSwapDD.selectDD();
AppendLogFile("Pressed HardwareColSwapDD DropDown Open");
return;
}
else if (HardwareColSwapDD.overOpen() != 0 && HardwareColSwapDD.Selected == true)
{
AppendLogFile("Pressed HardwareColSwapDD DropDown "+HardwareColSwapDD.overOpen() );
HardwareColSwapDD.Selected = false;
HardwareColSwapDD.SelStr = (HardwareColSwapDD.overOpen()-1);
return;
}  			
if (PixelChipsetDD.over() && InputModule[3].Enabled == true)
{
PixelChipsetDD.selectDD();
AppendLogFile("Pressed PixelChipsetDD DropDown Open");
return;
}
else if (PixelChipsetDD.overOpen() != 0 && PixelChipsetDD.Selected == true)
{
AppendLogFile("Pressed PixelChipsetDD DropDown "+PixelChipsetDD.overOpen() );
PixelChipsetDD.Selected = false;
PixelChipsetDD.SelStr = (PixelChipsetDD.overOpen()-1);
FuncRecommendColorShift();
return;
}  			
if (LEDModeDD.over() && InputModule[9].Enabled == true)
{
LEDModeDD.selectDD();
AppendLogFile("Pressed LEDModeDD DropDown Open");
return;
}
else if (LEDModeDD.overOpen() != 0 && LEDModeDD.Selected == true)
{
AppendLogFile("Pressed LEDModeDD DropDown "+LEDModeDD.overOpen() );
LEDModeDD.Selected = false;
LEDModeDD.SelStr = (LEDModeDD.overOpen()-1);
return;
}  	
if (DisplayModeDD.over() && InputModule[10].Enabled == true)
{
DisplayModeDD.selectDD();
AppendLogFile("Pressed DisplayModeDD DropDown Open");
return;
}
else if (DisplayModeDD.overOpen() != 0 && DisplayModeDD.Selected == true)
{
AppendLogFile("Pressed DisplayModeDD DropDown "+DisplayModeDD.overOpen() );
DisplayModeDD.Selected = false;
DisplayModeDD.SelStr = (DisplayModeDD.overOpen()-1);
return;
}  
if (MasterModeDD.over() && InputModule[7].Enabled == true)
{
MasterModeDD.selectDD();
AppendLogFile("Pressed MasterModeDD DropDown Open");
return;
}
else if (MasterModeDD.overOpen() != 0 && MasterModeDD.Selected == true)
{
AppendLogFile("Pressed DropDown "+MasterModeDD.overOpen() );
MasterModeDD.Selected = false;
MasterModeDD.SelStr = (MasterModeDD.overOpen()-1);
return;
}			
if (AutoDetectDD.over() && InputModule[11].Enabled == true)
{
AutoDetectDD.selectDD();
AppendLogFile("Pressed AutoDetectDD DropDown Open");
return;
}
else if (AutoDetectDD.overOpen() != 0 && AutoDetectDD.Selected == true)
{
AppendLogFile("Pressed AutoDetectDD DropDown "+AutoDetectDD.overOpen() );
AutoDetectDD.Selected = false;
AutoDetectDD.SelStr = (AutoDetectDD.overOpen()-1);
return;
}		
if (BaudRateDD.over() && InputModule[8].Enabled == true)
{
BaudRateDD.selectDD();
AppendLogFile("Pressed BaudRateDD DropDown Open");
return;
}
else if (BaudRateDD.overOpen() != 0 && BaudRateDD.Selected == true)
{
AppendLogFile("Pressed BaudRateDD DropDown "+BaudRateDD.overOpen() );
BaudRateDD.Selected = false;
BaudRateDD.SelStr = (BaudRateDD.overOpen()-1);
device.SelBaudRate = BaudRateDD.SelStr;
return;
}
if (DMXModesDD.over() && InputModule[6].Enabled == true)
{  
DMXModesDD.selectDD();
AppendLogFile("Pressed DMXModesDD DropDown Open");
return;
}
else if (DMXModesDD.overOpen() != 0 && DMXModesDD.Selected == true)
{
AppendLogFile("Pressed DMXModesDD DropDown "+DMXModesDD.overOpen() );
DMXModesDD.Selected = false;
DMXModesDD.SelStr = (DMXModesDD.overOpen()-1);
device.SelDMXMode = DMXModesDD.SelStr;
return;
}
if (AccMeterAutoModeDD.over() && InputModule[14].Enabled == true)
{  
AccMeterAutoModeDD.selectDD();
AppendLogFile("Pressed AccMeterAutoModeDD DropDown Open");
return;
}
else if (AccMeterAutoModeDD.overOpen() != 0 && AccMeterAutoModeDD.Selected == true)
{
AppendLogFile("Pressed AccMeterAutoModeDD DropDown "+AccMeterAutoModeDD.overOpen() );
AccMeterAutoModeDD.Selected = false;
AccMeterAutoModeDD.SelStr = (AccMeterAutoModeDD.overOpen()-1);
return;
}
if (AccMeterTapDD.over() && InputModule[15].Enabled == true)
{  
AccMeterTapDD.selectDD();
AppendLogFile("Pressed AccMeterTapDD DropDown Open");
return;
}
else if (AccMeterTapDD.overOpen() != 0 && AccMeterTapDD.Selected == true)
{
AppendLogFile("Pressed AccMeterTapDD DropDown "+AccMeterTapDD.overOpen() );
AccMeterTapDD.Selected = false;
AccMeterTapDD.SelStr = (AccMeterTapDD.overOpen()-1);
return;
}
if (PowerDownTimeOutDD.over() && InputModule[16].Enabled == true)
{  
PowerDownTimeOutDD.selectDD();
AppendLogFile("Pressed PowerDownTimeOutDD DropDown Open");
return;
}
else if (PowerDownTimeOutDD.overOpen() != 0 && PowerDownTimeOutDD.Selected == true)
{
AppendLogFile("Pressed PowerDownTimeOutDD DropDown "+PowerDownTimeOutDD.overOpen() );
PowerDownTimeOutDD.Selected = false;
PowerDownTimeOutDD.SelStr = (PowerDownTimeOutDD.overOpen()-1);
return;
}		
for (int i =0; i != HardwareCheckBox.length; i++) 
{
if (HardwareCheckBox[0].over() && device.Serial16Bit == true)
{
HardwareCheckBox[0].Selected =! HardwareCheckBox[0].Selected;
return;
}
if (HardwareCheckBox[1].over() && InputModule[19].Enabled==true)
{
HardwareCheckBox[1].Selected =! HardwareCheckBox[1].Selected;
return;
}			
} 
if(HardwareButtons[0].over() && device.RS485Capable) 
{
HardwareButtons[0].Selected =! HardwareButtons[0].Selected;
return;
} 	
if(HardwareButtons[1].over() && device.Bit16Capable) 
{
HardwareButtons[1].Selected =! HardwareButtons[1].Selected;
return;		
}
if(HardwareButtons[2].over() && device.HardwareID == 43) 
{
HardwareButtons[2].Selected =! HardwareButtons[2].Selected;
return;		
}
if(HardwareButtons[4].over() && InputModule[14].Enabled == true) 
{
HardwareButtons[4].Selected =! HardwareButtons[4].Selected;
return;		
}
if (TextFields[2].over() && InputModule[5].Enabled == true) { TextFields[2].SelectField(2); return; }
if (TextFields[15].over() && InputModule[17].Enabled == true) { TextFields[15].SelectField(15); return; }
if (TextFields[16].over() && InputModule[18].Enabled == true) { TextFields[16].SelectField(16); return; }
break; 
} 
AppendLogFile("========= MADE IT TO THE END WITH NO CONTACTS ===============");	
if(vTJocgz == true) { DropDownPointer.Selected = false;vTJocgz = false; }
if(QFfuPVT == true) QFfuPVT = false;
}
void SendMonitor()
{
aMBxKxp++; 
MYEjGAS++; 
if(device.HardwareID == 44) 
{	
if(aMBxKxp == device.CurrentBlockSize)
{
AppendLogFile("Waiting for ACK, SendCounter: "+aMBxKxp);
aMBxKxp = 0;
while(UPJfpbQ == false) 
{
delay(1);
}
UPJfpbQ = false; 
AppendLogFile("ACK RECEIVED FOR PACKET# "+xWhYcfF);
xWhYcfF++;
}
else delay(2); 
} 
else if (aMBxKxp >= device.EraseBlockSize)
{
delay(10); 
aMBxKxp = 0;
}
delay(1); 
}
void SendLegacyData() 
{
delay(50); 
if(device.LinkedSupport == true) SendLegacyWithLinked();
else SendLegacy();
PEMuQZm = false; 
} 
void SendLegacyWithLinked()
{
AppendLogFile("SendLegacyWithLinked()");
AppendLogFile("=========================================================================");
int LegacyMaxSequences = 32;
OefqCkP = device.BasicSeqLength;
for (int q = 1; q != slBNIJT.length; q++) 
{
slBNIJT[q].LinkerUtilized = false;
slBNIJT[q].assignedIDNum = 255;
slBNIJT[q].assignedLinkedIDNum = 255;
slBNIJT[q].IDassigned = false;
}
int offsetVar = 0;	
for (int i = 0; i != 32; i++) 
{	 	
if(JzvVShV[i] < 255 && slBNIJT[JzvVShV[i]].IDassigned == false)
{
slBNIJT[JzvVShV[i]].LinkerUtilized = true;
slBNIJT[JzvVShV[i]].assignedIDNum = i - offsetVar;
slBNIJT[JzvVShV[i]].IDassigned = true;
} 
else if(JzvVShV[i] < 255 && slBNIJT[JzvVShV[i]].IDassigned == true)
{	
offsetVar++;	
}
else if(JzvVShV[i] > 255) 
{
offsetVar++;		
}
else
{
label:
for (int q = 1; q != slBNIJT.length; q++)
{
if(slBNIJT[q].SeqMode == mLinked && slBNIJT[q].LinkerUtilized == true)
{	
for (int yy = 0; yy != slBNIJT[q].SeqFrameAmount; yy++)
{
if(slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized == false && slBNIJT[slBNIJT[q].DataFrames[0][yy]].IDassigned == false)
{	
AppendLogFile("One yet to be linked, SoftID: "+slBNIJT[q].DataFrames[0][yy]+" will be "+(i - offsetVar)+" instead of "+(i));
slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized = true;
slBNIJT[slBNIJT[q].DataFrames[0][yy]].assignedIDNum = i - offsetVar;
slBNIJT[slBNIJT[q].DataFrames[0][yy]].IDassigned = true;
break label;
}	
}
}	
}	
}
} 
for (int q = 1; q != slBNIJT.length; q++) AppendLogFile(q+" : assigned: "+slBNIJT[q].assignedIDNum+" : Utilized: "+slBNIJT[q].LinkerUtilized);
AppendLogFile("===================================="+OefqCkP+"=====================================");
for (int q = 1; q != slBNIJT.length; q++) AppendLogFile("SoftSeq#: "+q+" - Assigned: "+slBNIJT[q].assignedIDNum+" - LinkerAssiD: "+slBNIJT[q].assignedLinkedIDNum);
int tempPointer = 0;
int[] tempArray = new int[32];
int tempIDnum = 0;
for (int i = 0; i != 32; i++) tempArray[i] = 255;
for (int i = 1; i != slBNIJT.length; i++) 
{
if(slBNIJT[i].assignedIDNum == tempIDnum)
{	
tempArray[tempPointer] = i;
tempPointer++;
i = 0; 
tempIDnum++;
}
}	
delay(30); 
int CalcMapStart=0; 
int qq = 0; 
int DeviceMaxFrames = int((float)((float)device.DataSpace) / (float)device.Channels); 
aMBxKxp = 0;
MYEjGAS = 0;
int[] SlideBuild = new int[DeviceMaxFrames];
int g=0;
for(int i=0; i != SlideBuild.length;i++)  SlideBuild[i] = 127; 
for(int q=0; q != LegacyMaxSequences;q++) 
{	
try 
{	
qq = tempArray[q];	
if(qq == 255) qq = 0;
if(slBNIJT[qq].SeqMode != mLinked) 
{	
for(int i=0; i != (slBNIJT[qq].SeqFrameAmount+1);i++)   
{
/*	
30 – 36	Slide Down, Single, w/o color shift
40 – 46	Slide Down, RGB,  w/o color shift
50 – 56	Slide Down, RGBW,  w/o color shift
60 – 66	Slide Up, Single, w/o color shift
70 – 76	Slide Up, RGB,  w/o color shift
80 – 86	Slide Up, RGBW,  w/o color shift
*/
if (slBNIJT[qq].FrameSpecial[i] > 29 && slBNIJT[qq].FrameSpecial[i] < 60)
{
SlideBuild[g] = 127 - slBNIJT[qq].SlideValues[i]; 
if(slBNIJT[qq].SlideValues[i] < 0) slBNIJT[qq].SlideValues[i] = 0;
}
else if (slBNIJT[qq].FrameSpecial[i] > 59 && slBNIJT[qq].FrameSpecial[i] < 90)
{
SlideBuild[g] = 127 + slBNIJT[qq].SlideValues[i];  
if(slBNIJT[qq].SlideValues[i] > 255) slBNIJT[qq].SlideValues[i] = 255;
}
else
SlideBuild[g] = 127;
g++; 
} 
} 
} 
catch(Exception e)
{
g++; 
}		
} 
for(int i=0; i != DeviceMaxFrames;i++)
{
myPort.write(SlideBuild[i]);
SendMonitor();
}
for(int i=0; i != LegacyMaxSequences;i++) 
{
qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
temp = slBNIJT[qq].Speed;
if(temp > 255) temp = 255; 
myPort.write(temp); 
}
catch(Exception e)
{
myPort.write(0); 
}
SendMonitor();
}
for(int i=0; i != LegacyMaxSequences;i++) 
{
qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
if(slBNIJT[qq].SeqMode == mLinked) myPort.write(slBNIJT[qq].DataFrameAmount); 
else myPort.write(slBNIJT[qq].SeqFrameAmount); 
}
catch(Exception e)
{
myPort.write(0);  
}
SendMonitor();
}
for(int i=0; i != LegacyMaxSequences;i++)  
{
qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
if(slBNIJT[qq].SeqMode == mFade || slBNIJT[qq].SeqMode == mGradient) myPort.write(mFade);
else myPort.write(slBNIJT[qq].SeqMode);
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
for(int i=0; i != LegacyMaxSequences;i++)  
{
qq = tempArray[i];
if(qq == 255) qq = 0;	
if(i==0) 
{
myPort.write(0);
CalcMapStart = CalcMapStart + slBNIJT[qq].DataFrameAmount+1;
}
else if(slBNIJT[qq].SeqMode == mLinked)  myPort.write(0);
else
{
try 
{	
AppendLogFile("Cacling Map with ID: "+qq+", its "+(slBNIJT[qq].DataFrameAmount+1)+" frames.");
myPort.write(CalcMapStart);
CalcMapStart = CalcMapStart + slBNIJT[qq].DataFrameAmount+1;
AppendLogFile("CalcMapStart: "+CalcMapStart);
}
catch(Exception e)
{
myPort.write(0);	
AppendLogFile("Sequence Not Found Sent 0");
}
}
SendMonitor();
}
/*
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedLinkedIDNum); 
AppendLogFile("Linked SeqID: "+(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedLinkedIDNum));
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb((byte)slBNIJT[SelSeq].SlideValues[i]); 
AppendLogFile("Iterations: "+slBNIJT[SelSeq].SlideValues[i]);
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb((byte)slBNIJT[SelSeq].SpecialFrameVar[i]);
AppendLogFile("Transition: "+slBNIJT[slBNIJT[SelSeq].DataFrameVar[i]].SpecialFrameVar[i]);
}
*/
for(int q=0; q != LegacyMaxSequences;q++) 
{
qq = tempArray[q];
if(qq == 255) qq = 0;	
try 
{
if(slBNIJT[qq].SeqMode == mLinked)
{
AppendLogFile("qq = "+qq);
for(int i=0; i != device.Channels;i++)  
{
slBNIJT[qq].StartValues[i] = slBNIJT[slBNIJT[qq].DataFrames[0][i]].assignedIDNum;
slBNIJT[qq].DataFrameVar[i] = slBNIJT[qq].SlideValues[i];
AppendLogFile("assigned: "+slBNIJT[qq].StartValues[i] +" : Iterations: "+slBNIJT[qq].DataFrameVar[i]);
}
}
}
catch(Exception e)
{
}
}
for(int q=0; q != LegacyMaxSequences;q++) 
for(int i=0; i != device.Channels;i++)  
{
qq = tempArray[q];
if(qq == 255) qq =0;	
try 
{
myPort.write(slBNIJT[qq].StartValues[i]); 
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
for(int q=0; q != LegacyMaxSequences;q++) 
for(int i=0; i != device.Channels;i++)  
{
qq = tempArray[q];
if(qq == 255) qq = 0;
try 
{
myPort.write(slBNIJT[qq].DataFrameVar[i]);
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
CalcMapStart=0;
for(int q=0; q != LegacyMaxSequences;q++) 
{
qq = tempArray[q];
if(qq != 255) 
{
if(slBNIJT[qq].SeqMode != mLinked) 
{		
try 
{	
for(int z=0; z != (slBNIJT[qq].SeqFrameAmount+1);z++)
for(int i=0; i != device.Channels;i++) 
{
myPort.write(slBNIJT[qq].DataFrames[z][i]);
SendMonitor();
CalcMapStart++;
}
}
catch(Exception e)
{
AppendLogFile("DataValue exception "+q);
}
}
}		
} 
AppendLogFile("Data Values Left to Send: "+(device.DataSpace - CalcMapStart)+" and "+(device.CurrentBlockSize - (MYEjGAS%device.CurrentBlockSize))+"left to match memory block"); 
CalcMapStart = (device.DataSpace - CalcMapStart) + (device.CurrentBlockSize - (MYEjGAS%device.CurrentBlockSize));
for(int i=0; i != CalcMapStart;i++) 
{
myPort.write(0); 
SendMonitor();
}
AppendLogFile("LegacyDataWithLinked() Done");
} 
void SendLegacy()
{
AppendLogFile("SendLegacy()");
delay(20); 
int CalcMapStart=0; 
int qq = 0; 
int DeviceMaxFrames = int((float)((float)device.DataSpace) / (float)device.Channels); 
aMBxKxp = 0;
MYEjGAS = 0;
int[] SlideBuild = new int[64];
int g=0;
for(int i=0; i != 64;i++)  SlideBuild[i] = 127; 
for(int q=0; q != 8;q++) 
{	
try 
{	
qq = JzvVShV[q];
if(qq == 255) qq = 1;
for(int i=0; i != (slBNIJT[qq].SeqFrameAmount+1);i++)   
{
/*	
30 – 36	Slide Down, Single, w/o color shift
40 – 46	Slide Down, RGB,  w/o color shift
50 – 56	Slide Down, RGBW,  w/o color shift
60 – 66	Slide Up, Single, w/o color shift
70 – 76	Slide Up, RGB,  w/o color shift
80 – 86	Slide Up, RGBW,  w/o color shift
*/
AppendLogFile(q+" : "+qq+" - "+i+" - "+slBNIJT[qq].FrameSpecial[i]);
if (slBNIJT[qq].FrameSpecial[i] > 29 && slBNIJT[qq].FrameSpecial[i] < 60)
{
SlideBuild[g] = 127 - slBNIJT[qq].SlideValues[i]; 
if(slBNIJT[qq].SlideValues[i] < 0) slBNIJT[qq].SlideValues[i] = 0;
}
else if (slBNIJT[qq].FrameSpecial[i] > 59 && slBNIJT[qq].FrameSpecial[i] < 90)
{
SlideBuild[g] = 127 + slBNIJT[qq].SlideValues[i];  
if(slBNIJT[qq].SlideValues[i] > 255) slBNIJT[qq].SlideValues[i] = 255;
}
else
SlideBuild[g] = 127;
g++; 
} 
} 
catch(Exception e)
{
g++; 
}		
} 
AppendLogFile("Slides Built "+DeviceMaxFrames);
for(int i=0; i != DeviceMaxFrames;i++)
{
myPort.write(SlideBuild[i]);
SendMonitor();
}
for(int i=0; i != 8;i++) 
{
qq = JzvVShV[i];
if(qq == 255) qq = 1;
try 
{	
temp = slBNIJT[qq].Speed;
if(temp > 255) temp = 255; 
myPort.write(temp); 
}
catch(Exception e)
{
myPort.write(0); 
}
SendMonitor();
}
AppendLogFile("Speeds Sent");
for(int i=0; i != 8;i++) 
{
qq = JzvVShV[i];
if(qq == 255) qq = 1;
try 
{		
myPort.write(slBNIJT[qq].SeqFrameAmount); 
}
catch(Exception e)
{
myPort.write(0);  
}
SendMonitor();
}
for(int i=0; i != 8;i++)  
{
qq = JzvVShV[i];
if(qq == 255) qq = 1;
try 
{	
if(slBNIJT[qq].SeqMode == mFade || slBNIJT[qq].SeqMode == mGradient) myPort.write(mFade);
else myPort.write(mInstant);
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
for(int i=0; i != 8;i++)  
{
qq = JzvVShV[i];
if(qq == 255) qq = 1;	
if(qq==1) 
{
myPort.write(0);
CalcMapStart = CalcMapStart + slBNIJT[1].DataFrameAmount+1;
}	
else
{
try 
{	
AppendLogFile("Cacling Map with "+qq+", its "+slBNIJT[qq].DataFrameAmount);
myPort.write(CalcMapStart);
CalcMapStart = CalcMapStart + slBNIJT[qq].DataFrameAmount+1;
AppendLogFile("CalcMapStart: "+CalcMapStart);
}
catch(Exception e)
{
myPort.write(0);	
AppendLogFile("Sequence Not Found Sent 0");
}
}
SendMonitor();
}
for(int q=0; q != 8;q++) 
for(int i=0; i != device.Channels;i++)  
{
qq = JzvVShV[q];
if(qq == 255) qq = 1;	
try 
{
myPort.write(slBNIJT[qq].StartValues[i]); 
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
AppendLogFile("Start Values Sent");	
for(int q=0; q != 8;q++) 
for(int i=0; i != device.Channels;i++)  
{
qq = JzvVShV[q];
if(qq == 255) qq = 1;
try 
{
myPort.write(slBNIJT[qq].DataFrameVar[i]);
}
catch(Exception e)
{
myPort.write(0);	
}
SendMonitor();
}
AppendLogFile("FrameVars Sent");	
CalcMapStart=0;
for(int q=0; q != 8;q++) 
{
qq = JzvVShV[q];
if(qq == 255) qq = 1;	
try 
{	
for(int z=0; z != (slBNIJT[qq].SeqFrameAmount+1);z++)
for(int i=0; i != device.Channels;i++) 
{
myPort.write(slBNIJT[qq].DataFrames[z][i]);
SendMonitor();
CalcMapStart++;
}
}
catch(Exception e)
{
AppendLogFile("DataValue exception "+q);
}
} 
CalcMapStart = device.DataSpace - CalcMapStart;
AppendLogFile("Data Values Left to Send: "+CalcMapStart); 
for(int i=0; i != CalcMapStart;i++) 
{
myPort.write(i); 
SendMonitor();
}
AppendLogFile("LegacyData() Done");
}
void HandleFrameCheckBoxes(int PassedID)
{
FrameCheckBoxes[0].Selected = false; 
FrameCheckBoxes[1].Selected = false; 
FrameCheckBoxes[2].Selected = false; 
if (PassedID != 0)	FrameCheckBoxes[PassedID-1].Selected = true;
}
void HandleCommonButtons(int PassedID)
{
AppendLogFile("HandleButtons "+PassedID+" pressed"); 
CommonButtons[PassedID].Selected = true;
if(PassedID < 3 && slBNIJT[DIWlYpw].SeqMode == mPOV) return; 
switch(PassedID)
{
case 0: 
if (slBNIJT[DIWlYpw].SeqFrameAmount != (cSoftwareMaxFrames-1))  
{
slBNIJT[DIWlYpw].SeqFrameAmount++;
if (slBNIJT[DIWlYpw].SeqMode == mFade || slBNIJT[DIWlYpw].SeqMode == mInstant)
slBNIJT[DIWlYpw].FrameSpecial[slBNIJT[DIWlYpw].SeqFrameAmount] = slBNIJT[DIWlYpw].SeqMode*10;  
else  slBNIJT[DIWlYpw].FrameSpecial[slBNIJT[DIWlYpw].SeqFrameAmount] = 10;
}
if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
if(device.BasicVersion > 0 && device.LinkedSupport == true)
{
if(slBNIJT[DIWlYpw].SeqFrameAmount > 8) 
{
slBNIJT[DIWlYpw].SeqFrameAmount = 8;
EBWUsXC = 14;
}
}
else DrawLinkedBuffer();
} 
if (slBNIJT[DIWlYpw].SeqFrameAmount  >= ((wtkyhyk+1)*30)) 
{
AppendLogFile("PageView++");
wtkyhyk++;
}
break; 
case 1: 
if (slBNIJT[DIWlYpw].SeqFrameAmount != 1)  slBNIJT[DIWlYpw].SeqFrameAmount--; 
if (lXrpjlY > slBNIJT[DIWlYpw].SeqFrameAmount)
{    
SetlXrpjlY(slBNIJT[DIWlYpw].SeqFrameAmount-1);
FillFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial);
}
if (slBNIJT[DIWlYpw].SeqMode == mLinked) DrawLinkedBuffer();    
break;
case 2:
slBNIJT[DIWlYpw].SeqFrameAmount = 1;
SetlXrpjlY(0);
break; 
case 3: 
if (slBNIJT[DIWlYpw].SeqMode == mLinked) return;
wtkyhyk++;
if ((wtkyhyk*30) > slBNIJT[DIWlYpw].SeqFrameAmount) wtkyhyk = 0;
AppendLogFile("Frame Up: "+wtkyhyk);
break;
case 4: 
if (slBNIJT[DIWlYpw].SeqMode == mLinked) return;  
wtkyhyk--;
if (wtkyhyk < 0) wtkyhyk = floor(slBNIJT[DIWlYpw].SeqFrameAmount / 30);
AppendLogFile("Frame Down: "+wtkyhyk);
break; 
case 5: 
slBNIJT[DIWlYpw].SeqMode = mFade;
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 10;
UpdateSequence(DIWlYpw);
break; 
case 6: 
slBNIJT[DIWlYpw].SeqMode = mInstant;  
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 20;
slBNIJT[DIWlYpw].StartValues = new int[slBNIJT[DIWlYpw].DataSize]; 
UpdateSequence(DIWlYpw);
break;  
case 7: 
slBNIJT[DIWlYpw].SeqMode = mGradient;  
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 10;
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) 
{
switch(fYArHTo)
{
case 0: 
for (int i = 0; i != yxtcfxi;i++)  slBNIJT[DIWlYpw].DataFrames[x][i] = slBNIJT[DIWlYpw].DataFrames[x][0];
break;		
case 1: 
for (int i = 0; i < yxtcfxi-2;i+=3)  
{
slBNIJT[DIWlYpw].DataFrames[x][i] = slBNIJT[DIWlYpw].DataFrames[x][0];
slBNIJT[DIWlYpw].DataFrames[x][i+1] = slBNIJT[DIWlYpw].DataFrames[x][1];
slBNIJT[DIWlYpw].DataFrames[x][i+2] = slBNIJT[DIWlYpw].DataFrames[x][2];
}
break;
case 2: 
for (int i = 0; i < yxtcfxi-3;i+=4)  
{
slBNIJT[DIWlYpw].DataFrames[x][i] = slBNIJT[DIWlYpw].DataFrames[x][0];
slBNIJT[DIWlYpw].DataFrames[x][i+1] = slBNIJT[DIWlYpw].DataFrames[x][1];
slBNIJT[DIWlYpw].DataFrames[x][i+2] = slBNIJT[DIWlYpw].DataFrames[x][2];
slBNIJT[DIWlYpw].DataFrames[x][i+3] = slBNIJT[DIWlYpw].DataFrames[x][3];
}		
break;
}	  
}
UpdateSequence(DIWlYpw);
BuildGradientMenu();
break; 
case 8: 
if(device.BasicVersion > 0) return; 
slBNIJT[DIWlYpw].SeqMode = mCombo; 
for(int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 10; 
UpdateSequence(DIWlYpw);
break; 
case 9: 
if(device.LinkedSupport == false) return; 
if(slBNIJT[DIWlYpw].SeqMode != mLinked)
{
slBNIJT[DIWlYpw].SeqFrameAmount = 0;
slBNIJT[DIWlYpw].DataFrameAmount = 0;
slBNIJT[DIWlYpw].DataFrameVar = new int[cSoftwareMaxChans];
slBNIJT[DIWlYpw].SpecialFrameVar = new int[cSoftwareMaxChans];
slBNIJT[DIWlYpw].SlideValues = new int[cSoftwareMaxFrames]; 
slBNIJT[DIWlYpw].SpeedValues = new int[cSoftwareMaxFrames];
slBNIJT[DIWlYpw].DataFrames = new int[cSoftwareMaxFrames][cSoftwareMaxChans];   
}	
slBNIJT[DIWlYpw].SeqMode = mLinked;  
slBNIJT[DIWlYpw].FrameSpecial = new int[cSoftwareMaxFrames];
slBNIJT[DIWlYpw].StartValues = new int[cSoftwareMaxChans];  
UpdateSequence(DIWlYpw);
break;
case 10: 
if(device.BasicVersion > 0) return; 
slBNIJT[DIWlYpw].SeqMode = mPOV;    
for (int x = 0; x != slBNIJT[DIWlYpw].SeqFrameAmount+1;x++) slBNIJT[DIWlYpw].FrameSpecial[x] = 20;
slBNIJT[DIWlYpw].StartValues = new int[slBNIJT[DIWlYpw].DataSize]; 
UpdateSequence(DIWlYpw);
break;	
} 
if(PassedID ==  0 || PassedID == 1 || PassedID == 2)
{
MenuTabs[1].refresh(); 
}
CommonButtonsState(PassedID);
}
void CommonButtonsState(int PassedID)
{
AppendLogFile("CommonButtonsState "+PassedID+" pressed"); 
CommonButtons[PassedID].Selected = true;
switch(PassedID)
{
case 0: 
break; 
case 1: 
break;
case 2:
break; 
case 3: 
break;
case 4: 
break; 
case 5: 
CommonButtons[6].Selected = false;
CommonButtons[7].Selected = false;  
CommonButtons[8].Selected = false; 
CommonButtons[9].Selected = false; 
CommonButtons[10].Selected = false; 	
FrameOptionsButtons[0].Selected = true;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;       
break; 
case 6: 
CommonButtons[5].Selected = false;
CommonButtons[7].Selected = false;  
CommonButtons[8].Selected = false; 
CommonButtons[9].Selected = false;  
CommonButtons[10].Selected = false; 
FrameOptionsButtons[0].Selected = false;
FrameOptionsButtons[1].Selected = true;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;   
break;  
case 7: 
CommonButtons[6].Selected = false;
CommonButtons[5].Selected = false;  
CommonButtons[8].Selected = false; 
CommonButtons[9].Selected = false;
CommonButtons[10].Selected = false; 
FrameOptionsButtons[0].Selected = true;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;       
break; 
case 8: 
CommonButtons[6].Selected = false;
CommonButtons[7].Selected = false;  
CommonButtons[5].Selected = false; 
CommonButtons[9].Selected = false; 
CommonButtons[10].Selected = false; 
slBNIJT[DIWlYpw].SeqMode = mCombo; 
break; 
case 9: 
CommonButtons[6].Selected = false;
CommonButtons[7].Selected = false;  
CommonButtons[5].Selected = false; 
CommonButtons[8].Selected = false; 
CommonButtons[10].Selected = false; 
FrameOptionsButtons[0].Selected = false;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;   
break;
case 10: 
CommonButtons[5].Selected = false; 	  
CommonButtons[6].Selected = false;
CommonButtons[7].Selected = false;  
CommonButtons[8].Selected = false; 
CommonButtons[9].Selected = false; 
FrameOptionsButtons[0].Selected = false;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;   
break;	
}
}
void HandleSliders(boolean bMoveEnable)
{
if(AHCacLc != SliderPointer.SetNumber){ AHCacLc = SliderPointer.SetNumber;AppendLogFile("Dragging Set# "+SliderPointer.SetNumber); }
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);
if(SliderPointer.SetNumber == 10)
{
SliderPointer.displayLinked();
if (bMoveEnable == true) SliderPointer.move(yrsmlGD-85, LWAPDwF);
slBNIJT[DIWlYpw].SlideValues[lXrpjlY] = SliderPointer.Value; 
AppendLogFile("Slider Info: "+slBNIJT[DIWlYpw].SlideValues[lXrpjlY]+ " - Frame: "+lXrpjlY+" - Seq: "+DIWlYpw);
return; 
}
if (bMoveEnable == true)
{
SliderPointer.move(yrsmlGD, LWAPDwF);
}
SliderPointer.display(); 
switch(SliderPointer.SetNumber)
{
case 0: 
AeQGRRm =  TimeLineScrollBar.Value;
break;
case 1: 
int holdPixelType = fYArHTo;
if(LMORxyF == 2 && RVeDwhC == 2) 
{
holdPixelType = FmxWQSR;
}
switch(holdPixelType)
{
case 0: 
ColorSelector.slRed = 0;
ColorSelector.slGreen = 0;
ColorSelector.slBlue = 0;
ColorSelector.slWhite = ColorSelectorSliders[3].Value;
break;
case 1: 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;
ColorSelector.slWhite = 0;	
break;	
case 2: 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
break;
}	
TextFields[10].Label = ""+SliderPointer.Value; 
break;
case 2: 
slBNIJT[DIWlYpw].gradientSteps =  GradientStepsSlider.Value; 
break;
case 3: 
MHixUhI = MenuSliders[0].Value;
TextFields[1].Label = MHixUhI+""; 
MenuTabs[0].refresh();
break;
case 4: 
SequenceScrollBar.move(yrsmlGD, LWAPDwF);
break;      
case 5: 
break;
case 6: 
break;
case 7: 
slBNIJT[DIWlYpw].Speed = SequenceSpeedSlider.Value;
TextFields[12].Label = ""+SequenceSpeedSlider.Value; 
break;
case 8: 
TextFields[5].Label = ""+ControlSliders[int( TextFields[4].Label)-1].Value;
hkZcTKJ = true;
break;
case 9: 
if (SliderPointer == StandaloneSliders[0])  TextFields[8].Label = ""+SliderPointer.Value;  
if (SliderPointer == StandaloneSliders[1])  TextFields[9].Label = ""+SliderPointer.Value * StandaloneSliders[2].Value;  
if (SliderPointer == StandaloneSliders[2])  TextFields[9].Label = ""+StandaloneSliders[1].Value * StandaloneSliders[2].Value;  
break;
case 10: 
break;   
case 11: 
if(device.BasicVersion > 0)
{
SliderPointer.Value = device.Channels;
EBWUsXC = 13;
}
else
{
TextFields[11].Label = ""+int(SliderPointer.Value);
}
break;   
case 12: 
break;
} 
} 
void keyPressed()
{
AppendLogFile("keyPressed() - "+key);	
if (QzQTRuy == true)
{
try{
if(BTVNeSA == true)
{
if (key == ENTER)
{		
AppendLogFile("Enter Key Acknowledged");	
LinkedIterationFields[yJIRxDo].Selected = false;
if (int(LinkedIterationFields[yJIRxDo].Label) > 255) LinkedIterationFields[yJIRxDo].Label = "255";
slBNIJT[DIWlYpw].SlideValues[yJIRxDo] = int(LinkedIterationFields[yJIRxDo].Label);
LinkedSliders[yJIRxDo].Value = slBNIJT[DIWlYpw].SlideValues[yJIRxDo];
LinkedScrollBuffer.beginDraw();
LinkedSliders[yJIRxDo].displayLinked();
LinkedScrollBuffer.endDraw();
BTVNeSA = false;
QzQTRuy = false;
}
else if (key == BACKSPACE) 
{
AppendLogFile("Trying");
LinkedIterationFields[yJIRxDo].Label = LinkedIterationFields[yJIRxDo].Label.substring(0, LinkedIterationFields[yJIRxDo].Label.length()-1);
}
else if (key=='1' || key== '2' || key=='3' || key=='4' || key=='5' || key=='6' || key=='7' || key=='8' || key=='9' || key=='0')
{
LinkedIterationFields[yJIRxDo].Label =  LinkedIterationFields[yJIRxDo].Label + char(key);
}	
LinkedScrollBuffer.beginDraw();
LinkedIterationFields[yJIRxDo].displayLinked();
LinkedScrollBuffer.endDraw();
return;
}
}
catch(Exception e) { AppendLogFile("Iteration Textfield input error"); }	
if (key == ENTER)
{
QzQTRuy = false;
TextFields[yJIRxDo].Selected = false;
TextFields[yJIRxDo].Label =  TextFields[yJIRxDo].Label.replaceAll("[^\\x00-\\x7f]", ""); 
switch(yJIRxDo)
{
case 0: 
if (int(TextFields[yJIRxDo].Label) > 255) TextFields[yJIRxDo].Label = "255";
slBNIJT[DIWlYpw].SlideValues[lXrpjlY] = int(TextFields[yJIRxDo].Label);
MenuTabs[1].refresh();
break;
case 1:
MHixUhI = int(TextFields[yJIRxDo].Label);
if (MHixUhI > 32)
{
MHixUhI = 32;
TextFields[yJIRxDo].Label = "32";
}
MenuSliders[0].Value =  MHixUhI;
MenuSliders[0].display();
MenuTabs[0].refresh();
break;
case 2:
ezSfeSN = int(TextFields[2].Label);
if (ezSfeSN > 512) 
{
ezSfeSN = 512;
TextFields[2].Label = ""+ezSfeSN;
}
break;
case 3: 
slBNIJT[zDLkfrA].UserID = TextFields[3].Label;
vLvSrbC = false;
DrawUserSeqIconBuffer(zDLkfrA);
TextFields[3].Label = "Enter Text";
MenuTabs[2].refresh();
break;
case 4: 
if (int(TextFields[4].Label) == 0 || int(TextFields[4].Label) > device.Channels)
TextFields[4].Label = "1";
TextFields[5].Label = ""+ControlSliders[int( TextFields[4].Label)-1].Value;
break;
case 5: 
int temp = int(TextFields[5].Label);
if(LiveControlCheckBox[3].Selected == true)  {
if (temp > 65535) temp = 65535;
}
else {
if (temp > 255) temp = 255;
}
ControlSliders[int( TextFields[4].Label)-1].Value = temp;
hkZcTKJ = true;
break;
case 6: 
if (int(TextFields[yJIRxDo].Label) > 255) TextFields[yJIRxDo].Label = "255";
slBNIJT[DIWlYpw].SpeedValues[lXrpjlY] = int(TextFields[yJIRxDo].Label);
break;
case 10: 
if(int(TextFields[10].Label) > ColorSelectorSliders[0].Maximum) TextFields[10].Label = ""+ColorSelectorSliders[0].Maximum; 
SliderPointer.Value = int(TextFields[10].Label); 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
break;  
case 11: 
wLEAfPX = 5; 
break;
case 12: 
if(int(TextFields[12].Label) < 1) TextFields[12].Label = ""+1;
if(device.BasicVersion > 0) 
{
if(int(TextFields[12].Label) > 0xFF) TextFields[12].Label = ""+0xFF;
}
else
{
if(int(TextFields[12].Label) > 0xFFFF) TextFields[12].Label = ""+0xFFFF;
}
slBNIJT[DIWlYpw].Speed = int(TextFields[12].Label);
SequenceSpeedSlider.Value = int(TextFields[12].Label);
MenuTabs[2].refresh();
break;
case 13: 
if(int(TextFields[13].Label) > 7) TextFields[13].Label = "7";		  
ZtOnJEO = int(TextFields[13].Label);
break;	
case 14:
if (int(TextFields[14].Label) > 100) 
{
TextFields[14].Label = "100";
}		
break;		
} 
return;
}  
else if (key == BACKSPACE) 
{
try {
AppendLogFile("Trying");
TextFields[yJIRxDo].Label = TextFields[yJIRxDo].Label.substring(0, TextFields[yJIRxDo].Label.length()-1);
}
catch(Exception e) { }	
TextFields[yJIRxDo].display();
}		
else if (key=='1' || key== '2' || key=='3' || key=='4' || key=='5' || key=='6' || key=='7' || key=='8' || key=='9' || key=='0')
{
TextFields[yJIRxDo].Label =  TextFields[yJIRxDo].Label + char(key);
TextFields[yJIRxDo].display();
}
else if (yJIRxDo == 3) 
{
TextFields[yJIRxDo].Label =  TextFields[yJIRxDo].Label + char(key);
TextFields[yJIRxDo].display();
}	
return;
}
if (key == CODED) 
{
switch(keyCode)
{
case UP:
AppendLogFile("Up on "+SliderPointer);
SliderPointer.Value--;
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);
break;
case DOWN:
AppendLogFile("Down on "+SliderPointer); 
SliderPointer.Value++;    
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);
break;
case RIGHT:
AppendLogFile("Right on "+SliderPointer);
SliderPointer.Value++;
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);  
break;
case LEFT:
AppendLogFile("Left on "+SliderPointer); 
SliderPointer.Value--;    
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);	  
break;
}
}
if (key == 's')
{
SaveslBNIJTFile("saves/quicksave-"+hour()+"-"+minute()+"-"+day()+"-"+month()+".txt");
EBWUsXC = 3;
}
if (key == ESC) { key = 0; AppendLogFile("ESCAPE DISABLED"); }
}
void mouseReleased()
{
if(qAuRcYr == true){AppendLogFile("Done dragging #:"+SliderPointer.SetNumber); AHCacLc = 1000;}
qAuRcYr = false;
uJwNffD = false;
}
void mouseWheel(MouseEvent event) 
{
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);
try {	
float e = event.getAmount();
if(yrsmlGD >= 660 && yrsmlGD <= 660+140 && LWAPDwF >= 35 && LWAPDwF <= 35+570) 
{      
SequenceScrollBar.setValue(int(SequenceScrollBar.Value+e));
return;
} 
switch(LMORxyF)
{
case 1:
if(yrsmlGD >= 85 && yrsmlGD <= 85+570 && LWAPDwF >= 35 && LWAPDwF <= 35+475) 
{ 
AppendLogFile(LinkedScrollBar.Value+" : "+e);
if(slBNIJT[DIWlYpw].SeqMode == mLinked) LinkedScrollBar.setValue(int(LinkedScrollBar.Value+(e*33)));
else TimeLineScrollBar.setValue(int(TimeLineScrollBar.Value+((TimeLineBuffer.height/100)*e)));
AeQGRRm = TimeLineScrollBar.Value;
} 
break;
case 2:	
if(yrsmlGD >= 85 && yrsmlGD <= 85+180 && LWAPDwF >= 35 && LWAPDwF <= 35+580) 
{      
IndexScrollBar.setValue(int(IndexScrollBar.Value+e));
} 
break;
} 
}
catch(Exception ee) { AppendLogFile("Mousewheel ignored, would have errored"); }
} 
void FuncRecommendColorShift()
{	
for(int i=0;i<=PixelChipsetDD.numStrs+1;i++)
{
if(PixelChipsetDD.Labels[PixelChipsetDD.SelStr].indexOf(cPixelChipsetStrings[i])>=0)
{
InputModule[3].Label = "Select The Pixel Chipset:\n\n\nRecommended Color: "+cPixelChipsetColorID[i];
break;
}
} 
} 
class SpecHWModules
{
int IDnumber;
String Label;
int xpos;
int ypos;
int bWidth;
int bHeight;
boolean Enabled;
SpecHWModules(int iIDnumber, String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight)
{
IDnumber = iIDnumber;
Label = iLabel;
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
}
void display()
{
if(Enabled == false) return;
stroke(0);
strokeWeight(2);
fill(cBorderColor, 200);
rect(xpos, ypos, bWidth, bHeight);
noStroke();
textAlign(CENTER);
textSize(12);  
fill(0);
text(Label, xpos+5, ypos+10, bWidth-10, bHeight-10);  
switch(IDnumber)
{
case 0:	
HardwareButtons[0].display();		
break;		
case 1:	
break;		  
case 2:	
HardwareColSwapDD.display();	
if(HardwareColSwapDD.Selected == true)	DropDownPointer = HardwareColSwapDD;	
break;		  
case 3:	
PixelChipsetDD.display();	
if(PixelChipsetDD.Selected == true)	DropDownPointer = PixelChipsetDD;
break;				
case 4:	
HardwareButtons[2].display();	
break;			
case 5:
TextFields[2].display(); 
break;			
case 6:
DMXModesDD.display(); 
if(DMXModesDD.Selected == true)	DropDownPointer = DMXModesDD;			
break;	
case 7:
MasterModeDD.display();
if(MasterModeDD.Selected == true)	DropDownPointer = MasterModeDD;
break;
case 8:
HardwareCheckBox[0].display();
fill(0);
textAlign(LEFT);
text("16-Bit Serial", HardwareCheckBox[0].xpos+25 , HardwareCheckBox[0].ypos+15); 
BaudRateDD.display();	
if(BaudRateDD.Selected == true)	DropDownPointer = BaudRateDD;
break;
case 9:
LEDModeDD.display();
if(LEDModeDD.Selected == true)	DropDownPointer = LEDModeDD;
break;	
case 10:
DisplayModeDD.display();
if(DisplayModeDD.Selected == true)	DropDownPointer = DisplayModeDD;
break;	
case 11:
AutoDetectDD.display();	
if(AutoDetectDD.Selected == true)	DropDownPointer = AutoDetectDD;
break;			
case 12:
HardwareButtons[3].display();
break;			
case 13: 
AccMeterAutoModeDD.display();	
if(AccMeterAutoModeDD.Selected == true)	DropDownPointer = AccMeterAutoModeDD;
break;				
case 14: 
HardwareButtons[4].display();
break;
case 15: 
AccMeterTapDD.display();	
if(AccMeterTapDD.Selected == true)	DropDownPointer = AccMeterTapDD;
break;
case 16: 
PowerDownTimeOutDD.display();	
if(PowerDownTimeOutDD.Selected == true)	DropDownPointer = PowerDownTimeOutDD;
break;		
case 17: 
TextFields[15].display();
break;	
case 18: 
TextFields[16].display();
break;
case 19: 
HardwareCheckBox[1].display();	
fill(0);
textAlign(LEFT);
text("Enable", HardwareCheckBox[1].xpos-45 , HardwareCheckBox[1].ypos+15); 
break;		
}	
}
void InitPositions()
{
switch(IDnumber)
{
case 0:	
HardwareButtons[0].xpos = xpos+30;
HardwareButtons[0].ypos = ypos+55;
break;		
case 1:	
HardwareButtons[1].xpos = xpos+25;
HardwareButtons[1].ypos = ypos+55;	
break;		  
case 2:	
HardwareColSwapDD.xpos = xpos+10;			
HardwareColSwapDD.ypos = ypos+60;			
break;		  
case 3:	
PixelChipsetDD.xpos = xpos+10;		
PixelChipsetDD.ypos = ypos+25;		
break;				
case 4:	
HardwareButtons[2].xpos = xpos+60;
HardwareButtons[2].ypos = ypos+55;	
break;	
case 5:	
TextFields[2].xpos = xpos+20;
TextFields[2].ypos = (ypos+(bHeight))-50;				
break;				
case 6:
DMXModesDD.xpos = xpos+10;
DMXModesDD.ypos = (ypos+(bHeight))-40;			
break;			
case 7:
MasterModeDD.xpos = xpos+10;
MasterModeDD.ypos = (ypos+(bHeight))-40;	
break;			
case 8:
BaudRateDD.xpos = xpos+10;
BaudRateDD.ypos = (ypos+(bHeight))-52;	
HardwareCheckBox[0].xpos = xpos+10;
HardwareCheckBox[0].ypos = (ypos+(bHeight))-25;			
break;	
case 9:
LEDModeDD.xpos = xpos+10;
LEDModeDD.ypos = (ypos+(bHeight))-40;
break;	
case 10:
DisplayModeDD.xpos = xpos+10;
DisplayModeDD.ypos = (ypos+(bHeight))-40;
break;	
case 11:
AutoDetectDD.xpos = xpos+10;
AutoDetectDD.ypos = (ypos+(bHeight))-40;			
break;			
case 12:
HardwareButtons[3].xpos = xpos+5;
HardwareButtons[3].ypos = (ypos+(bHeight))-40;	
break;	
case 13: 
AccMeterAutoModeDD.xpos = xpos+10;		
AccMeterAutoModeDD.ypos = ypos+55;	
break;		
case 14: 
HardwareButtons[4].xpos = xpos+30;
HardwareButtons[4].ypos = ypos+45;	
break;
case 15: 
AccMeterTapDD.xpos = xpos+20;		
AccMeterTapDD.ypos = ypos+55;	
break;		
case 16: 
PowerDownTimeOutDD.xpos = xpos+10;
PowerDownTimeOutDD.ypos = (ypos+(bHeight))-40;	
break;
case 17: 
TextFields[15].xpos=xpos+35;
TextFields[15].ypos=ypos+55;		
break;	
case 18: 
TextFields[16].xpos=xpos+35;
TextFields[16].ypos=ypos+55;		
break;	
case 19: 
HardwareCheckBox[1].xpos=xpos+70;	
HardwareCheckBox[1].ypos=ypos+65;	
break;					
}	    
}
boolean over() 
{
if(Enabled == false) return false;  
if (yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
void PlaceTile()
{
if(InputModule[IDnumber].bWidth < ndWzZJi)
{
AppendLogFile("Module "+IDnumber+" with width of: "+InputModule[IDnumber].bWidth+" can fit at Y: "+fOVDUFW+", X: "+FbBzWRr+" with available: "+ndWzZJi);
InputModule[IDnumber].xpos = FbBzWRr;
InputModule[IDnumber].ypos = fOVDUFW;
FbBzWRr = 0;
fOVDUFW = 0;
ndWzZJi = 0;
}  
else if((DdSpzLs + InputModule[IDnumber].bWidth) < 660)
{
AppendLogFile("IDnumber: "+IDnumber+" : "+DdSpzLs);
InputModule[IDnumber].xpos = DdSpzLs;
DdSpzLs += (InputModule[IDnumber].bWidth+10);
InputModule[IDnumber].ypos = jQLgPRK;
}
else 
{
if((660 - DdSpzLs) > ndWzZJi)
{
FbBzWRr = DdSpzLs;
fOVDUFW = jQLgPRK;
ndWzZJi = 660 - DdSpzLs;
AppendLogFile("remaining Module Size: "+ndWzZJi);
}
jQLgPRK += 100;
InputModule[IDnumber].xpos = 90;
DdSpzLs = 90 + (InputModule[IDnumber].bWidth+10);
InputModule[IDnumber].ypos = jQLgPRK;
}
InputModule[IDnumber].Enabled = true;
InputModule[IDnumber].InitPositions();	  
}
}  
void BuildnZGATrb(int dataValue)
{
aMBxKxp++; 
MYEjGAS++; 
if (aMBxKxp >= device.EraseBlockSize)
{
delay(5); 
aMBxKxp = 0;
}
nZGATrb[kjvybLg] = byte(dataValue); 
kjvybLg++;
if(kjvybLg == 64)
{
kjvybLg = 0;
try {		
if(yFhUYmK == 0) myPort.write(nZGATrb); 
else if(yFhUYmK == 1) TCPClient.write(nZGATrb);
}
catch(Exception e)
{
AppendLogFile("Unable to Send Packet");	
}
AppendLogFile("BuildUSBPacket sent packet number "+xWhYcfF);
xWhYcfF++;
if(device.HardwareID == 160 || (device.HardwareID == 148 && device.FirmwareVersion == 1 && device.FirmwareRevision >= 5)) 
{	
if(aMBxKxp == device.CurrentBlockSize)
{
AppendLogFile("Waiting for ACK, SendCounter: "+aMBxKxp);
aMBxKxp = 0;
while(UPJfpbQ == false) 
{
delay(1);
}
UPJfpbQ = false; 
AppendLogFile("ACK RECEIVED FOR PACKET# "+xWhYcfF);
}
else delay(2); 
} 
}	
}	
void SendSingleDataChar(char passedValue)
{
if(yFhUYmK == 0) myPort.write(passedValue);
else if(yFhUYmK == 1) TCPClient.write(passedValue);
}
void SendSingleDataByte(int passedValue)
{
if(yFhUYmK == 0) myPort.write(passedValue);
else if(yFhUYmK == 1) TCPClient.write(passedValue);
}
void OpenTCP()
{
AppendLogFile("OpenTCP()");
try {
TCPClient.clear();
TCPClient.dispose();
TCPClient.stop();
}
catch(Exception e) { }
CloseCOMPort();	
try {
OmWQXCr = "Trying TCP";
TCPClient = new Client(this, vrXaZIu, DCrfRAK); 
if(TCPClient.active() == true) 
{
AppendLogFile("Connected to TCP Server at "+TCPClient.ip()+" on port 23");
yFhUYmK = 1; 
dyfVXdN = "TCP/IP";
OpenConnection();
}
else
{
TCPClient.stop();
if(DeviceConnect.Selected == false) 
{
OmWQXCr = "TCP Failed";
dyfVXdN = "None";
}
}
}
catch(Exception e)
{
AppendLogFile("Could Not Connect To TCP/IP Server");
}
} 
void CloseTCP()
{
AppendLogFile("CloseTCP()");
DeviceConnect.Selected = false;		
OmWQXCr = "Unconnected";
yFhUYmK = 0;
try {
TCPClient.clear();
TCPClient.dispose();
TCPClient.stop();
}
catch(Exception e) { }
} 
void CloseCOMPort()
{
AppendLogFile("CloseCOMPort() - Closing Port "+myPort);  	
DeviceConnect.Selected = false;		
OmWQXCr = "Unconnected";
for (int i=0; i < COMButtons.length;i++)	COMButtons[i].Selected = false;
try	 
{	
myPort.stop();
myPort.dispose();
}
catch(Exception e)
{
AppendLogFile("No Port To Close");
}	
}
void OpenCOMPort(String NameID)
{
AppendLogFile("OpenCOMPort() with "+NameID);
if(NameID.equals("TCP/IP"))
{
thread("OpenTCP");
return;
}
try {
myPort.stop();
myPort.dispose();     
}
catch(Exception e) { }
try 
{
for (int x =0; x != Serial.list().length; x++) 
{
if(NameID.equals(Serial.list()[x]))
{	
dyfVXdN = Serial.list()[x];
myPort = new Serial(this, dyfVXdN, 19200);
try {
for (int q =0; q != COMButtons.length; q++) COMButtons[q].Selected = false;	
COMButtons[x].Selected = true;	
}
catch(Exception e)	{	}	
AppendLogFile("Connected to "+dyfVXdN);
OpenConnection();
break;
}
else
{
AppendLogFile(Serial.list()[x]+" is not a Match for COM port in software.ini");		
}	
}	
}
catch(Exception e)
{
AppendLogFile("Could Not Open COM Port");
dyfVXdN = "None";
}
} 
void serialEvent(Serial myPort) 
{
BqCeyBf = pPucQLc;
pPucQLc = JQNPFti;
JQNPFti = sxOzTpa;
sxOzTpa = myPort.read();
DataRecieved(); 
}	
void TCPDataRecieved()
{
BqCeyBf = pPucQLc;
pPucQLc = JQNPFti;
JQNPFti = sxOzTpa;
sxOzTpa = TCPClient.read();
DataRecieved(); 
if(TCPClient.available() > 0) TCPDataRecieved();
}	
void DataRecieved()	
{
AppendLogFile("Received: "+sxOzTpa+"  Char: "+char(sxOzTpa));
if (XFdpqPd == true && JQNPFti == 'a' && sxOzTpa == '9')
{
XFdpqPd = false;
MuRkHZb = true;
ixQxYRX = 15;
SendSingleDataChar('n'); 
SendSingleDataChar('l');  
SendSingleDataChar('e');
SendSingleDataChar('d');  
SendSingleDataChar('9');   
SendSingleDataChar('9');
AppendLogFile("Sent Acknowledge");
}
else if (MuRkHZb == true  && JQNPFti == 'f' && sxOzTpa == '0')
{
AppendLogFile("Cmd Acknowledged, Sending - CmdByte: "+xhPzZot+" : "+hgwvVkk[0]+" : "+hgwvVkk[1]+" : "+hgwvVkk[2]+" : "+hgwvVkk[3]);
MuRkHZb = false;
SendSingleDataByte(xhPzZot); 
SendSingleDataByte(hgwvVkk[0]);  
SendSingleDataByte(hgwvVkk[1]);   
SendSingleDataByte(hgwvVkk[2]);  
SendSingleDataByte(hgwvVkk[3]); 
switch(xhPzZot)
{
case 1:	
PEMuQZm = true;
SendConfigurations();	
PEMuQZm = false;
break;
case 4: 
QXWMJZB = true;
break;
case 60:	
if(hgwvVkk[0] == 1) mBQOSqm = true; 
else if(hgwvVkk[0] == 0) mBQOSqm = false; 
break;
case 75: 
PEMuQZm = true;
OefqCkP = slBNIJT[cAkjvcj].Length;   
thread("SendHardwarePreview"); 
break;		
case 100: 
PEMuQZm = true;
if(device.BasicVersion > 0) thread("SendLegacyData"); 
else thread("FullUpload");
MYEjGAS = 0; 
break;
}	
}
else if (QXWMJZB == true)
{
AppendLogFile("Counter: "+PoeHNaw);
switch(PoeHNaw)
{
case 0:
UCUaKHp = device.HardwareID; 
device.HardwareID = sxOzTpa;
break;      
case 1:
device.HardwareVersion = sxOzTpa;
break;
case 2:
device.FirmwareVersion = sxOzTpa;
break;
case 3:
device.FirmwareRevision = sxOzTpa;
QXWMJZB = false;
hdESbSC = true;
OmWQXCr = "Connected";
DeviceConnect.Selected = true; 
SaveSoftwareConfigFile();	
try {
LoadDeviceFile();
String temp = cRevisionIDstr[device.FirmwareRevision]; 
}
catch(Exception e) { AppendLogFile("Possibly bad IDs, try again"); EBWUsXC = 16; }
if(device.FirmwareVersion > 100) wLEAfPX = 11; 
break;
}  
PoeHNaw++;
}
else if(OoJfuuV == true)
{
if(JQNPFti == 'C' && sxOzTpa == 'S')
{
AppendLogFile("CONFIG ACK RECEIVED");
OoJfuuV = false;
EBWUsXC = 1;
}
}
else if(PEMuQZm == true)
{
if(BqCeyBf == 'z' && pPucQLc == 'A' && JQNPFti == 'c' && sxOzTpa == 'k')
{
UPJfpbQ = true;
AppendLogFile("PACKET ACKNOWLEDGED");
}
}	
} 
void RequestCommand()
{
try {
SendSingleDataChar('N'); 
SendSingleDataChar('L');  
SendSingleDataChar('E');   
SendSingleDataChar('D');  
SendSingleDataChar('1');   
SendSingleDataChar('1');
XFdpqPd = true; 
ixQxYRX = 15;
}
catch(Exception e)
{
AppendLogFile("Port Not Open, Or Unable to Send"); 
XFdpqPd = false;
CloseCOMPort();
EBWUsXC = 8;
}
} 
void OpenConnection()
{
AppendLogFile("Attempting Connection");
xhPzZot = 4; 
hgwvVkk[0] = 0;
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
hdESbSC = false;
PoeHNaw = 0;
RequestCommand();
}
void RequestToSendPreview()
{
AppendLogFile("RequestToSendPreview()");
SaveslBNIJTFile("saves/tempSave.txt");
AppendLogFile("Dragged Sequence Length: "+slBNIJT[cAkjvcj].Length+" : Device HPV Space: "+device.HPVSpace);
xWhYcfF = 0; 
if(slBNIJT[cAkjvcj].SeqMode == mLinked || slBNIJT[cAkjvcj].Length > device.HPVSpace) 
{	  
EBWUsXC = 5; 
return; 
}
device.CurrentBlockSize = device.HPVBlockSize;
xhPzZot = 75; 
hgwvVkk[0] = ((ceil((float)slBNIJT[cAkjvcj].Length/device.CurrentBlockSize)+1) >> 8) & 0xFF; 
hgwvVkk[1] = (ceil((float)slBNIJT[cAkjvcj].Length/device.CurrentBlockSize)) & 0xFF; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
AppendLogFile("Expected HPV Packets: "+ceil((float)slBNIJT[cAkjvcj].Length/device.CurrentBlockSize)+1);
RequestCommand();
}
void RequestConfigurationUploadType2()
{
AppendLogFile("RequestConfigurationUploadType2() for Basic Version Type 2");
xhPzZot = 1; 
hgwvVkk[0] = 0; 
switch(PowerDownTimeOutDD.SelStr) 
{
case 0: 
hgwvVkk[0] = 0x00;
break;
case 1: 
hgwvVkk[0] = 0x01;
break;
case 2: 
hgwvVkk[0] =  0x02;
break;
case 3: 
hgwvVkk[0] = 0x03;
break;
}	
OoJfuuV = true;
ixQxYRX = 15;
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
}
void RequestConfigurationUpload()
{
AppendLogFile("RequestConfigurationUpload()");
xhPzZot = 1; 
hgwvVkk[0] = 0; 
hgwvVkk[1] = 0; 
hgwvVkk[2] = 0;  
hgwvVkk[3] = 0;  
RequestCommand();
}
void RequestFullUpload()
{
AppendLogFile("RequestFullUpload() "+YsOnDkT);
if(YsOnDkT == -1)
{
EBWUsXC = 15; 
return;
}
SaveslBNIJTFile("saves/tempSave.txt");
OefqCkP = 0; 
for (int i = 0; i != YsOnDkT+1; i++) 
{	
try { 	
CheckStartVals(i);
if(slBNIJT[JzvVShV[i]].StartValError == true && KUNEdsh == false)
{
AppendLogFile("Start Values for "+JzvVShV[i]+" are bad");
if(slBNIJT[JzvVShV[i]].SeqMode == mPOV) 
{
ResetStartValuesCommon(JzvVShV[i]);
AppendLogFile("===================POV Start Values Reset==================");	
break;
}
if(slBNIJT[JzvVShV[i]].SeqMode == mLinked) break; 
wLEAfPX = 7;
hoGoqRP = JzvVShV[i];
return;
} 
} 
catch(Exception e)	{
AppendLogFile("Some sort of error checking start values for"+JzvVShV[i]);
}
}
KUNEdsh = false;
for (int q = 1; q != slBNIJT.length; q++) 
{
slBNIJT[q].LinkerUtilized = false;
slBNIJT[q].assignedIDNum = 255;
slBNIJT[q].assignedLinkedIDNum = 255;
slBNIJT[q].IDassigned = false;
}
int offsetVar = 0;	
for (int i = 0; i != 32; i++) 
{	 	
if(JzvVShV[i] < 255 && slBNIJT[JzvVShV[i]].IDassigned == false)
{
slBNIJT[JzvVShV[i]].LinkerUtilized = true;
slBNIJT[JzvVShV[i]].assignedIDNum = i - offsetVar;
slBNIJT[JzvVShV[i]].IDassigned = true;
OefqCkP += slBNIJT[JzvVShV[i]].Length;
} 
else if(JzvVShV[i] < 255 && slBNIJT[JzvVShV[i]].IDassigned == true)
{	
offsetVar++;	
}
else if(JzvVShV[i] > 255) 
{
offsetVar++;		
}
else
{
label:
for (int q = 1; q != slBNIJT.length; q++)
{
if(slBNIJT[q].SeqMode == mLinked && slBNIJT[q].LinkerUtilized == true)
{	
for (int yy = 0; yy != slBNIJT[q].SeqFrameAmount; yy++)
{
if(slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized == false && slBNIJT[slBNIJT[q].DataFrames[0][yy]].IDassigned == false)
{	
AppendLogFile("One yet to be linked, SoftID: "+slBNIJT[q].DataFrames[0][yy]+" will be "+(i - offsetVar)+" instead of "+(i));
slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized = true;
slBNIJT[slBNIJT[q].DataFrames[0][yy]].assignedIDNum = i - offsetVar;
slBNIJT[slBNIJT[q].DataFrames[0][yy]].IDassigned = true;
OefqCkP += slBNIJT[slBNIJT[q].DataFrames[0][yy]].Length;
break label;
}	
}
}	
}	
}
} 
for (int q = 1; q != slBNIJT.length; q++) AppendLogFile(q+" : assigned: "+slBNIJT[q].assignedIDNum+" : Utilized: "+slBNIJT[q].LinkerUtilized);
AppendLogFile("Total Sequences Length in Bytes: "+OefqCkP);
xWhYcfF = 0; 
OefqCkP += device.IndexBlockSize; 
device.CurrentBlockSize = device.SeqMemoryBlockSize;	
AppendLogFile("RequestFullUpload() "+OefqCkP+" : MapPointer: "+YsOnDkT);
xhPzZot = 100; 
hgwvVkk[0] = ((ceil((float)OefqCkP/device.CurrentBlockSize)) >> 8) & 0xFF; 
hgwvVkk[1] = (ceil((float)OefqCkP/device.CurrentBlockSize)) & 0xFF; 
hgwvVkk[2] = YsOnDkT;  
hgwvVkk[3] = 0;  
RequestCommand();
AppendLogFile("ExpectedPackets: "+ceil((float)OefqCkP/device.CurrentBlockSize));
}
void BreakUSBValue(int passedValue)
{
switch(device.IndexMemoryModel)
{
case 0: 
BuildnZGATrb(passedValue); 
BuildnZGATrb((passedValue>>8)); 
if(device.FillUpperData == true)BuildnZGATrb(0); 
break;
case 1: 
BuildnZGATrb(passedValue); 
BuildnZGATrb((passedValue>>8)); 
if(device.FillUpperData == true)BuildnZGATrb(0); 
BuildnZGATrb((passedValue>>16)); 
BuildnZGATrb((passedValue>>24));
if(device.FillUpperData == true)BuildnZGATrb(0); 
break;
} 
} 
void FullUpload()
{
AppendLogFile("FullUpload() - Sending Sequences");
int tempAdr = 0;
aMBxKxp = 0;
MYEjGAS = 0;
boolean tempExclusion = false;
for (int i = 1; i != slBNIJT.length; i++) 
{
slBNIJT[i].LinkerUtilized = false;
slBNIJT[i].assignedLinkedIDNum  = 255;
}
printArray(JzvVShV);
int[] tempArray = new int[32]; 
for (int i = 0; i != 32; i++) 
{
AppendLogFile("Main Loop Iteration: "+i);
if(JzvVShV[i] == 1000) 
{
BreakUSBValue(0xFFFD);
tempArray[i] = 0xFFFD;
}	
else if(JzvVShV[i] == 1001) 
{
BreakUSBValue(0xFFFE);			
tempArray[i] = 0xFFFE;			  
}		  
else if(JzvVShV[i] != 255)
{
AppendLogFile("Map Build: "+i+" : "+JzvVShV[i]+" : "+tempAdr);
if(slBNIJT[JzvVShV[i]].LinkerUtilized == true) 
{
BreakUSBValue(slBNIJT[JzvVShV[i]].MappedAdr);
tempArray[i] = slBNIJT[JzvVShV[i]].MappedAdr;
AppendLogFile("Sent "+slBNIJT[JzvVShV[i]].MappedAdr+" as tempAdr");
}
else
{	
BreakUSBValue(tempAdr);	
tempArray[i] = tempAdr;			
slBNIJT[JzvVShV[i]].LinkerUtilized = true;
slBNIJT[JzvVShV[i]].assignedLinkedIDNum = i;
slBNIJT[JzvVShV[i]].MappedAdr = tempAdr;
tempAdr += slBNIJT[JzvVShV[i]].Length;
}
} 
else
{
label2:		
for (int q = 1; q != slBNIJT.length; q++)
{		
if(slBNIJT[q].SeqMode == mLinked && slBNIJT[q].LinkerUtilized == true)
{	
AppendLogFile("Sequence in Index is a Linked "+q);
for (int yy = 0; yy != slBNIJT[q].SeqFrameAmount; yy++) 
{
if(slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized == false) 
{	
AppendLogFile("One hasn't been sent yet "+slBNIJT[q].DataFrames[0][yy]);
slBNIJT[slBNIJT[q].DataFrames[0][yy]].LinkerUtilized = true;
slBNIJT[slBNIJT[q].DataFrames[0][yy]].assignedLinkedIDNum = i;
BreakUSBValue(tempAdr);	
tempArray[i] = tempAdr;							
AppendLogFile("Map Build B: "+i+" : "+JzvVShV[i] +" : "+tempAdr);
tempAdr += slBNIJT[slBNIJT[q].DataFrames[0][yy]].Length;
tempExclusion = true;
break label2;
}	
}
}	
}	
if(tempExclusion == false)
{
BreakUSBValue(0);	
}
tempExclusion = false;
} 
} 
if(device.HardwareID == 160) 
{
for (int q = 0; q != 64; q++) BuildnZGATrb(0x33);  
}
AppendLogFile("Sent "+MYEjGAS+" index bytes");
for (int q = 1; q != slBNIJT.length; q++) AppendLogFile("SoftSeq#: "+q+" - Assigned: "+slBNIJT[q].assignedIDNum+" - LinkerAssiD: "+slBNIJT[q].assignedLinkedIDNum);
int tempIDnum = 0;
for (int i = 1; i != slBNIJT.length; i++) 
{
AppendLogFile("Loop:  Seq: "+i+" : is: "+slBNIJT[i].assignedIDNum+" : Looking for:"+tempIDnum);
if(slBNIJT[i].assignedIDNum == tempIDnum)
{	
if(slBNIJT[i].SeqMode == mLinked)
{
PackSendLinked(i);
}
else	
{
CalculateDataFrameAmt(i); 
SendSequence(i);				
}
tempIDnum++;
i = 0; 
}
}	
AppendLogFile("TotalSent: "+MYEjGAS);     
AppendLogFile("Left to Send: "+(device.CurrentBlockSize - (aMBxKxp%device.CurrentBlockSize)));
while((float)(MYEjGAS%device.CurrentBlockSize) != 0)
{  
BuildnZGATrb(33); 
} 
AppendLogFile("Sequences Sent");
PEMuQZm = false;
}
public void SendHardwarePreview()
{
int SelSeq = cAkjvcj; 
AppendLogFile("SendHardwarePreview() with "+SelSeq);
aMBxKxp = 0;
MYEjGAS = 0;
AppendLogFile("HPV Length: "+slBNIJT[SelSeq].Length);
AppendLogFile("SeqAmt: "+slBNIJT[SelSeq].SeqFrameAmount+" DataAmt: "+slBNIJT[SelSeq].DataFrameAmount);
CalculateDataFrameAmt(SelSeq); 
SendSequence(SelSeq);
AppendLogFile("TotalSent: "+MYEjGAS);     
AppendLogFile("Left to Send: "+(device.CurrentBlockSize - (aMBxKxp%device.CurrentBlockSize)));
while((float)(MYEjGAS%device.CurrentBlockSize) != 0)
{
BuildnZGATrb(33); 
}
PEMuQZm = false;
} 
void SendSequence(int SelSeq)
{
AppendLogFile("SendSequence() "+SelSeq+"    Start SendCounterB="+MYEjGAS);
BuildnZGATrb(0); 
BuildnZGATrb(cDDPOVModeValues[slBNIJT[SelSeq].POVUsageMode]); 
BuildnZGATrb((byte)((slBNIJT[SelSeq].Speed >> 8) & 0xFF)); 
BuildnZGATrb((byte)(slBNIJT[SelSeq].Speed & 0xFF)); 
BuildnZGATrb((slBNIJT[SelSeq].DataSize >> 8) & 0xFF);
BuildnZGATrb(slBNIJT[SelSeq].DataSize & 0xFF);
BuildnZGATrb(slBNIJT[SelSeq].SeqFrameAmount);
BuildnZGATrb(slBNIJT[SelSeq].DataFrameAmount);
BuildnZGATrb(slBNIJT[SelSeq].DataType);
BuildnZGATrb(slBNIJT[SelSeq].SeqMode);
AppendLogFile("Connection() - Frame Amts: "+slBNIJT[SelSeq].DataFrameAmount+" : "+slBNIJT[SelSeq].DataFrameAmount );
float GlobalIntensity = (float)int(TextFields[14].Label) / 100;	
int tempData = 0; 
AppendLogFile("=========="+GlobalIntensity+"==============");
if(device.Bit16Capable == true)
{
AppendLogFile("Sending 16-bit data, SeqDataSize "+slBNIJT[SelSeq].DataSize);
if(slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mPOV)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{  
tempData = int(slBNIJT[SelSeq].DataFrames[0][i] * GlobalIntensity);
BuildnZGATrb(tempData); 
BuildnZGATrb(tempData>>8); 
}
}
else
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{  
tempData = int(slBNIJT[SelSeq].StartValues[i] * GlobalIntensity);
BuildnZGATrb(tempData); 
BuildnZGATrb(tempData>>8); 
}
}  
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(slBNIJT[SelSeq].SpecialFrameVar[i]);
}
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].DataFrameVar[i]);
}
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].FrameSpecial[i]); 
BuildnZGATrb(slBNIJT[SelSeq].FrameSpecial[i]>>8); 
}
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]); 
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]>>8); 
}
}
if (slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SpeedValues[i]); 
BuildnZGATrb(slBNIJT[SelSeq].SpeedValues[i]>>8); 
}
} 
if (slBNIJT[SelSeq].SeqMode == mGradient) 
{	  
AppendLogFile("16-BIT GRADIENT DATA FRAMES NOT TESTED BUT UPDATED");
for (int q=0; q != (slBNIJT[SelSeq].DataFrameAmount+1);q++)
{
for (int i=0; i != 4;i++)
{
tempData = int(slBNIJT[SelSeq].DataFrames[q][i]  * GlobalIntensity);
BuildnZGATrb(tempData); 
BuildnZGATrb(tempData>>8); 
} 
}
}
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{
for (int q=0; q != (slBNIJT[SelSeq].SeqFrameAmount+1);q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 30 ) 
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
tempData = int(slBNIJT[SelSeq].DataFrames[q][i]  * GlobalIntensity);
BuildnZGATrb(tempData); 
BuildnZGATrb(tempData>>8); 
} 
} 
}
}
else
{
AppendLogFile("Sending 16-bit dataframes: "+(slBNIJT[SelSeq].DataFrameAmount+1)+" : "+slBNIJT[SelSeq].DataSize);
for (int q=0; q != (slBNIJT[SelSeq].DataFrameAmount+1);q++)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
tempData = int(slBNIJT[SelSeq].DataFrames[q][i]  * GlobalIntensity);
BuildnZGATrb(tempData); 
BuildnZGATrb(tempData>>8); 
} 
}
}
AppendLogFile("Sent 16-bit data");
} 
else if(device.Bit16Processor == true)
{
AppendLogFile("Sending 8-bit data for 16-bit processor, SeqDataSize: "+slBNIJT[SelSeq].DataSize);
if(slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mPOV)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(slBNIJT[SelSeq].DataFrames[0][i]);
}
}
else
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].StartValues[i] * GlobalIntensity));
}
}
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{ 
BuildnZGATrb(slBNIJT[SelSeq].SpecialFrameVar[i]);
}
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++) 
{	  
BuildnZGATrb(slBNIJT[SelSeq].DataFrameVar[i]);
}
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++)
{
BuildnZGATrb(slBNIJT[SelSeq].FrameSpecial[i]); 
BuildnZGATrb(slBNIJT[SelSeq].FrameSpecial[i]>>8); 
}
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]); 
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]>>8); 
}
}
if (slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SpeedValues[i]); 
BuildnZGATrb(slBNIJT[SelSeq].SpeedValues[i]>>8); 
}
} 
if (slBNIJT[SelSeq].SeqMode == mGradient)
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
for (int i=0; i != 4;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}
} 
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{	
for (int q=0; q != (slBNIJT[SelSeq].SeqFrameAmount+1);q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 30 ) 
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
} 
}
}
else
{
for (int q=0; q != (slBNIJT[SelSeq].DataFrameAmount+1);q++)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{	
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}
}
}	
else
{
AppendLogFile("Sending 8-bit usage");  
if(slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mPOV)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[0][i] * GlobalIntensity));
}
}
else
{	
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].StartValues[i] * GlobalIntensity));
}
}  
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(slBNIJT[SelSeq].SpecialFrameVar[i]);
}
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].DataFrameVar[i]);
}
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++)
{
BuildnZGATrb(slBNIJT[SelSeq].FrameSpecial[i]);
}
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]);
}
}
if (slBNIJT[SelSeq].SeqMode == mCombo)
{
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount+1;i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SpeedValues[i]);
}
} 
if (slBNIJT[SelSeq].SeqMode == mGradient)
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
for (int i=0; i != 4;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}
}
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 30 ) 
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
} 
}
}
else
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
BuildnZGATrb(int(slBNIJT[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}
}
}	
} 
void PackSendLinked(int SelSeq)
{
AppendLogFile("PackSendLinked() : "+SelSeq);
BuildnZGATrb((byte)((slBNIJT[SelSeq].Length >> 8) & 0xFF)); 
BuildnZGATrb((byte)(slBNIJT[SelSeq].Length & 0xFF)); 
BuildnZGATrb(0); 
BuildnZGATrb(0); 
BuildnZGATrb(0); 
BuildnZGATrb(0);
BuildnZGATrb(slBNIJT[SelSeq].SeqFrameAmount);
BuildnZGATrb(slBNIJT[SelSeq].DataFrameAmount);
BuildnZGATrb(0); 
BuildnZGATrb(slBNIJT[SelSeq].SeqMode);
if(device.Bit16Capable || device.Bit16Processor)
{
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedIDNum); 
BuildnZGATrb((slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedIDNum)>>8); 
AppendLogFile("Linked SeqID: "+(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedIDNum)+" : Using: "+(slBNIJT[SelSeq].DataFrames[0][i]));
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SlideValues[i]); 
BuildnZGATrb((slBNIJT[SelSeq].SlideValues[i])>>8);
AppendLogFile("Iterations: "+slBNIJT[SelSeq].SlideValues[i]+" : Using: "+SelSeq);
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb(slBNIJT[SelSeq].SpecialFrameVar[i]); 
BuildnZGATrb((slBNIJT[SelSeq].SpecialFrameVar[i])>>8);
AppendLogFile("Transition: "+slBNIJT[SelSeq].SpecialFrameVar[i]+" : Using: "+SelSeq);
}
}
else
{
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedLinkedIDNum); 
AppendLogFile("Linked SeqID: "+(slBNIJT[slBNIJT[SelSeq].DataFrames[0][i]].assignedLinkedIDNum));
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb((byte)slBNIJT[SelSeq].SlideValues[i]); 
AppendLogFile("Iterations: "+slBNIJT[SelSeq].SlideValues[i]);
}
for(int i=0;i != slBNIJT[SelSeq].SeqFrameAmount; i++) 
{
BuildnZGATrb((byte)slBNIJT[SelSeq].SpecialFrameVar[i]);
AppendLogFile("Transition: "+slBNIJT[slBNIJT[SelSeq].DataFrameVar[i]].SpecialFrameVar[i]);
}
}	
} 
void SendConfigurations()
{
AppendLogFile("SendConfigurations()"); 
/*
#define fDisModeMSB ConfigFlags.b0 
#define fDisModeLSB ConfigFlags.b1
#define fLEDModeMSB ConfigFlags.b2 
#define fLEDModeLSB ConfigFlags.b3
#define fAutoDetectID ConfigFlags.b4 
#define fAutoDetect ConfigFlags.b5
#define f8or16Bit ConfigFlags.b6
#define fRS485Enable ConfigFlags.b7 
#define fMasterEnable Config2Flags.b0
#define fMaster16Bit ConfigFlags.bits.b9 
#define fBootLoaderVerified ConfigFlags.bits.b10 
#define fDisModeMSB ConfigFlags.bits.b0 
#define fDisModeLSB ConfigFlags.bits.b1
#define fLEDModeMSB ConfigFlags.bits.b2 
#define fLEDModeLSB ConfigFlags.bits.b3
#define fAutoDetectID ConfigFlags.bits.b4 
#define fAutoDetect ConfigFlags.bits.b5 
#define f8or16Bit ConfigFlags.bits.b6	
#define fRS485Enable ConfigFlags.bits.b7 
#define fMasterEnable ConfigFlags.bits.b8
#define fMaster16Bit ConfigFlags.bits.b9
#define fBootLoaderVerified ConfigFlags.bits.b10 
*/
int tempFlags = 0;
int temp2Flags = 0;
/*
#define DisplayModeFlag Flags3,0 ;0 = CountDown, 1 = Always On
#define DisplayDimFlag Flags3, 1 ; dim or not
#define AutoDetectFlag Flags3, 2 ;1 = Switchover, 0 = ignore
#define RS485Enable Flags3, 3 ;1 = 485 enabled with serial, 0 = 485 disabled with serial
#define SerialOrDMX Flags3, 4 ;0 = DMX, 1 = Serial
#define TransmitMode Flags3,5 ;1 = master, 0 = reception
#define MasterPartialFlag Flags3, 6 ;1 = Full Packets, 0 = Partial	
DE .0 ;Adr Hi
DE .1 ;Adr Lo
DE b'00100010' ;Flags3
DE .0 ;DMX Mode
DE .2 ;SettingNumber
DE .1 ;StandAloneMode, either 1 for sequences, 2 for hold, 3 for blank and hold
DE cPWMRate4 ;PWM Rate
DE .2 ;19200 default	
*/	
if(device.BasicVersion == 1)
{
AppendLogFile("Display: "+DisplayModeDD.SelStr);	
switch(DisplayModeDD.SelStr)
{
case 0: 
break;
case 1: 
tempFlags = tempFlags | 0x02;
break;
case 2: 
tempFlags = tempFlags | 0x01;
break;
case 3: 
tempFlags = tempFlags | 0x03;
break;
}
AppendLogFile("Master: "+MasterModeDD.SelStr);	
switch(MasterModeDD.SelStr)
{
case 0: 
break;
case 1: 
tempFlags = tempFlags | 0x60;	
break;
case 2: 
tempFlags = tempFlags | 0x20;	
break;	
} 
if(AutoDetectDD.numStrs == 3)
{
switch(AutoDetectDD.SelStr)
{
case 0: 
break;
case 1: 
temp2Flags = 0x01; 
break;
case 2: 
tempFlags = tempFlags | 0x10; 
tempFlags = tempFlags | 0x20; 
break;
case 3: 
tempFlags = tempFlags | 0x20; 
break;
}
}
else if(AutoDetectDD.numStrs == 2)
{
switch(AutoDetectDD.SelStr)
{
case 0: 
break;
case 1: 
tempFlags = tempFlags | 0x04; 
break;
}
} 
if(HardwareButtons[0].Selected)  tempFlags = tempFlags | 0x08;
if(HardwareButtons[2].Selected)  tempFlags = tempFlags | 0x10;
AppendLogFile("Flags: "+binary(tempFlags, 8));
SendSingleDataByte((int(TextFields[2].Label) >> 8) & 0xFF); 
SendSingleDataByte(int(TextFields[2].Label) & 0xFF); 
SendSingleDataByte(tempFlags & 0xFF); 
SendSingleDataByte(DMXModesDD.SelStr); 
SendSingleDataByte(BaudRateDD.SelStr); 
}
else if(device.BasicVersion == 2)
{
} 
else
{
AppendLogFile(DisplayModeDD.SelStr+" : "+LEDModeDD.SelStr);
switch(DisplayModeDD.SelStr)
{
case 0: 
break;
case 1: 
tempFlags = tempFlags | 0x01;
break;
case 2: 
tempFlags = tempFlags | 0x02;
break;
case 3: 
tempFlags = tempFlags | 0x03;
break;
}
AppendLogFile("THIS 1: "+tempFlags);
switch(LEDModeDD.SelStr) 
{
case 0: 
tempFlags = tempFlags | 0x08;
break;
case 1: 
tempFlags = tempFlags | 0x04;
break;
case 2: 
tempFlags = tempFlags | 0x0C;
break;
case 3: 
break;
}
AppendLogFile("THIS 2: "+tempFlags);
switch(AutoDetectDD.SelStr)
{
case 0: 
break;
case 1: 
tempFlags = tempFlags | 0x10; 
tempFlags = tempFlags | 0x20; 
break;
case 2: 
tempFlags = tempFlags | 0x20; 
break;
}
if(HardwareCheckBox[0].Selected && device.Serial16Bit) tempFlags = tempFlags | 0x40;
if(HardwareButtons[0].Selected)  tempFlags = tempFlags | 0x80;
AppendLogFile("THIS 3: "+tempFlags);
if(device.DMXMasterCapable == true && device.Bit16Capable == true) 
{
switch(MasterModeDD.SelStr)
{
case 0: 
break;
case 1: 
temp2Flags = temp2Flags | 0x01; 
temp2Flags = temp2Flags | 0x02; 
break;
case 2: 
temp2Flags = temp2Flags | 0x01; 
temp2Flags = temp2Flags | 0x02; 
temp2Flags = temp2Flags | 0x04; 
break;
case 3:	
temp2Flags = temp2Flags | 0x01; 
break;	
case 4:	
temp2Flags = temp2Flags | 0x01; 
temp2Flags = temp2Flags | 0x04; 
break;		
}
}	
else
{	
switch(MasterModeDD.SelStr)
{
case 0: 
break;
case 1: 
temp2Flags = temp2Flags | 0x01; 
temp2Flags = temp2Flags | 0x02; 
break;
case 2: 
temp2Flags = temp2Flags | 0x01; 
break;
}
}
AppendLogFile("THIS 4: "+temp2Flags);
if(device.AccelerometerMode > 0)
{
if(AccMeterAutoModeDD.SelStr > 0)	temp2Flags = temp2Flags | 0x08; 
if(HardwareButtons[4].Selected)	temp2Flags = temp2Flags | 0x10;
if(AccMeterTapDD.SelStr > 0) 		temp2Flags = temp2Flags | 0x20; 
}	
if(InputModule[19].Enabled == true && HardwareCheckBox[1].Selected == true) temp2Flags = temp2Flags | 0x40;
AppendLogFile("Flags: "+binary(tempFlags, 8));
AppendLogFile("Flags2: "+binary(temp2Flags, 8));
AppendLogFile((int(TextFields[2].Label) >> 8 & 0xFF)+" : "+(int(TextFields[2].Label) & 0xFF)+" : "+DMXModesDD.SelStr+" : "+BaudRateDD.SelStr+" : "+(tempFlags & 0xFF)+" : "+(temp2Flags & 0xFF));
SendSingleDataByte((int(TextFields[2].Label) >> 8) & 0xFF); 
SendSingleDataByte(int(TextFields[2].Label) & 0xFF); 
SendSingleDataByte(DMXModesDD.SelStr); 
SendSingleDataByte(BaudRateDD.SelStr); 
SendSingleDataByte(temp2Flags & 0xFF); 
SendSingleDataByte(tempFlags & 0xFF); 
if(device.SelPixelType > 0) 
{
SendSingleDataByte(PVvDSxb[PixelChipsetDD.SelStr]); 
}
if(device.GlobalColorShift == true)
{
SendSingleDataByte(HardwareColSwapDD.SelStr); 
}	
if(device.AccelerometerMode > 0)
{
SendSingleDataByte(cAccMeterShutOffVals[AccMeterAutoModeDD.SelStr]); 	
AppendLogFile("TimeOutVal: "+cAccMeterShutOffVals[AccMeterAutoModeDD.SelStr]);
SendSingleDataByte(AccMeterTapDD.SelStr);	
}
if(device.SelPixelType > 0) 
{
SendSingleDataByte(int(TextFields[15].Label)); 
}	
if(device.SequenceTransition == true) 
{
SendSingleDataByte(int(TextFields[16].Label)); 
}			
}
OoJfuuV = true;
ixQxYRX = 15;
AppendLogFile("Configs Sent");	
} 
void stop()
{
try {
myPort.dispose();
}
catch(Exception e) {
}
}
void draw() 
{
background(cBackgroundColor);
scale(ThUIWJw, ThUIWJw);
stroke(cBorderColor);
strokeWeight(2);
line(80, 30, 80, 515);
line(0, 30, 800, 30);
line(660, 0, 660, 600);
line(0, 150, 80, 150);
if(yFhUYmK == 1)
{
if (TCPClient.available() > 0)  TCPDataRecieved();
}
if (LMORxyF < 2)line(0, 515, 660, 515); 
else		line(80, 515, 80, 600); 
noStroke();  
if(LMORxyF  == 0 || LMORxyF  == 1)line(660, 440, 800, 440); 
image(fullNameImg, 3, 3, fullNameImg.width, fullNameImg.height);
image(sequencesImg, 675, 3, sequencesImg.width, sequencesImg.height);
PImage TempImg;
PImage TempImgTimeLine;
PImage TempImgIndex;
if (LMORxyF == 0 || LMORxyF == 1)  TempImg = SeqIconBuffer.get(0, SequenceScrollBar.Value*80, 140, 400); 
else	TempImg = SeqIconBuffer.get(0, SequenceScrollBar.Value*80, 140, 570); 
image(TempImg, 660, 35, TempImg.width, TempImg.height);  
textAlign(LEFT);
fill(cWorkspaceFont);
textSize(11);
if(yFhUYmK == 0) text("Serial Port:\n"+dyfVXdN, 5, 45);
else if(yFhUYmK == 1) text("TCP/IP:\n"+TCPClient.ip()+"\nPort: "+DCrfRAK, 5, 45);
text("Status:\n"+OmWQXCr, 5, 85);
DeviceConnect.display();
if (LMORxyF == 0 || LMORxyF == 1)
{
textSize(13);
text("Speed: ", 670, SequenceSpeedSlider.ypos-10);  
textSize(11);
text("Single - RGB - RGBW", 670, SeqCheckBoxes[0].ypos-5);  		
textLeading(20);
text("Slide Value:", 5, TextFields[0].ypos-5);
text("Color Swap:", 5, FrameOptionsDD.ypos-5);  
textAlign(CENTER);
text("Frame "+(lXrpjlY+1)+"\nOptions", 40, 165);
textSize(10);  
text("Frame Speed:", 38, TextFields[6].ypos-5);  
textAlign(LEFT);  
textSize(8);
fill(cWorkspaceFont);
text("Single-RGB-RGBW", 5, FrameCheckBoxes[0].ypos-10);
pushStyle();
strokeWeight(2);
stroke(cBorderColor);
line(660,435,800,435);
popStyle();
for (int i =0; i != CommonButtons.length; i++) CommonButtons[i].display();
for (int i =0; i != SeqCheckBoxes.length; i++) SeqCheckBoxes[i].display();
for (int i =0; i != FrameCheckBoxes.length; i++) FrameCheckBoxes[i].display();
for (int i =0; i != FrameOptionsButtons.length; i++) FrameOptionsButtons[i].display();
SequenceSpeedSlider.display();
FrameSpeedSlider.display();
TextFields[0].display(); 
TextFields[6].display(); 
TextFields[12].display(); 
noStroke();
if (slBNIJT[DIWlYpw].FrameSpecial[lXrpjlY] < 29)
{
fill(cBackgroundColor, 200);
rect(0, 430, 80, 85);
}
if (slBNIJT[DIWlYpw].SeqMode == mFade || slBNIJT[DIWlYpw].SeqMode == mGradient)
{
fill(cBackgroundColor, 200);
rect(0, 275, 75, 100);
}    
if (slBNIJT[DIWlYpw].SeqMode == mInstant)
{
fill(cBackgroundColor, 200);
rect(0, 240, 75, 35);
}  
if (slBNIJT[DIWlYpw].SeqMode != mCombo)
{
fill(cBackgroundColor, 200);
rect(0, 365, 75, 60);
}
if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
fill(cBackgroundColor, 200);
rect(0, 190, 75, 300); 
}		
if (slBNIJT[DIWlYpw].SeqMode == mPOV)
{
fill(cBackgroundColor, 200);
rect(0, 190, 75, 420); 
}				
if (FrameOptionsDD.Selected == true)	FrameOptionsDD.displayOpen();
else FrameOptionsDD.display();	
if(device.BasicVersion > 0) 
{	
fill(cBackgroundColor, 200);
rect(735,575,135,25); 
rect(735,520,62,27); 
rect(FrameOptionsDD.xpos,FrameOptionsDD.ypos,FrameOptionsDD.bWidth+5,FrameOptionsDD.bHeight+5);
}	
else if(slBNIJT[DIWlYpw].SeqMode == mPOV || slBNIJT[DIWlYpw].SeqMode == mLinked)
{
fill(cBackgroundColor, 200);	
rect(FrameOptionsDD.xpos,FrameOptionsDD.ypos,FrameOptionsDD.bWidth+5,FrameOptionsDD.bHeight+5);	
}
if(device.LinkedSupport == false)
{
fill(cBackgroundColor, 200);
rect(665,575,65,25); 
}	
} 
for (int i =0; i != MenuTabs.length; i++) MenuTabs[i].display();  
SequenceScrollBar.display();
if (qAuRcYr == true)
{
HandleSliders(true); 
} 
switch(LMORxyF)
{
case 0: 
DisplayFrameButtons();
if(DIWlYpw == 0)
{
textAlign(CENTER);
fill(cWorkspaceFontColor);
textSize(18);	
text("Please connect a device or\nload a device file to create a Sequence.", 360, 270);
textAlign(LEFT);
break;
}
if (PDBLtrJ == 3 || PDBLtrJ == 6)
{	
textAlign(CENTER);
fill(cWorkspaceFontColor);
textSize(18);
text("Frame is Set as Slide. Edit Variables on Left Side Menu.", 370, 270);
textAlign(LEFT);
}
else if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
textAlign(CENTER);
fill(cWorkspaceFontColor);
textSize(18);
text("Linked Sequence - Use Time Line Tab", 370, 270);
textAlign(LEFT);
}
else
{
if(EnableGroupMode.Selected == true)
{
for (int i =0; i != INyauIU; i++) LEDIcon[i].displayGroup();
}
else image(GraphicLayoutBuffer, 85, 35, GraphicLayoutBuffer.width, GraphicLayoutBuffer.height);
if(yAtBugw == true || GraphicFuncPaintButton.Selected == true)
{
fill(cMenuColor);
stroke(cBorderColor);
strokeWeight(2);
rect(0,150,80,365); 
line(0,220,80,220); 
line(0,315,80,315); 
line(0,415,80,415);		
noStroke();	
EnableGroupMode.display();
GraphicLayoutAllSame.display();
GraphicFuncPaintButton.display();
PaintRect.display();
CopyFrameButton.display();
PasteFrameButton.display();
EnableGroupMode.display(); 
TextFields[13].display(); 
GraphicLayoutColorGroup.display();
GradientDrawSlider.display();
GradientDrawRadialButton.display();
GradientDrawLinearButton.display();		
fill(0);
textSize(12);
text("Action ID:", TextFields[13].xpos-5, TextFields[13].ypos-5);
text("Close",40, 505);
text("Frame:",20, 165);
textSize(10);
text("Gradient Tools:",5, 330);		
text("Adjust: "+((float)GradientDrawSlider.Value/100), 5,GradientDrawSlider.ypos-5);			
}
} 
if(jgMnfDa == true) 
{	
stroke(255);
strokeWeight(2);	
switch(tVJyYzv)
{
case 1: 
line(jBfTygi,gSPmmNm,yrsmlGD, LWAPDwF); 
float maxDistX = dist(jBfTygi, 0, yrsmlGD, 0);
float maxDistY = dist(0, gSPmmNm, 0, LWAPDwF);
stroke(cBorderColor);
if(yrsmlGD > jBfTygi)
{
if(LWAPDwF > gSPmmNm)
{
line(jBfTygi,gSPmmNm, (jBfTygi - maxDistX), (gSPmmNm - maxDistY));
}
else
{
line(jBfTygi,gSPmmNm, (jBfTygi - maxDistX), (gSPmmNm + maxDistY));
}
}
else
{
if(LWAPDwF > gSPmmNm)
{
line(jBfTygi,gSPmmNm, (jBfTygi + maxDistX), (gSPmmNm - maxDistY));
}
else
{
line(jBfTygi,gSPmmNm, (jBfTygi + maxDistX), (gSPmmNm + maxDistY));
}
}
break;
case 2: 
line(jBfTygi,gSPmmNm,yrsmlGD, LWAPDwF); 
stroke(0);
xRcScjl = jBfTygi + (LWAPDwF - gSPmmNm);
Y1 = gSPmmNm + (jBfTygi - yrsmlGD);
X2 = jBfTygi + (gSPmmNm - LWAPDwF);
Y2 = gSPmmNm + (yrsmlGD - jBfTygi);
line(xRcScjl, Y1, X2, Y2); 
X3 = yrsmlGD + (LWAPDwF - gSPmmNm); 
Y3 = LWAPDwF + (jBfTygi - yrsmlGD); 
X4 = yrsmlGD + (gSPmmNm - LWAPDwF);
Y4 = LWAPDwF + (yrsmlGD - jBfTygi);
break;		
} 
noStroke();
} 
yrsmlGD = round((float)mouseX / ThUIWJw); 
LWAPDwF = round((float)mouseY / ThUIWJw);
for (int i =0; i != INyauIU; i++)
{
try {
if (LEDIcon[i].over())
{								
textSize(12);
fill(0);
text((i+1),yrsmlGD+1,LWAPDwF+1);
fill(255);
text((i+1),yrsmlGD,LWAPDwF);
}
}
catch(Exception e){}
}	
GraphicLayoutExpandOpt.display();
break;
case 1: 
if(DIWlYpw == 0)
{
textAlign(CENTER);
fill(cWorkspaceFontColor);
textSize(18);			
text("Please connect a device or\nload a device file to create a Sequence.", 360, 270);
textAlign(LEFT);
break;
}
if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
TempImgTimeLine = LinkedScrollBuffer.get(0, LinkedScrollBar.Value, 570, 475); 
image(TempImgTimeLine, 85, 35, TempImgTimeLine.width, TempImgTimeLine.height);
fill(cWorkspaceFontColor);
textSize(14);
text("Use the Add/Remove/Reset Buttons to edit the amount of Linked Sequences.\nClick the Icon(left), it will highlight red, then click the sequence to add.",90, 555);
LinkedScrollBar.display();
if(QFfuPVT == true)
{
stroke(255,0,0);
strokeWeight(3);
fill(0,0,0,0);
rect(145, (50+(KqHwDQs*100))-LinkedScrollBar.Value, 110, 70);
noStroke();
}
}
else if(slBNIJT[DIWlYpw].SeqMode == mPOV)
{
POVModeButton.display();
for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].display();			
image(povButtonsImgs[3], POVOptionButtons[3].xpos,POVOptionButtons[3].ypos);	
image(povButtonsImgs[2], POVOptionButtons[2].xpos,POVOptionButtons[2].ypos);	
image(povButtonsImgs[1], POVOptionButtons[1].xpos,POVOptionButtons[1].ypos);	
image(povButtonsImgs[0], POVOptionButtons[0].xpos,POVOptionButtons[0].ypos);		
textSize(14);
text(cPOVDescriptionsSecond[slBNIJT[DIWlYpw].molKaUt],90,550,520,100);
text(cPOVDescriptions[slBNIJT[DIWlYpw].molKaUt],90,530,520,100);
fill(255);
textSize(14);
text("Point of Vision(POV) Mode: ", 90,55);
textSize(12);
text("Image Width: "+POVGraphicBuffer.width+" Image Height: "+POVGraphicBuffer.height+"\nUsable Width:"+floor(yxtcfxi/MDmgrxQ)+" Usable Height: "+(GUOIdiy), 410, 50);
text("P.O.V. Usage Mode:\nAllows a gap/empty space to be placed between frames.\nMakes it look like a grid instead of streaks.", POVModeDD.xpos-10, POVModeDD.ypos-35);	
try
{
image(POVBuffer, 85, 150, 570, 360);
}
catch(Exception e)
{
AppendLogFile("Null Pointer on POVBuffer");
}
POVModeDD.display();
}	
else
{
StartValReset.display();
for (int i =0; i != TimeLineFrameButtons.length; i++) TimeLineFrameButtons[i].display();				
noStroke();
textFont(fNormal, 48);
textSize(14);
fill(255);	
if(slBNIJT[DIWlYpw].StartValError == true) text("Bad Start Value(s) has been detected, please adjust the purple indicator(s), press Reset, or press Generate for Gradients", 220, 40, 440, 100);
else text("Start Values allow a Color Channel to start at a selected position in the Sequence. Drag indicators to adjust.", 220, 40, 440, 100);				
TempImgTimeLine = TimeLineBuffer.get(0, AeQGRRm, 570, 410); 
image(TempImgTimeLine, cTLChBufX, cTLChBufY, TempImgTimeLine.width, TempImgTimeLine.height);
TimeLineScrollBar.display();
for (int q=0; q != slBNIJT[DIWlYpw].SeqFrameAmount+1;q++)
{
noStroke();
fill(255);
rect(85+35+(LodQDil*q), cTLChBufY-5, 1, 415); 
}
if (slBNIJT[DIWlYpw].SeqMode == mGradient)
{
fill(cWorkspaceFont);
textSize(16);
text("Gradient Menu:", 80, 540);
textSize(12);  
text("Gradient Steps: "+GradientStepsSlider.Value, GradientStepsSlider.xpos-125, 540);
if ((slBNIJT[DIWlYpw].SeqFrameAmount+1) != GradientRects.length) BuildGradientMenu();
for (int i =0; i != slBNIJT[DIWlYpw].SeqFrameAmount+1; i++) GradientRects[i].display();
GradientStepsSlider.display();
GradientGenerate.display();
GradientForward.display();
GradientReverse.display();
}
else   DisplayFrameButtons();
}
break;
case 2: 
switch(RVeDwhC)
{
case 0: 
TempImgIndex = ConnectionScrollBuffer.get(0, (IndexScrollBar.Value*80), 180, 580); 
image(TempImgIndex, 85, 35, TempImgIndex.width, TempImgIndex.height);
for (int i =0; i != ConnectionButtons.length; i++) ConnectionButtons[i].display();
IndexScrollBar.display();
HardwarePrevIcon.displaySq();
DMXSequenceIcon.displaySq();
SerialSequenceIcon.displaySq();
TextFields[14].display();
fill(cWorkspaceFont);   
textSize(18);
text("User Settings and Upload:", 300, 55);
text("Upload To Device:", 380, 440);	
textSize(14);
text("Hardware Preview:", HardwarePrevIcon.xpos-10, HardwarePrevIcon.ypos-10);		
text("Global Intensity(%):", 295, 535);		
textSize(12);
text("Select which sequences you wish to upload to the controller and the order they will be selected when pressing the device's button(s)\nUsage: Click and drag a Sequence Icon over to the Linker area, and drop it onto a already placed Icon or onto the Add an Icon", 300, 65, 360, 500);
text("Complete Your Color Sequences and Create the Index to the left. When ready, click 'Upload Sequences and Index' button. To upload Configurations(options on Hardware Tab), press the 'Upload Configurations' button.", 300, 450, 360, 500);
text("Note: Some devices do not support Hardware Preview and/or Serial/DMX Sequences. Attempting to drag or drop will result in no action.", 300,360,360,500);
text("(Intensity Affected By\nGlobal Setting Below)",495,255);
if(PEMuQZm==true)
{
fill(cBackgroundColor, 128);
rect(0,0,800,600);
stroke(cColButtonsHL);
strokeWeight(4);
fill(cBackgroundColor);
rect(250,260,300,80);
stroke(255);	
fill(0);	
strokeWeight(2);
rect(270,305,260,25);
textFont(fDigital, 48);
textSize(48);
fill(255);
text("Upload In Progress:", 265, 290);
textFont(fNormal, 48);
noStroke();
ggBWveR = (float)MYEjGAS / (float)(ceil((float)OefqCkP/(float)device.CurrentBlockSize) * device.CurrentBlockSize);
if(MYEjGAS > 10) 
{	
for (int i =0; i != int(ggBWveR*21); i++)
{
colorMode(HSB, 25);
fill(i, 25, 25);
rect(275+(i*12),310,8,16, 6);	
}	
colorMode(RGB, 255);
}
} 	
stroke(cBorderColor);
strokeWeight(2);
line(290, 410, 660, 410);		
noStroke();  
if(device.BasicVersion > 0 && PEMuQZm == false)
{
fill(cBackgroundColor, 128); 
rect(ConnectionButtons[4].xpos,ConnectionButtons[4].ypos,ConnectionButtons[4].bWidth,ConnectionButtons[4].bHeight);
}
if(device.HPVSpace == 0)
{
fill(cBackgroundColor, 128); 
rect(HardwarePrevIcon.xpos,HardwarePrevIcon.ypos,HardwarePrevIcon.bWidth,HardwarePrevIcon.bHeight);
}
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);
if (OcNYMio == true) DMXSequenceIcon.displayIconDrag(yrsmlGD, LWAPDwF);
if (deIRAFp == true) SerialSequenceIcon.displayIconDrag(yrsmlGD, LWAPDwF);
if (VvhyvBZ == true) 
{
slBNIJT[cAkjvcj].displayIconDrag(yrsmlGD, LWAPDwF);
textSize(14);
fill(255);
text("Length: "+slBNIJT[cAkjvcj].Length,yrsmlGD+1,LWAPDwF+86);
fill(200, 0, 0);			
text("Length: "+slBNIJT[cAkjvcj].Length,yrsmlGD,LWAPDwF+85);
}
for (int i =0; i != slBNIJT.length; i++)
{		
if(slBNIJT[i].over(5, 5+((i-1)*80)))
{							
textSize(14);
fill(255);
text("Length: "+slBNIJT[i].Length,yrsmlGD+1,LWAPDwF+1);
fill(200, 0, 0);			
text("Length: "+slBNIJT[i].Length,yrsmlGD,LWAPDwF);
}	
}
break;
case 1: 
textSize(14); 
for (int i = 0; i != ControlSliders.length; i++) 
{
ControlSliders[i].display();  
fill(cWorkspaceFont); 
text((i+1)+"", ControlSliders[i].xpos-25, ControlSliders[i].ypos+14);
}
fill(cWorkspaceFont);   
textSize(14);
text("Selected\nChannel:", 90, 55); 
text("Channel\nValue:", 220, 55); 
if(yxtcfxi > 208) text("Not all sliders can be displayed, use Color mode or use the text fields above.", 100, 590); 
if(device.Serial16Bit == true)
{	
text("16 Bit Mode:",  LiveControlCheckBox[3].xpos-30, LiveControlCheckBox[3].ypos-5);      
LiveControlCheckBox[3].display(); 
}
LiveControlClose.display();		
LiveControlToggle.display();
TextFields[4].display(); 
TextFields[5].display(); 
break;  
case 2: 
for (int i =0; i != 3; i++)  LiveControlCheckBox[i].display();    
fill(cWorkspaceFont);   
textSize(12);
text("Single - RGB - RGBW:", LiveControlCheckBox[0].xpos-10, LiveControlCheckBox[0].ypos-5);   
uDInFJD = yxtcfxi / QVhoOtU;
float RectThUIWJw = 1;
if(uDInFJD > 80 && uDInFJD < 99)
{
RectThUIWJw = 0.9;
}
else if(uDInFJD > 100 && uDInFJD <= 120)
{
RectThUIWJw = 0.8;
}			
else if(uDInFJD > 120 && uDInFJD <= 154)
{
RectThUIWJw = 0.7;
}		
else if(uDInFJD > 154 && uDInFJD <= 208)
{
RectThUIWJw = 0.6;
}
else if(uDInFJD > 208 && uDInFJD <= 303)
{
RectThUIWJw = 0.5;
}			
else if(uDInFJD > 303) RectThUIWJw = 0.38;
int column = 0;
int row = 0;
for (int i = 0; i != uDInFJD; i++) 
{
stroke(0);
strokeWeight(2);
textSize(16*RectThUIWJw);      
fill(cWorkspaceFont);
ControlRects[i] = new ColorRect(115, 90, round(40*RectThUIWJw), round(40*RectThUIWJw), 0, 0, 0, 0);
ControlRects[i].xpos = ControlRects[i].xpos + round((column*70)*RectThUIWJw);
ControlRects[i].ypos = ControlRects[i].ypos + round((row*50)*RectThUIWJw);
row++;
if((row*round(50*RectThUIWJw)) > (490-ControlRects[i].bHeight))
{
row = 0;
column++;
}
textAlign(RIGHT);
text(""+(i+1),ControlRects[i].xpos - (3*RectThUIWJw), ControlRects[i].ypos + (25*RectThUIWJw)  );  
textAlign(LEFT);				
switch(FmxWQSR)
{
case 0: 
ControlRects[i].Red = 0;
ControlRects[i].Green = 0;
ControlRects[i].Blue = 0;		
ControlRects[i].White = ControlSliders[(i*QVhoOtU)].Value; 
break;
case 1: 
ControlRects[i].Red = ControlSliders[(i*QVhoOtU)].Value;
ControlRects[i].Green = ControlSliders[(i*QVhoOtU)+1].Value;
ControlRects[i].Blue = ControlSliders[(i*QVhoOtU)+2].Value;
ControlRects[i].White = 0;
break;
case 2: 
ControlRects[i].Red = ControlSliders[(i*QVhoOtU)].Value;
ControlRects[i].Green = ControlSliders[(i*QVhoOtU)+1].Value;
ControlRects[i].Blue = ControlSliders[(i*QVhoOtU)+2].Value;
ControlRects[i].White = ControlSliders[(i*QVhoOtU)+3].Value;;
break;
}
ControlRects[i].display();
}
noStroke();
LiveControlClose.display();
LiveControlToggle.display();
break;  
case 3: 
textSize(18);
fill(cWorkspaceFont);
text("Color Swap:\n\n\nSelect Sequence:\n\n\n\nAlter Speed:\n\n\nInstant Stepping:\n\n\nFade Control:", 90, 60);
textSize(14);
text("Start Stalled:", StandaloneCheckBox[1].xpos-90, StandaloneCheckBox[1].ypos+15);
text("Ensure Sequence is Paused", 245, 275);
text("Sequence Number:", TextFields[7].xpos-40, TextFields[7].ypos-5);
text("Value:", TextFields[9].xpos, TextFields[9].ypos-5);
text("Value:", StandaloneSliders[1].xpos-45, StandaloneSliders[1].ypos+12); 
text("(1 - 65535)",  TextFields[9].xpos-5, TextFields[9].ypos+45);
text("Multiplier: "+StandaloneSliders[2].Value, StandaloneSliders[2].xpos-90, StandaloneSliders[2].ypos+12); 
text("All Stand-Alone Commands can be ran from custom user created programs. Any language that can interface with serial ports can work. See Command Sheet for details", 90, 425, 350, 350);
for (int i =0; i != StandaloneSliders.length; i++) StandaloneSliders[i].display();
for (int i =0; i != StandaloneButtons.length; i++) StandaloneButtons[i].display();
StandaloneCheckBox[1].display();
StandAloneClose.display();
TextFields[7].display();
TextFields[8].display();
TextFields[9].display();     
stroke(cBorderColor);
strokeWeight(2);
line(440, 30, 440, 600);
line(80, 100, 440, 100);    
line(80, 190, 440, 190);      
line(80, 255, 660, 255);         
line(80, 320, 440, 320);  
line(80, 410, 440, 410);       
line(80, 515, 80, 600);        
line(440, 100, 660, 100); 
StandAloneDD.display();          
break;
}
break; 
case 3: 
for (int i =0; i != SoftwareButtons.length; i++) SoftwareButtons[i].display();
for (int i =0; i != SoftwareCheckBox.length; i++) SoftwareCheckBox[i].display();
TextFields[3].display(); 
MenuSliders[0].display();
TextFields[1].display();    
TextFields[11].display(); 
UserChannelsSlider.display();
image(auroraLogoImg, 100, 45, 120, 140);
fill(cWorkspaceFont);
textSize(16);
textAlign(CENTER);
text("Click the function button then click on an Icon to the right.", 450, 195, 200, 240);
textAlign(LEFT);	
text("Graphic Layout Options:\n\nLEDs Per Channel: "+MHixUhI, 90, 420);  
text("User Channel Amount: "+yxtcfxi+" out of "+device.Channels, UserChannelsSlider.xpos, UserChannelsSlider.ypos-20);  
text("Written in Proccesing\nwww.Processing.org", 245, 60);
text("Software Version: "+cSoftwareV+"\nSoftware Revision: "+cRevisionIDstr[cSoftwareR], 245, 150);
text("Window Size:\n(or select a corner of the window and drag)", 90, 520);  
textSize(12);		
textAlign(RIGHT);	
text("Small:\n\nMedium:\n\nLarge:", 600, 450);  	
textAlign(LEFT);			
text("LED Icon Size:", 570, 430);  		
if(jgvztaS == 5 || jgvztaS == 6)
{
int strSize = PmuCQks.length();
String tempString = PmuCQks;
if (strSize > 26)  tempString = PmuCQks.substring(0, 12) + "......"+PmuCQks.substring(strSize-14);
text("Layout File Path: \n"+tempString+"", 314, 460);
}
else text("Layout File Path: \nNot Enabled", 314, 460);
textSize(12);	
text("Updates and Information: www.NLEDshop.com/nledaurora\nCopyright© 2015 Northern Lights Electronic Design, LLC", 95, 200);
image(fullNameRGB, 85, 235, 350, 90);
ShapeOptionsDD.display();	
stroke(cBorderColor);
strokeWeight(2);    
line(80, 400, 660, 400);
line(440, 30, 440, 400);	
line(80, 225, 440, 225);	
line(440, 145, 660, 145);	
line(80, 320, 440, 320);	
noStroke();
break;		
case 4: 
for (int i =0; i != COMButtons.length; i++) COMButtons[i].display();
float tempUsage = ((float)LdDeBhf/(float)device.DataSpace) * 100;
DeviceWebpage.display();
RequestConfigurations.display();
EnterBootloaderButton.display();
OpenTCPButton.display();
HardwareTabUploadConfigurations.display();
if(COMButtons.length != Serial.list().length) 
{
AppendLogFile("COM LENGTHS: "+COMButtons.length+" : "+Serial.list().length);	
InitCOMButtons();
}
if(device.BasicVersion > 0) 
{	
int tempHold = 0;
for (int i =1; i != slBNIJT.length; i++) tempHold = tempHold + slBNIJT[i].SeqFrameAmount;
tempUsage = tempHold / ((float)device.DataSpace / (float)device.Channels);	
tempUsage = tempUsage * 100;
}	
textSize(16);
fill(cWorkspaceFont);
textAlign(LEFT);
text(device.Name, 100, 55);
textSize(14); 
textLeading(20);
try {
if(device.FirmwareVersion > 100)
{
text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: Unverified-"+(device.FirmwareVersion-100)+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 90, 80);
}
else
{	
text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: "+device.FirmwareVersion+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 90, 80);  
}
}
catch(Exception e) { }
text("Usage: "+nfs(tempUsage, 1, 2)+"%", 290, 140);   
textAlign(CENTER); 	
text("TCP/IP: ", 40, 170);
text("Select\nCOM Port: ", 40, 220);
textSize(20);		
text("Device Configurations", 200, 180);
textAlign(LEFT); 
for (int i =0; i != InputModule.length; i++) InputModule[i].display();
if(DropDownPointer.Selected)	DropDownPointer.display();
stroke(cBorderColor);
strokeWeight(2);
line(80, 150, 660, 150); 
fill(0, 255, 0); 
rect(390, 125, 140, 15); 
fill(255, 0, 0);	
rect(390, 125, round(tempUsage*1.4), 15); 
break;
}
if (YyryBXy == true)    ColorSelector.display();
if (uJwNffD == true) DisplayDragIndicator();
if (hkZcTKJ == true)
{
if(LiveControlCheckBox[3].Selected == true) 
{
XsXSdbA = new byte[yxtcfxi*2];
int xx = 0;
for (int i =0; i != yxtcfxi; i++) 
{
XsXSdbA[xx] = (byte)((ControlSliders[i].Value >> 8)  & 0xFF); 
XsXSdbA[xx+1] = (byte)(ControlSliders[i].Value & 0xFF); 
xx += 2;
}
}
else
{
XsXSdbA = new byte[yxtcfxi];
for (int i =0; i != yxtcfxi; i++) 
{
XsXSdbA[i] = byte(ControlSliders[i].Value);
}		
} 
try {
if(yFhUYmK == 0) myPort.write(XsXSdbA);
else if(yFhUYmK == 1) TCPClient.write(XsXSdbA);
}
catch(Exception e)
{
AppendLogFile("Port Not Open");
}
hkZcTKJ = false;
}
if(XFdpqPd == true && ixQxYRX > 0)
{
ixQxYRX--;
if(ixQxYRX == 0)
{
AppendLogFile("Command Request Timed Out");
if(yFhUYmK == 0) CloseCOMPort();
else if(yFhUYmK == 1) CloseTCP();
EBWUsXC = 6;
UPJfpbQ = false;
PEMuQZm = false;
}	
}
else if(OoJfuuV == true && ixQxYRX > 0)
{
ixQxYRX--;
if(ixQxYRX == 0)
{
OoJfuuV = false;
AppendLogFile("WaitingForConfigAck not Acknowledged");
EBWUsXC = 7;
}	
}
if(EBWUsXC > 0)
{
pushStyle();
fill(cBackgroundColor, 128);
rect(0,0,800,600);	
textAlign(CENTER);	
textFont(fDigital, 48);
textSize(48);
stroke(cColButtonsHL);
strokeWeight(4);
fill(cBackgroundColor);
int tempStrW = int(textWidth(cNotificationText[EBWUsXC]))+20;
rect(360-(tempStrW/2),250,tempStrW,80);
fill(255);
text(cNotificationText[EBWUsXC], 360, 300);
popStyle();
QGxXgDU++;
if(QGxXgDU == 30) { EBWUsXC = 0;QGxXgDU = 0; }
}
if(wLEAfPX > 0)
{
fill(cBackgroundColor, 128);
rect(0,0,width,height);
fill(cBorderColor);
stroke(cColButtonsHL);
strokeWeight(3);
rect((800/2)-120,(600/2)-60, 240, 120, 20);
fill(0);
textSize(14);
textAlign(CENTER);
if(wLEAfPX == 2) text(cConfirmBoxText[wLEAfPX]+slBNIJT[zDLkfrA].UserID+"?", (800/2)-110, (600/2)-50, 220, 100); 
else text(cConfirmBoxText[wLEAfPX], (800/2)-110, (600/2)-50, 220, 100);
textAlign(LEFT);
ConfirmButtonYes.display();
ConfirmButtonNo.display();
}		
if (BkvHOVd != width || OqJQsXJ != height)
{
AppendLogFile("Window Resized to: "+width+" : "+height+" from "+BkvHOVd+" : "+OqJQsXJ);    
if(width < 480) { width = 480; BkvHOVd = width;}
if(displayHeight < (width/4) *3)
{
width = 1280; 
if(displayHeight < (width/4) *3)
{
width = 800; 
}
}
surface.setSize(width, (width/4) *3);	
insets = frame.getInsets();	
surface.setSize(width+(insets.left+insets.right),height+(insets.top+insets.bottom));	
OqJQsXJ = height;  
BkvHOVd = width;
SaveSoftwareConfigFile();	
ThUIWJw = (float)width / 800; 
}
}
void QuickSaveFunciton()
{
SaveslBNIJTFile("saves/quicksave.txt");
}
void LoadDeviceFile()
{
String BuildString = "devices/"+device.HardwareID+"-nled-contr-revs.txt"; 	
String[] lines = loadStrings(BuildString); 
String[] WorkString = new String[30]; 
BuildString = "";	
for(int i = 0; i != lines.length;i++)
{
WorkString = split(lines[i], '\t');
AppendLogFile(int(WorkString[0])+" : "+int(WorkString[1]));		
if(int(WorkString[0]) == device.FirmwareVersion)
{
if(int(WorkString[1]) < device.FirmwareRevision && i == 0)
{
AppendLogFile("Revison higher than local "+device.FirmwareRevision);
BuildString = "devices/"+device.HardwareID+"-"+int(WorkString[0])+"-"+int(WorkString[1])+"-nled-contr.txt";
break;
} 
if(int(WorkString[1]) == device.FirmwareRevision)
{
AppendLogFile("REVISION FOUND with "+i);
BuildString = "devices/"+device.HardwareID+"-"+int(WorkString[0])+"-"+int(WorkString[1])+"-nled-contr.txt";
break;
} 
} 
}
if(BuildString.equals(""))
{
AppendLogFile("Device File For V. & Rev. Not Found - Using Most Recent Version");	
lines = loadStrings("devices/"+device.HardwareID+"-nled-contr-revs.txt"); 
WorkString = split(lines[0], '\t');
BuildString = "devices/"+device.HardwareID+"-"+int(WorkString[0])+"-"+int(WorkString[1])+"-nled-contr.txt";	
}
AppendLogFile("LoadDeviceFile() - "+BuildString);	
lines = loadStrings(BuildString); 
int LinePointer = 1;
WorkString = split(lines[LinePointer++], '\t');
device.Name = WorkString[1];
LinePointer++;	
WorkString = split(lines[LinePointer++], '\t');
if(device.FirmwareVersion < int(WorkString[1]))
{
AppendLogFile("FIRMWARE OUTDATED "+int(WorkString[1])+" vs "+device.FirmwareVersion);
if(hdESbSC == true) 
{	
wLEAfPX = 8;
}
}
WorkString = split(lines[LinePointer++], '\t');
if(device.FirmwareRevision < int(WorkString[1]))
{
AppendLogFile("FIRMWARE REVISION OUTDATED "+int(WorkString[1])+" vs "+device.FirmwareRevision);
if(hdESbSC == true) 
{
wLEAfPX = 8;
}
}	
WorkString = split(lines[LinePointer++], '\t');
device.Channels = int(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.DataSpace = int(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.IndexBlockSize = int(WorkString[1]);
try { 	
device.HPVBlockSize = int(WorkString[2]);   
device.SeqMemoryBlockSize = int(WorkString[3]);   
}
catch(Exception e) 
{
AppendLogFile("Error loading block sizes, using single value");
device.CurrentBlockSize	= device.IndexBlockSize;
device.HPVBlockSize = device.CurrentBlockSize;   
device.SeqMemoryBlockSize = device.CurrentBlockSize;  	
}
WorkString = split(lines[LinePointer++], '\t');
device.EraseBlockSize = int(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.HPVSpace = int(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.LinkedSupport = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.CurrentCorrection = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.EvenDataFlag = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.Bit16Capable = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.Bit16Processor = boolean(WorkString[1]);  	
WorkString = split(lines[LinePointer++], '\t');
device.Serial16Bit = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.FillUpperData = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.GlobalColorShift = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.LEDDisplayCapable = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.LEDIndicatorCapable = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.RS485Capable = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.BasicVersion = int(WorkString[1]);      
WorkString = split(lines[LinePointer++], '\t');
device.SerialInput = boolean(WorkString[1]);     
WorkString = split(lines[LinePointer++], '\t');
device.AutoDetection = boolean(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.PowerDownTimer = boolean(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.AccelerometerMode = int(WorkString[1]);  	
WorkString = split(lines[LinePointer++], '\t');
device.SequenceTransition = boolean(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.IndexMemoryModel = int(WorkString[1]);  		
WorkString = split(lines[LinePointer++], '\t');
device.WebpageURL = WorkString[1];  	
WorkString = split(lines[LinePointer++], '\t');
device.DMXMasterCapable = boolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.DMXModeAmt =int( WorkString[1]);   
String tempDMXLabels[] = new String[device.DMXModeAmt];
if(device.DMXModeAmt > 0)
{	
for (int i = LinePointer; i != (LinePointer+device.DMXModeAmt);i++)
{
WorkString = split(lines[i], '\t');
tempDMXLabels[i-LinePointer] = WorkString[1];
}
}
device.DMXModeLabels = new String[device.DMXModeAmt];
device.DMXModeLabels = tempDMXLabels;
DMXModesDD.Labels = tempDMXLabels;
DMXModesDD.numStrs = device.DMXModeAmt;
LinePointer += device.DMXModeAmt;
WorkString = split(lines[LinePointer++], '\t');
device.SelPixelType = int( WorkString[1]);   
if(device.SelPixelType > 0)
{	
tempDMXLabels = new String[device.SelPixelType]; 
PVvDSxb = new int[device.SelPixelType];
for (int i = LinePointer; i != (LinePointer+device.SelPixelType);i++)
{
WorkString = split(lines[i], '\t');
tempDMXLabels[i-LinePointer] = WorkString[1];
PVvDSxb[i-LinePointer] = int(WorkString[2]);
}
PixelChipsetDD.Labels = tempDMXLabels;
PixelChipsetDD.numStrs = device.SelPixelType;	
}	
if(device.BasicVersion > 0)
{
switch(device.BasicVersion)
{
case 1:
device.BasicMaxSequences = 8;
device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
AppendLogFile("============"+device.BasicSeqLength+"================");
break;
case 2:
device.BasicMaxSequences = 32;
device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
break;		
}
}
UserChannelsSlider.Maximum = device.Channels;
UserChannelsSlider.Value = device.Channels;
if(device.DataSpace > 1000000) device.MemorySpaceString = nf((((float)device.DataSpace/1048576)),1,2)+"MB";
else device.MemorySpaceString = nf((((float)device.DataSpace/1024)),1,2)+"KB";	
if(device.DMXMasterCapable == true && device.Bit16Capable == true) 
{
MasterModeDD.Labels = cDDMasterModesMultiBit;
MasterModeDD.numStrs = cDDMasterModesMultiBit.length;	
}
if(UCUaKHp != device.HardwareID)yxtcfxi = device.Channels;
if(device.BasicVersion == 1)	
{
AutoDetectDD.Labels = cDDAutoDetectModesT2;
AutoDetectDD.numStrs = cDDAutoDetectModesT2.length;
}
if(device.Bit16Capable == true)
{
ColorSelectorSliders[0].Maximum = 65535;
ColorSelectorSliders[1].Maximum = 65535;
ColorSelectorSliders[2].Maximum = 65535;
ColorSelectorSliders[3].Maximum = 65535;
XKRcKWc = 65535;
}
else
{
ColorSelectorSliders[0].Maximum = 255;
ColorSelectorSliders[1].Maximum = 255;
ColorSelectorSliders[2].Maximum = 255;
ColorSelectorSliders[3].Maximum = 255;
XKRcKWc = 255;
}
if(device.BasicVersion > 0)
{
SequenceSpeedSlider.Maximum = 255;
}
else SequenceSpeedSlider.Maximum = 0xFFFF;
DdSpzLs = 90;
jQLgPRK = 190;
FbBzWRr = 0;
fOVDUFW = 0;
ndWzZJi = 0;
for (int i = 0; i != InputModule.length;i++) InputModule[i].Enabled = false;
if(device.SerialInput == true)	InputModule[8].PlaceTile();	
if(device.GlobalColorShift == true)	InputModule[2].PlaceTile();	
if(device.SelPixelType > 0) InputModule[3].PlaceTile();	 
switch(device.AccelerometerMode)
{
case 0:
break;
case 1:
InputModule[13].PlaceTile(); 
InputModule[14].PlaceTile();
InputModule[15].PlaceTile();		
break;
case 2:
break;	
} 
if(device.DMXModeAmt > 0)
{
InputModule[6].PlaceTile();	
InputModule[5].PlaceTile();	
}	
if(device.DMXMasterCapable)		InputModule[7].PlaceTile();	
if(device.LEDIndicatorCapable )	InputModule[9].PlaceTile();	
if(device.LEDDisplayCapable)	InputModule[10].PlaceTile();	
if(device.AutoDetection)	InputModule[11].PlaceTile(); 
if(device.HardwareID == 43)	InputModule[4].PlaceTile();	
if(device.RS485Capable == true) 	InputModule[0].PlaceTile();  
if(device.CurrentCorrection == true) 	InputModule[12].PlaceTile();  
if(device.PowerDownTimer == true) 	InputModule[16].PlaceTile();  
if(device.SelPixelType > 0) InputModule[17].PlaceTile();	 
if(device.SequenceTransition == true) InputModule[18].PlaceTile();
if(device.HardwareID == 160 || (device.HardwareID == 148 && device.FirmwareVersion == 1 && device.FirmwareRevision >= 5)) 
{		
InputModule[19].PlaceTile();
}
/*
InputModule[8].PlaceTile();	
InputModule[2].PlaceTile(); 
InputModule[3].PlaceTile();	 
InputModule[6].PlaceTile();	
InputModule[5].PlaceTile();	
InputModule[7].PlaceTile();	
InputModule[9].PlaceTile(); 
InputModule[10].PlaceTile(); 
InputModule[11].PlaceTile(); 
InputModule[4].PlaceTile(); 
InputModule[0].PlaceTile(); 
*/	
/*	
InputModule[0] = new SpecHWModules(0,"Serial RS-485 Enable:\n(Disable for TTL Serial)",0, 0,140, 90);
InputModule[1] = new SpecHWModules(1,"16-Bit DMX Master:\n(Disabled is Standard 8-bit)",0, 0,130, 90);
InputModule[2] = new SpecHWModules(2,"Select Correct RGB Order For Utilized Pixels",0, 0,120, 90);
InputModule[3] = new SpecHWModules(3,"Select which Pixel Type you would like to utilize",0, 0,140, 90);
InputModule[4] = new SpecHWModules(4,"Enable Serial Reception Instead of DMX reception. Auto-Detect is disabled during serial reception.",0,0, 200, 90);
InputModule[5] = new SpecHWModules(5,"DMX Address(1-512):\n(Enter Number)",0,0, 140, 90);
InputModule[6] = new SpecHWModules(6,"DMX Reception\nMode ID Number: "+device.SelDMXMode,0,0, 170, 90); 
InputModule[7] = new SpecHWModules(7,"DMX Master Mode:",0,0, 170, 90); 
InputModule[8] = new SpecHWModules(8,"Serial Baud Rate:\nID Number: "+device.SelBaudRate,0,0, 140, 90); 
InputModule[9] = new SpecHWModules(9,"LED Mode:",0,0, 120, 90); 
InputModule[10] = new SpecHWModules(10,"LED Display Mode:",0,0, 140, 90); 
InputModule[11] = new SpecHWModules(11,"Auto-Detect Option:",0,0, 155, 90); 
InputModule[12] = new SpecHWModules(12,"Open Current\nCorrection:",0,0, 140, 90); 
*/
}
void LoadConfigFile()
{
String[] lines = loadStrings("software.ini"); 
String[] WorkString = new String[5]; 
WorkString = split(lines[0], '\t');
int tempWidth = int(WorkString[1]);
WorkString = split(lines[1], '\t');
int tempHeight = int(WorkString[1]);
surface.setSize(tempWidth, tempHeight);
WorkString = split(lines[2], '\t');
if(dyfVXdN != WorkString[1])OpenCOMPort(WorkString[1]);
WorkString = split(lines[3], '\t');	
vrXaZIu = WorkString[1]; 
WorkString = split(lines[4], '\t');	
DCrfRAK = int(WorkString[1]);
}
void SaveSoftwareConfigFile()
{
AppendLogFile("SaveSoftwareConfigFile() - Saving software.ini");
String[] WorkString = new String[5]; 
WorkString[0] = "ScreenW\t" + width;
WorkString[1] = "ScreenH\t" + height;
WorkString[2] = "COMPort\t" + dyfVXdN;
WorkString[3] = "IP\t" + vrXaZIu;
WorkString[4] = "Port\t" + DCrfRAK;
saveStrings("software.ini", WorkString);
}
void fileSelected(File selection) 
{
if (selection == null) {
AppendLogFile("Window was closed or the user hit cancel.");
} 
else {
AppendLogFile("User selected " + selection.getAbsolutePath());
glYkgZR = selection.getAbsolutePath();
switch(zJypjQP)  
{
case 0: 
break;
case 1: 
try {
LoadslBNIJTFile(glYkgZR);
}
catch(Exception e)	{
wLEAfPX = 6;
}
break;
case 2: 
SaveslBNIJTFile(glYkgZR);
break;
case 3: 
OmWQXCr = "Emulated";
String[] lines = loadStrings(glYkgZR); 
device.HardwareID = int(split(lines[0], '\t')[1]);  
device.HardwareVersion = 0;
device.FirmwareVersion = 0;
device.FirmwareRevision = 0;		
LoadDeviceFile();
break;	  
case 4: 
LoadPOVFile(loadImage(glYkgZR));
break;  
case 5: 
MenuTabs[0].refresh(); 
PmuCQks = glYkgZR;
graphicImg = loadImage(PmuCQks);
break; 	
case 6: 
MenuTabs[0].refresh(); 
PmuCQks = glYkgZR; 
ImportCustomPatch();
break; 			
}
}
}
void LoadslBNIJTFile(String PassedLocation)
{
AppendLogFile("LoadUserSequencesFile() - Loading From: "+PassedLocation); 
String[] lines = loadStrings(PassedLocation); 
int sLines = 0;  
String[] WorkString= new String[300]; 
AppendLogFile("Loading from "+PassedLocation+" : Length: "+lines.length);
int SelSeq = 0;
WorkString = split(lines[sLines], '\t');
if(device.HardwareID != int(WorkString[4]) && device.HardwareID != 0)
{
AppendLogFile("Save file loaded different from currently connected hardware");
CloseCOMPort();
device.HardwareID = int(WorkString[4]);	
LoadDeviceFile();
wLEAfPX = 10; 
}
device.HardwareID = int(WorkString[4]);	
if(hdESbSC == false) LoadDeviceFile(); 
yxtcfxi = int(WorkString[5]); 
UserChannelsSlider.Value = yxtcfxi;
MHixUhI = int(WorkString[7]);
jgvztaS = int(WorkString[8]);
ShapeOptionsDD.SelStr = jgvztaS-1;
tGrissw = int(WorkString[9]);
SoftwareCheckBox[0].Selected = false;
SoftwareCheckBox[1].Selected = false;
SoftwareCheckBox[2].Selected = false;
SoftwareCheckBox[tGrissw].Selected = true;
OefqCkP =  int(WorkString[10]); 
if(jgvztaS == 6)
{
AppendLogFile("Using Graphic: "+WorkString[11]);
try {
PmuCQks = WorkString[11];
graphicImg = loadImage(PmuCQks); 
}
catch(Exception e)	{
AppendLogFile("Error Loading Image Shape, defaulting");
PmuCQks = "imagelayouts/default.png";
graphicImg = loadImage(PmuCQks); 
}
}	
else
{
PmuCQks = "imagelayouts/default.png";
graphicImg = loadImage(PmuCQks); 
}	
slBNIJT = new UserSequenceObj[OefqCkP+1];
for (int i = 0; i != slBNIJT.length; i++)
{
slBNIJT[i] = new UserSequenceObj("User Seq "+i, i, 0, 2, 2, 1, device.Channels, 1, 1, HoldChanSz, HoldChanSz, HoldChanSz, HoldFullSz, HoldFullSz, HoldFullSz, HoldDataFrames, false); 
}
for (SelSeq = 1; SelSeq != OefqCkP+1;SelSeq++) 
{
sLines++;
WorkString = split(lines[sLines], '\t');
slBNIJT[SelSeq].UserID = WorkString[1].replaceAll("[^\\x00-\\x7f]", ""); 
slBNIJT[SelSeq].Length = int(WorkString[2]);
slBNIJT[SelSeq].DataSize = int(WorkString[3]);
slBNIJT[SelSeq].SeqFrameAmount = int(WorkString[4]);
slBNIJT[SelSeq].DataFrameAmount = int(WorkString[5]);
slBNIJT[SelSeq].Speed = int(WorkString[6]);
slBNIJT[SelSeq].SeqMode = int(WorkString[7]);
slBNIJT[SelSeq].DataType = int(WorkString[8]);
if(slBNIJT[SelSeq].SeqMode == mPOV)
{
try {
slBNIJT[SelSeq].molKaUt = int(WorkString[9]) & 0xFF; 
slBNIJT[SelSeq].POVUsageMode = (int(WorkString[9]) >> 8); 
}
catch(Exception e)
{
slBNIJT[SelSeq].molKaUt = 0; 
}
}
else
{
try {
slBNIJT[SelSeq].gradientSteps = int(WorkString[9]); 
}
catch(Exception e)
{
slBNIJT[SelSeq].gradientSteps = 0; 
}	
}
slBNIJT[SelSeq].DataFrameVar = new int[device.Channels]; 
slBNIJT[SelSeq].SpecialFrameVar = new int[device.Channels];
slBNIJT[SelSeq].StartValues = new int[device.Channels];
slBNIJT[SelSeq].FrameSpecial = new int[cSoftwareMaxFrames]; 
slBNIJT[SelSeq].SlideValues = new int[cSoftwareMaxFrames]; 
slBNIJT[SelSeq].SpeedValues = new int[cSoftwareMaxFrames]; 
slBNIJT[SelSeq].DataFrames = new int[cSoftwareMaxFrames][device.Channels];
if(slBNIJT[SelSeq].SeqMode == mLinked)
{
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++)
{
slBNIJT[SelSeq].DataFrames[0][i] = int(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++)
{
slBNIJT[SelSeq].SlideValues[i] = int(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++)
{
slBNIJT[SelSeq].SpecialFrameVar[i] = int(WorkString[i+1]);
}   
}
else	
{
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].StartValues[i] = int(WorkString[i+1]);
}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].SpecialFrameVar[i] = int(WorkString[i+1]);
}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].DataFrameVar[i] = int(WorkString[i+1]);
}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++)
{
slBNIJT[SelSeq].FrameSpecial[i] = int(WorkString[i+1]);
}    
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo) 
{
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++)
{
slBNIJT[SelSeq].SlideValues[i] = int(WorkString[i+1]);
}
}
if ( slBNIJT[SelSeq].SeqMode == mCombo) 
{
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++)
{
slBNIJT[SelSeq].SpeedValues[i] = int(WorkString[i+1]);
}
}
if (slBNIJT[SelSeq].SeqMode == mGradient) 
{
int tempDataMult = 0;
switch(slBNIJT[SelSeq].DataType)
{	
case 0:
tempDataMult = 1;
break;
case 1:
tempDataMult = 3;
break;
case 2:
tempDataMult = 4;
break;
}	
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].DataFrames[q][i] = int(WorkString[(i%tempDataMult)+1]);
}
}
}
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 29 ) 
{
sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].DataFrames[q][i] = int(WorkString[i+1]);
}
}    
}
}
else
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
slBNIJT[SelSeq].DataFrames[q][i] = int(WorkString[i+1]);
}
}
}
}
}
LdDeBhf = 0; 
YsOnDkT = 0;
sLines++;
WorkString = split(lines[sLines], '\t');  
for (int q=0; q != 32;q++)
{
JzvVShV[q] = int(WorkString[q+1]);
if(JzvVShV[q] != 255) 
{				
if(JzvVShV[q] != 1001 && JzvVShV[q] != 1000)
{	
LdDeBhf += slBNIJT[JzvVShV[q]].Length;
}	
YsOnDkT++; 
}	
}
YsOnDkT--; 
IndexScrollBar.Value = 0;	
if(jgvztaS == 5 || jgvztaS == 6)
{	
sLines++;	
WorkString = split(lines[sLines], '\t'); 
IBzMEJI = new int[MHixUhI*yxtcfxi]; 
zppAzXD = new int[MHixUhI*yxtcfxi];
for (int q=0; q != (MHixUhI*yxtcfxi);q++)IBzMEJI[q] = int(WorkString[q+1]);
sLines++;	
WorkString = split(lines[sLines], '\t'); 
for (int q=0; q != (MHixUhI*yxtcfxi);q++)zppAzXD[q] = int(WorkString[q+1]);
sLines++;		
}
tDYkOHG = new int[MHixUhI*yxtcfxi];
try {
WorkString = split(lines[sLines], '\t'); 	
for (int q=0; q != (MHixUhI*yxtcfxi);q++)
{
try {	
tDYkOHG[q] = int(WorkString[q+1]); }
catch(Exception e) { 
tDYkOHG[q] = 0;
}
}
}
catch(Exception e) { AppendLogFile("No Group IDs to load"); }
if(OefqCkP > 0)
{	
DIWlYpw = 1; 
slBNIJT[DIWlYpw].Highlighted = true;
LoadSequence();
}	
DrawUserSeqIconBuffer(9999); 
DrawIndexScrollArea();	
GraphicLayoutBuild(); 
AppendLogFile("Loaded Sequences File");
}
void SaveslBNIJTFile(String PassedLocation)
{
AppendLogFile("SaveUserSequencesFile()  Saving To: "+PassedLocation);
ArrayList strs = new ArrayList(); 
String TempS="";
int SeqLength = 0;
int SelSeq = 0;
int holdHeaderLine = 0;
OefqCkP = 0; 
strs.add("\t"+cSoftwareV+"\t"+cSoftwareR+"\t"+month()+"/"+day()+"/"+year()+"\t"+device.HardwareID+"\t"+yxtcfxi+"\t"+device.Channels+"\t"+MHixUhI+"\t"+jgvztaS
+"\t"+tGrissw+"\t"+(slBNIJT.length-1)+"\t"+PmuCQks);
for (SelSeq = 1; SelSeq != slBNIJT.length; SelSeq++) 
{
SeqLength = 0;
if (slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mPOV)
{
AppendLogFile("Combo or Instant"); 
CalculateDataFrameAmt(SelSeq);
}
if (slBNIJT[SelSeq].SeqMode == mLinked)
{
}	
else
{
slBNIJT[SelSeq].DataFrameAmount = slBNIJT[SelSeq].SeqFrameAmount;
arrayCopy(slBNIJT[SelSeq].SpecialFrameVar, slBNIJT[SelSeq].DataFrameVar);
}
int holdLastValue = 0; 
if(slBNIJT[SelSeq].SeqMode == mPOV) holdLastValue = (slBNIJT[SelSeq].POVUsageMode << 8) | slBNIJT[SelSeq].molKaUt; 
else holdLastValue = slBNIJT[SelSeq].gradientSteps;
strs.add("\t"+slBNIJT[SelSeq].UserID+"\t"+SeqLength+"\t"+slBNIJT[SelSeq].DataSize+"\t"+slBNIJT[SelSeq].SeqFrameAmount+"\t"+
slBNIJT[SelSeq].DataFrameAmount+"\t"+slBNIJT[SelSeq].Speed+"\t"+slBNIJT[SelSeq].SeqMode+"\t"+slBNIJT[SelSeq].DataType+"\t"+holdLastValue);
SeqLength = 10; 
holdHeaderLine = (strs.size()-1); 
if(slBNIJT[SelSeq].SeqMode == mLinked)
{
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].DataFrames[0][i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS); 		
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].SlideValues[i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);	
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].SeqFrameAmount;i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].SpecialFrameVar[i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);		
}
else 
{
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].StartValues[i];
if(device.Bit16Capable) SeqLength += 2;
else SeqLength++; 
}
strs.add(TempS);   
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].SpecialFrameVar[i];
SeqLength++;
}
strs.add(TempS);   
TempS = "";
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].DataFrameVar[i];
SeqLength++;
}
strs.add(TempS);   
TempS = "";
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].FrameSpecial[i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);   
if(slBNIJT[SelSeq].SeqMode == mInstant || slBNIJT[SelSeq].SeqMode == mCombo) 
{
TempS = "";
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].SlideValues[i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);
}
if (slBNIJT[SelSeq].SeqMode == mCombo) 
{
TempS = "";
for (int i=0; i != (slBNIJT[SelSeq].SeqFrameAmount+1);i++) 
{
TempS = TempS+"\t"+slBNIJT[SelSeq].SpeedValues[i];
if(device.Bit16Capable || device.Bit16Processor) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);
}	
if (slBNIJT[SelSeq].SeqMode == mGradient)
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
TempS = "";  
for (int i=0; i != 4;i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].DataFrames[q][i];
if(device.Bit16Capable) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);
}
}
else if (slBNIJT[SelSeq].SeqMode == mCombo || slBNIJT[SelSeq].SeqMode == mInstant) 
{
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if(slBNIJT[SelSeq].FrameSpecial[q] < 30 ) 
{
TempS = "";  
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].DataFrames[q][i];
if(device.Bit16Capable) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);
} 
}
}
else
{
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
TempS = "";  
for (int i=0; i != slBNIJT[SelSeq].DataSize;i++)
{
TempS = TempS+"\t"+slBNIJT[SelSeq].DataFrames[q][i];
if(device.Bit16Capable) SeqLength += 2;
else SeqLength++;
}
strs.add(TempS);
}
}	
} 
String[]  WorkStringA = split((String)strs.get(holdHeaderLine), '\t');
WorkStringA[2] = Integer.toString(SeqLength);
String  WorkStringB = "";
for (int i = 1; i != 10; i++)  WorkStringB = WorkStringB+"\t"+WorkStringA[i];
strs.set(holdHeaderLine, WorkStringB);
OefqCkP = OefqCkP+SeqLength;
slBNIJT[SelSeq].Length = SeqLength;
}
TempS = "";  
for (int q=0; q != 32;q++) TempS = TempS+"\t"+JzvVShV[q];
strs.add(TempS);
if(jgvztaS == 5 || jgvztaS == 6)
{
AppendLogFile("saving LEDIcon Coords, length: "+INyauIU);
TempS = ""; 	
for (int i=0;i != (MHixUhI*device.Channels);i++)
{
try {	
TempS = TempS+"\t"+LEDIcon[i].xpos;
}
catch(Exception e)	{
TempS = TempS+"\t"+0;	
}
} 
strs.add(TempS);	
TempS = ""; 	
for (int i=0;i != (MHixUhI*yxtcfxi);i++)
{
try {	
TempS = TempS+"\t"+LEDIcon[i].ypos;
}
catch(Exception e)	{
TempS = TempS+"\t"+0;	
}
} 
strs.add(TempS);	
}
TempS = ""; 	
for (int i=0;i != (MHixUhI*yxtcfxi);i++)
{
try {	
TempS = TempS+"\t"+LEDIcon[i].GroupID;
}
catch(Exception e)	{
TempS = TempS+"\t"+0;	
}
} 
strs.add(TempS);			
String[] lines = new String[strs.size()]; 
for (int q=0; q != strs.size();q++)  
{
lines[q]=(String) strs.get(q);
if(q == 0) lines[q] += "\t"+OefqCkP; 
} 
String[]  ExtensionStripped = split(PassedLocation, '.');
saveStrings(ExtensionStripped[0]+".txt", lines);
} 
/*
if ( overCircle(circleX, circleY, circleSize) ) {
circleOver = true;
rectOver = false;
} 
boolean overCircle(int x, int y, int diameter) 
{
float disX = x - mouseX;
float disY = y - mouseY;
if (sqrt(sq(disX) + sq(disY)) < diameter/2 ) 
{
return true;
} 
else 
{
return false;
}
*/
void FillManualGradient(int rollingIDnumber, int maxDist)
{
float LocationVar = (256 * (slBNIJT[DIWlYpw].SeqFrameAmount+1)); 
float StepFactorH = LocationVar / ((float)rollingIDnumber / ((float)GradientDrawSlider.Value/100));
int FrameVarCurrent = 0; 
int FrameVarNext = 1; 
float StepFactor = 0; 
int HoldCurrent=0;
int HoldNext=0;	
AppendLogFile("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH+"  : rollingIDnumber"+(float)rollingIDnumber+"  : maxDist: "+(int)maxDist); 
LocationVar = 0;
for(int raidusVal = 1;raidusVal!= maxDist;raidusVal++) 
{
for(int i=0;i!=INyauIU;i++) 
{
if(mDPegwE[i] == raidusVal)
{
for(int q=0;q != MDmgrxQ;q++)
{
if (q == 0)
{
LocationVar += StepFactorH; 
if (LocationVar > 255)
{
LocationVar -= 256;    
if (FrameVarNext == (slBNIJT[DIWlYpw].SeqFrameAmount))
{
FrameVarNext = 0; 
FrameVarCurrent = (slBNIJT[DIWlYpw].SeqFrameAmount);
}
else
{
FrameVarNext++;
FrameVarCurrent++;	
if(FrameVarCurrent > slBNIJT[DIWlYpw].SeqFrameAmount) FrameVarCurrent = 0;
}
} 
}
int tempThis = (i*MDmgrxQ)+q;
StepFactor = (float)LocationVar / 256; 
HoldCurrent = slBNIJT[DIWlYpw].DataFrames[FrameVarCurrent][tempThis];
HoldNext = slBNIJT[DIWlYpw].DataFrames[FrameVarNext][tempThis];
if (HoldCurrent == HoldNext) 
{ 
slBNIJT[DIWlYpw].StartValues[tempThis] = HoldCurrent;
}  
else if (HoldCurrent < HoldNext)  
{
slBNIJT[DIWlYpw].StartValues[tempThis] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
}
else
{
slBNIJT[DIWlYpw].StartValues[tempThis] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
}
slBNIJT[DIWlYpw].SpecialFrameVar[tempThis] = FrameVarCurrent;
slBNIJT[DIWlYpw].DataFrameVar[tempThis] = FrameVarCurrent;
} 
} 
} 
} 
} 
void GenerateLinearGradient()
{
AppendLogFile("GenerateLinearGradient() "+LEDIcon.length+" with viewable: "+INyauIU);
mDPegwE = new int[LEDIcon.length]; 
for(int i=0; i!= INyauIU; i++) mDPegwE[i] = 0;
float maxDist = dist(jBfTygi, gSPmmNm, KqDBNTS, XYfpIvO);
int lineDist = int(maxDist);	
int rollingIDnumber = 1;	
float lerp1, lerp2, lerp3, lerp4;
float lerpFactor = 1/maxDist;
for(int i = 0; i!=lineDist;i++) 
{
lerp1 = lerp(xRcScjl, X3, i*lerpFactor);
lerp2 = lerp(Y1, Y3, i*lerpFactor);
lerp3 = lerp(X2, X4, i*lerpFactor);
lerp4 = lerp(Y2, Y4, i*lerpFactor);
line(lerp1, lerp2, lerp3, lerp4);
for(int q = 0; q!=INyauIU;q++) 
{
try {
if(((X2 - xRcScjl) * ((LEDIcon[q].ypos+35) - Y1) - (Y2 - Y1) * ((LEDIcon[q].xpos+85) - xRcScjl)) < 0) 
{
if(((lerp3 - lerp1) * ((LEDIcon[q].ypos+35) - lerp2) - (lerp4 - lerp2) * ((LEDIcon[q].xpos+85) - lerp1)) > 0) 
{
if(mDPegwE[q] == 0)
{
mDPegwE[q] = rollingIDnumber;
} 
} 
} 
}
catch(Exception e) { break; } 
} 
rollingIDnumber++;
} 
FillManualGradient(rollingIDnumber, int(maxDist)); 
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
}
void GenerateRadialGradient()
{
AppendLogFile("GenerateRadialGradient() "+INyauIU+" : "+LEDIcon.length);
mDPegwE = new int[LEDIcon.length]; 
for(int i=0; i!= INyauIU; i++) mDPegwE[i] = 0;
float maxDist = dist(jBfTygi, gSPmmNm, KqDBNTS, XYfpIvO);
jBfTygi -= 85; 
gSPmmNm -= 35;
int rollingIDnumber = 1;
int lineDist = int(maxDist);
float disX = 0; 
float disY = 0;	
for(int i = 1; i != lineDist; i++) 
{
for(int q=0;q!=INyauIU;q++)
{
try {
disX = jBfTygi - LEDIcon[q].xpos;
}
catch(Exception e) { break; } 
disY = gSPmmNm - LEDIcon[q].ypos;
if (sqrt(sq(disX) + sq(disY)) < i ) 
{
if(mDPegwE[q] == 0)
{
mDPegwE[q] = rollingIDnumber;
}
} 
}
rollingIDnumber++;
} 
FillManualGradient(rollingIDnumber, int(maxDist)); 
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
} 
void ResetStartValuesCommon(int passedSeq)
{
for (int i =0; i != slBNIJT[passedSeq].DataSize; i++)
{			
slBNIJT[passedSeq].SpecialFrameVar[i] = 0;
slBNIJT[passedSeq].DataFrameVar[i] = 0;
slBNIJT[passedSeq].StartValues[i] = slBNIJT[passedSeq].DataFrames[0][i];
}
} 
void AppendLogFile(String newData)
{
//FUNCTION REMOVED
} 
boolean WithinStartLimits(int value, int start, int end)
{
if(start >= end) 
{
if(value < end || value > start) return false;
else return true;	
}
else if(end > start) 
{
if(value < start || value > end) return false;
else return true;	
}	
return false;
} 
void LoadPOVFile(PImage POVImg)
{
AppendLogFile("Loading POV from "+POVImg);
int x = 0;
RkNigLx = POVImg.width;
GUOIdiy = POVImg.height;
color tempColor;
AppendLogFile("width: "+RkNigLx+" : height: "+POVImg.height);
switch(slBNIJT[DIWlYpw].molKaUt)
{
case 0: 
if(GUOIdiy > 255) GUOIdiy = 256; 
slBNIJT[DIWlYpw].DataFrameAmount = GUOIdiy-1;
slBNIJT[DIWlYpw].SeqFrameAmount = GUOIdiy-1;
for (int q=0; q != (slBNIJT[DIWlYpw].DataFrameAmount+1);q++)
{
x = 0;
for(int i = zQjfRqq-1; i >= 0; i--)
{
tempColor = POVImg.get(i,q);
slBNIJT[DIWlYpw].DataFrames[q][x] = (int)red(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+1] = (int)green(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+2] = (int)blue(tempColor);
x+=3;
} 
}
break;
case 1: 
if(GUOIdiy > 255) GUOIdiy = 256; 
slBNIJT[DIWlYpw].DataFrameAmount = RkNigLx-1;
slBNIJT[DIWlYpw].SeqFrameAmount = RkNigLx-1;
for (int q=0; q != (slBNIJT[DIWlYpw].DataFrameAmount+1);q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{
tempColor = POVImg.get(q,i); 
slBNIJT[DIWlYpw].DataFrames[q][x] = (int)red(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+1] = (int)green(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+2] = (int)blue(tempColor);
x+=3;
} 
}
break;
case 2: 
if(GUOIdiy > 255) GUOIdiy = 256; 
slBNIJT[DIWlYpw].DataFrameAmount = GUOIdiy-1;
slBNIJT[DIWlYpw].SeqFrameAmount = GUOIdiy-1;
for (int q=0; q != (slBNIJT[DIWlYpw].DataFrameAmount+1);q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{
tempColor = POVImg.get(i,q);
slBNIJT[DIWlYpw].DataFrames[q][x] = (int)red(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+1] = (int)green(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+2] = (int)blue(tempColor);
x+=3;
} 
}
break;
case 3: 
if(GUOIdiy > 255) GUOIdiy = 256; 
slBNIJT[DIWlYpw].DataFrameAmount = RkNigLx-1;
slBNIJT[DIWlYpw].SeqFrameAmount = RkNigLx-1;
AppendLogFile("LoadPOV TotalColorChannels: "+zQjfRqq+" : DataFrameAmt: "+slBNIJT[DIWlYpw].DataFrameAmount);
for (int q=0; q != (slBNIJT[DIWlYpw].DataFrameAmount+1);q++)
{
x = 0;
for (int i=zQjfRqq-1; i >= 0;i--)
{
tempColor = POVImg.get(q,i); 
slBNIJT[DIWlYpw].DataFrames[q][x] = (int)red(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+1] = (int)green(tempColor);
slBNIJT[DIWlYpw].DataFrames[q][x+2] = (int)blue(tempColor);
x+=3;
} 
}
break;		
} 
for (int q=0; q != slBNIJT[DIWlYpw].DataSize;q++)
{
slBNIJT[DIWlYpw].DataFrameVar[q] = 0;
slBNIJT[DIWlYpw].SpecialFrameVar[q] = 0;
slBNIJT[DIWlYpw].StartValues[q] = 0;
}
for (int q=0; q != (slBNIJT[DIWlYpw].DataFrameAmount+1);q++)
{
slBNIJT[DIWlYpw].FrameSpecial[q] = 20; 
}
AppendLogFile("Frame Amts: "+slBNIJT[DIWlYpw].SeqFrameAmount+" : "+slBNIJT[DIWlYpw].DataFrameAmount );
DrawPOVBuffer(); 
} 
void CalculateDataFrameAmt(int SelSeq)
{
slBNIJT[SelSeq].DataFrameAmount = 0;
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if (slBNIJT[SelSeq].FrameSpecial[q] > 29 && slBNIJT[SelSeq].FrameSpecial[q] < 90)
{
}
else
{
arrayCopy(slBNIJT[SelSeq].DataFrames[q], HoldDataFrames[slBNIJT[SelSeq].DataFrameAmount]); 
slBNIJT[SelSeq].DataFrameAmount++;
}
}
slBNIJT[SelSeq].DataFrameAmount = slBNIJT[SelSeq].DataFrameAmount - 1;
} 
void SetFrameSpecial(int[] oPtr)
{
int TempHold = (((PDBLtrJ+(ZVgbanO-1))*10))+TqwTJFO;
oPtr[lXrpjlY] = TempHold;
}
void FillFrameSpecial(int[] oPtr) 
{
int TempHold = oPtr[lXrpjlY];
AppendLogFile("FillFrameSpecial() "+TempHold +" - "+TempHold/10);
FrameOptionsButtons[0].Selected = false;
FrameOptionsButtons[1].Selected = false;
FrameOptionsButtons[2].Selected = false;
FrameOptionsButtons[3].Selected = false;	
if (TempHold == 0) 
{
TqwTJFO = 0;
switch(slBNIJT[DIWlYpw].SeqMode)
{
case mStall: 
PDBLtrJ = slBNIJT[DIWlYpw].SeqMode;
break;
case mFade: 
PDBLtrJ = mFade;
FrameOptionsButtons[0].Selected = true;
break;
case mInstant: 
PDBLtrJ = mInstant;
FrameOptionsButtons[1].Selected = true;
break;
case mGradient: 
PDBLtrJ = mFade;
FrameOptionsButtons[2].Selected = true;
break; 
case mCombo:
PDBLtrJ = mFade;
FrameOptionsButtons[3].Selected = true;
break;
} 
ZVgbanO = 1; 
SetFrameSpecial(slBNIJT[DIWlYpw].FrameSpecial); 
ZVgbanO = 0; 
}
else
{
TqwTJFO = TempHold%10;
TextFields[0].Label = ""+slBNIJT[DIWlYpw].SlideValues[lXrpjlY];
if(slBNIJT[DIWlYpw].SpeedValues[lXrpjlY] < 1) slBNIJT[DIWlYpw].SpeedValues[lXrpjlY] = 1;
TextFields[6].Label = ""+slBNIJT[DIWlYpw].SpeedValues[lXrpjlY];
switch(TempHold/10)
{
case 1: 
PDBLtrJ = 1;
ZVgbanO = 1;
FrameOptionsButtons[0].Selected = true;		
break;
case 2: 
PDBLtrJ = 2;
ZVgbanO = 1;
FrameOptionsButtons[1].Selected = true;		
break;
case 3: 
PDBLtrJ = 3;
ZVgbanO = 1; 
FrameOptionsButtons[3].Selected = true;			
break;
case 4: 
PDBLtrJ = 3;
ZVgbanO = 2; 
FrameOptionsButtons[3].Selected = true;			
break;
case 5: 
PDBLtrJ = 3;
ZVgbanO = 3; 
FrameOptionsButtons[2].Selected = true;		
break;
case 6: 
PDBLtrJ = 6; 
ZVgbanO = 1; 
FrameOptionsButtons[2].Selected = true;		
break;
case 7: 
PDBLtrJ = 6; 
ZVgbanO = 2; 
FrameOptionsButtons[2].Selected = true;		
break;
case 8: 
PDBLtrJ = 6; 
ZVgbanO = 3; 
FrameOptionsButtons[2].Selected = true;	
break;
}
}
HandleFrameCheckBoxes(ZVgbanO); 
FrameOptionsDD.SelStr = TqwTJFO;
}
void DrawPOVBuffer()
{
RkNigLx = slBNIJT[DIWlYpw].DataFrameAmount;
GUOIdiy = slBNIJT[DIWlYpw].DataSize / MDmgrxQ;
POVGraphicBuffer = createGraphics(RkNigLx+1,GUOIdiy);
/*
switch(slBNIJT[DIWlYpw].molKaUt)
{
case 0:
RkNigLx = slBNIJT[DIWlYpw].DataSize / MDmgrxQ;
GUOIdiy = slBNIJT[DIWlYpw].DataFrameAmount;
POVGraphicBuffer = createGraphics(RkNigLx,GUOIdiy+1);
break;
case 1:
RkNigLx = slBNIJT[DIWlYpw].DataFrameAmount;
GUOIdiy = slBNIJT[DIWlYpw].DataSize / MDmgrxQ;
POVGraphicBuffer = createGraphics(RkNigLx+1,GUOIdiy);
break;
case 2:
RkNigLx = slBNIJT[DIWlYpw].DataSize / MDmgrxQ;
GUOIdiy = slBNIJT[DIWlYpw].DataFrameAmount;
break;
case 3:
RkNigLx = slBNIJT[DIWlYpw].DataSize / MDmgrxQ;
GUOIdiy = slBNIJT[DIWlYpw].DataFrameAmount;
break;
} 
*/
AppendLogFile("DrawPOVBuffer() using w: "+RkNigLx+" h: "+GUOIdiy+" Type: "+molKaUt);
POVBuffer = createGraphics(570, 360);
POVBuffer.beginDraw();
POVBuffer.background(30, 30, 30);
POVBuffer.noStroke();
float tempSz;		
int x = 0;
int tempCenterX = 0;
int tempCenterY = 0;	
if(GUOIdiy >= RkNigLx) 
{
tempSz = GUOIdiy; 
tempSz = int(360 / tempSz); 
}
else {
tempSz = RkNigLx;
tempSz = int(550 / tempSz); 
}
POVGraphicBuffer.beginDraw();
POVGraphicBuffer.background(255,0,0);
POVGraphicBuffer.noStroke();
try
{
switch(slBNIJT[DIWlYpw].molKaUt)
{
case 0: 
tempCenterX = int(560 - (tempSz * zQjfRqq)) / 2;
tempCenterY = int(360 - (tempSz * (slBNIJT[DIWlYpw].DataFrameAmount+1))) / 2;
for (int q=0; q != slBNIJT[DIWlYpw].DataFrameAmount+1;q++)
{
x = 0;
for(int i = zQjfRqq-1; i >= 0; i--)
{
POVBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+(q*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);					
x+=3;
} 
}
break;
case 1: 
tempCenterX = int(560 - (tempSz * (slBNIJT[DIWlYpw].DataFrameAmount+1))) / 2;
tempCenterY = int(360 - (tempSz * zQjfRqq)) / 2;
for (int q=0; q != slBNIJT[DIWlYpw].DataFrameAmount+1;q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{
POVBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}
break;
case 2: 
tempCenterX = int(560 - (tempSz * zQjfRqq)) / 2;
tempCenterY = int(360 - (tempSz * (slBNIJT[DIWlYpw].DataFrameAmount+1))) / 2;
for (int q=0; q != slBNIJT[DIWlYpw].DataFrameAmount+1;q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{
POVBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+(q*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);		
x+=3;
} 
}
break;
case 3: 
tempCenterX = int(560 - (tempSz * (slBNIJT[DIWlYpw].DataFrameAmount+1))) / 2;
tempCenterY = int(360 - (tempSz * zQjfRqq)) / 2;
for (int q=0; q != slBNIJT[DIWlYpw].DataFrameAmount+1;q++)
{
x = 0;
for (int i=zQjfRqq-1; i >= 0;i--)
{
POVBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(slBNIJT[DIWlYpw].DataFrames[q][x], slBNIJT[DIWlYpw].DataFrames[q][x+1], slBNIJT[DIWlYpw].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}
break;		
} 
}
catch(Exception e)
{			
AppendLogFile("error, reload image file");
}
POVGraphicBuffer.endDraw();
POVBuffer.endDraw();
} 
void UpdateColorChannelBuffer(int passedID)
{	
AppendLogFile("UpdateColorChannelBuffer() with "+passedID);
try {
PreviewBuffer[passedID] = createGraphics(500, cTLGraphBufH);
GenerateSeqPreview(PreviewBuffer[passedID], passedID, DIWlYpw); 
TimeLineBuffer.beginDraw();
TimeLineBuffer.image(PreviewBuffer[passedID], 35, 5+(passedID*cTLChBufH), 500, cTLGraphBufH);
TLStartIndicators[passedID].display();	
TimeLineBuffer.endDraw();
}
catch(Exception e) {AppendLogFile("Unable to Run UpdateColorChannelBuffer()"); }
} 
void DrawTimeLineBuffer()
{
AppendLogFile("DrawTimeLineBuffer() - TotalColorChannels: "+zQjfRqq+" Sequence#: "+DIWlYpw);
if (slBNIJT[DIWlYpw].SeqMode == mLinked)
{
DrawLinkedBuffer();
return;
}
if(slBNIJT[DIWlYpw].SeqMode == mPOV)
{
DrawPOVBuffer();
return;
}	
int tempButtonCounter = 0;
int tempFrameVar = 0;
float tempVar = 0; 
boolean TempFlag = false;
int RStart = 0;
int GStart = 0;
int BStart = 0;
int WStart = 0;
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0;
float DifferenceR = 0;
float DifferenceG = 0;
float DifferenceB = 0;
float DifferenceW = 0;	
int tempR = 0;
int tempG = 0;
int tempB = 0;
int tempW = 0;
int tempX = 0;
int tempY = 0;
boolean TempStartIndicatorError = false;
slBNIJT[DIWlYpw].StartValError = false; 
if(TimeLineBuffer == null) return;
int tempA = 500 / (slBNIJT[DIWlYpw].SeqFrameAmount+1); 
LodQDil = tempA;
if(slBNIJT[DIWlYpw].SeqMode == mCombo) tempA = 500 / (slBNIJT[DIWlYpw].DataFrameAmount+1);
int qTemp = 0;
TimeLineFrameButtons = new Button[(slBNIJT[DIWlYpw].SeqFrameAmount+1)];
for (int q=0; q != slBNIJT[DIWlYpw].SeqFrameAmount+1;q++)
{
if (q == lXrpjlY) TempFlag = true; 
else TempFlag = false;
if (slBNIJT[DIWlYpw].SeqMode == mCombo && slBNIJT[DIWlYpw].FrameSpecial[q] > 29 && slBNIJT[DIWlYpw].FrameSpecial[q] < 90) 
{
TimeLineFrameButtons[tempButtonCounter] = new Button(""+(1+q), cTLChBufX+17+(tempA*q), cTLChBufY-20, 25, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, TempFlag);
TimeLineFrameButtons[tempButtonCounter].display(); 
tempButtonCounter++;
}
else
{
TimeLineFrameButtons[tempButtonCounter] = new Button(""+(1+q), cTLChBufX+22+(tempA*qTemp), cTLChBufY-25, 25, 20, cColButtonsBG, cColButtonsHL, cColButtonsOut, true, TempFlag);
TimeLineFrameButtons[tempButtonCounter].display(); 
tempButtonCounter++;
qTemp++;
} 
}
TimeLineBuffer.beginDraw();
TimeLineBuffer.background(cBackgroundColor);
TimeLineBuffer.strokeWeight(2);
TimeLineBuffer.textFont(fDigital, 48);
TLStartIndicators =  new TLTriangle[zQjfRqq];
CalculateDataFrameAmt(DIWlYpw);
TimeLineLabelButtons = new TLButton[zQjfRqq];
for (int i = 0; i != zQjfRqq; i++)
{
TimeLineBuffer.stroke(cStrokeColor);
TimeLineBuffer.line(0, (i*cTLChBufH), (TimeLineBuffer.width-30), (i*cTLChBufH));	
TimeLineLabelButtons[i] = new TLButton(""+(i+1), 0, 5+(i*cTLChBufH), 30, 20, cPurpleColor, cColButtonsHL, cColButtonsOut, true, false);
TimeLineLabelButtons[i].display();
TimeLineBuffer.noStroke();
if(slBNIJT[DIWlYpw].SeqMode == mGradient && i != 0)
{	
TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(i*cTLChBufH), 500, cTLGraphBufH);
}
else
{
PreviewBuffer[i] = createGraphics(500, cTLGraphBufH);
GenerateSeqPreview(PreviewBuffer[i], i, DIWlYpw); 
TimeLineBuffer.image(PreviewBuffer[i], 35, 5+(i*cTLChBufH), 500, cTLGraphBufH);
}
if (slBNIJT[DIWlYpw].SeqMode != mInstant)
{
switch(fYArHTo)
{
case 2: 
WStart = slBNIJT[DIWlYpw].StartValues[(i*MDmgrxQ)+3]; 
case 1: 
RStart = slBNIJT[DIWlYpw].StartValues[(i*MDmgrxQ)];
GStart = slBNIJT[DIWlYpw].StartValues[(i*MDmgrxQ)+1];
BStart = slBNIJT[DIWlYpw].StartValues[(i*MDmgrxQ)+2];
break;
case 0: 
WStart = slBNIJT[DIWlYpw].StartValues[(i*MDmgrxQ)]; 
break;	
}	
tempFrameVar = slBNIJT[DIWlYpw].SpecialFrameVar[(i*MDmgrxQ)];
switch(fYArHTo)
{
case 2: 
CurrentStartW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+3];
case 1: 
CurrentStartR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)];
CurrentStartG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+1];
CurrentStartB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+2];
break;
case 0: 
CurrentStartW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)];
break;	
}	  	  
if (tempFrameVar < slBNIJT[DIWlYpw].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(fYArHTo)
{
case 2: 
CurrentEndW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+3];
case 1: 
CurrentEndR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)];
CurrentEndG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+1]; 
CurrentEndB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)+2];
break;
case 0: 
CurrentEndW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(i*MDmgrxQ)];
break;	
}	 	  
tempFrameVar = slBNIJT[DIWlYpw].SpecialFrameVar[(i*MDmgrxQ)];
switch(fYArHTo)
{
case 0: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) slBNIJT[DIWlYpw].StartValError = true;
break;	
case 2: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) slBNIJT[DIWlYpw].StartValError = true;
case 1: 
if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) slBNIJT[DIWlYpw].StartValError = true;
if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) slBNIJT[DIWlYpw].StartValError = true;
if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) slBNIJT[DIWlYpw].StartValError = true;
break;
}	
DifferenceR = 0;
DifferenceG = 0;
DifferenceB = 0;
DifferenceW = 0;
if(CurrentStartR >= CurrentEndR) DifferenceR = CurrentStartR - RStart;
else DifferenceR = RStart - CurrentStartR;
if(CurrentStartG >= CurrentEndG) DifferenceG = CurrentStartG - GStart;
else DifferenceG = GStart - CurrentStartG;			
if(CurrentStartB >= CurrentEndB) DifferenceB = CurrentStartB - BStart;
else DifferenceB = BStart - CurrentStartB;
if(CurrentStartW >= CurrentEndB) DifferenceW = CurrentStartW - WStart;
else DifferenceW = WStart - CurrentStartW;
if (DifferenceR < 0) DifferenceR = (DifferenceR * -1); 
if (DifferenceG < 0) DifferenceG = (DifferenceG * -1);
if (DifferenceB < 0) DifferenceB = (DifferenceB * -1);      
if (DifferenceW < 0) DifferenceW = (DifferenceW * -1); 		
tempR = (CurrentEndR - CurrentStartR);
tempG = (CurrentEndG - CurrentStartG);
tempB = (CurrentEndB - CurrentStartB);				
tempW = (CurrentEndW - CurrentStartW);				
if (tempR < 0) tempR = (tempR * -1); 
if (tempG < 0) tempG = (tempG * -1);
if (tempB < 0) tempB = (tempB * -1);      
if (tempW < 0) tempW = (tempW * -1); 
DifferenceR = DifferenceR / (float)tempR;
DifferenceG = DifferenceG / (float)tempG;	
DifferenceB = DifferenceB / (float)tempB;
DifferenceW = DifferenceW / (float)tempW;		
if (DifferenceR > 0xFFFF) DifferenceR = 0; 
if (DifferenceG > 0xFFFF) DifferenceG = 0;  
if (DifferenceB > 0xFFFF) DifferenceB = 0;
if (DifferenceW > 0xFFFF) DifferenceW = 0;				
if (Float.isNaN(DifferenceR)) DifferenceR = 0;
if (Float.isNaN(DifferenceG)) DifferenceG = 0;
if (Float.isNaN(DifferenceB)) DifferenceB = 0;			
if (Float.isNaN(DifferenceW)) DifferenceW = 0;
switch(fYArHTo)
{
case 0: 
tempVar = DifferenceW;
break;
case 1: 
tempVar =  max(max(DifferenceR, DifferenceG), DifferenceB);
break;	
case 2: 
tempVar =  max(max(DifferenceR, DifferenceG), max(DifferenceB, DifferenceW));
break;
}		
tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);
tempY =  5+(i*cTLChBufH);
if(tempX > (497+35) || tempX < 35) 
{
slBNIJT[DIWlYpw].StartValError = true;
tempX = 35;
TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), cColButtonsOut, false, false);		
}	
else if(slBNIJT[DIWlYpw].StartValError == true)
{
TempStartIndicatorError = true;	
slBNIJT[DIWlYpw].StartValError = false;
tempX = 35;
TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), cColButtonsOut, false, false);			
}
else TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, cColButtonsHL, cColButtonsHL, cColButtonsOut, false, false);		
TLStartIndicators[i].display();
}
else
{
tempFrameVar = slBNIJT[DIWlYpw].SpecialFrameVar[(i*MDmgrxQ)];
tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);
try {	
for (int q = 0; q != slBNIJT[DIWlYpw].DataSize; q++) slBNIJT[DIWlYpw].StartValues[q] = slBNIJT[DIWlYpw].DataFrames[0][q];
}
catch(Exception e)
{
AppendLogFile("Unable to create startvals from DataFrame - Graphicsbuffer.pde");	
}
TLStartIndicators[i] = new TLTriangle(""+i, tempX, 5+(i*cTLChBufH), 0, 10, cColButtonsHL, cColButtonsHL, cColButtonsOut, false, false);
TLStartIndicators[i].display();
}
} 
TimeLineBuffer.endDraw();
slBNIJT[DIWlYpw].StartValError = TempStartIndicatorError;
if(slBNIJT[DIWlYpw].StartValError == true) AppendLogFile("Bad Start Value(s) Detected");
DrawUserSeqIconBuffer(DIWlYpw); 
}
void DrawIndexScrollArea()
{
AppendLogFile("DrawIndexScrollArea() "+YsOnDkT);
for (int i = 1; i != slBNIJT.length; i++)MeasureOefqCkP(i);
LdDeBhf = 0; 
for (int q=0; q != 32;q++)
{
if(JzvVShV[q] != 255 && JzvVShV[q] != 1001 && JzvVShV[q] != 1000) 
{			
LdDeBhf += slBNIJT[JzvVShV[q]].Length;
}	
}
if (420 < (YsOnDkT*80))
{
if(YsOnDkT == 31)
{	
ConnectionScrollBuffer = createGraphics(180, (YsOnDkT+1)*80);
IndexScrollBar.Maximum = (YsOnDkT-6);
}
else
{
if(device.BasicVersion != 0 && device.BasicMaxSequences == (YsOnDkT+1))
{
ConnectionScrollBuffer = createGraphics(180, (YsOnDkT+1)*80);
IndexScrollBar.Maximum = (YsOnDkT-6);
}		
else
{
ConnectionScrollBuffer = createGraphics(180, (YsOnDkT+2)*80); 
IndexScrollBar.Maximum = (YsOnDkT-5);
}
} 
IndexScrollBar.Value = IndexScrollBar.Maximum;
}
ConnectionScrollBuffer.beginDraw();
ConnectionScrollBuffer.background(cScrollBoxColor);
for (int i = 0; i != YsOnDkT+2; i++)
{
if((i+1) != 33 && (device.BasicVersion == 0 || device.BasicMaxSequences > i))
{	
ConnectionScrollBuffer.fill(255);
ConnectionScrollBuffer.textSize(36);
ConnectionScrollBuffer.textFont(fDigital, 48);
ConnectionScrollBuffer.text((i+1)+"", 5, 50+(i*80));
ConnectionScrollBuffer.textFont(fNormal, 48);
}
try {
if (JzvVShV[i] < 256)  slBNIJT[JzvVShV[i]].displayIconB(60, (5+(i*80)));
else if (JzvVShV[i] == 1000) DMXSequenceIcon.displayIconB(60, (5+(i*80)));
else if (JzvVShV[i] == 1001) SerialSequenceIcon.displayIconB(60, (5+(i*80)));
}
catch(Exception e)
{
AppendLogFile("Exception Occured in DrawIndexScrollArea()");
if(((device.BasicVersion == 0 || device.BasicMaxSequences > 8) || YsOnDkT < 7) && i != 32)
{	
AppendLogFile("No more UserSequences to Draw");
ConnectionScrollBuffer.fill(cColButtonsBG); 
ConnectionScrollBuffer.stroke(0);
ConnectionScrollBuffer.rect(60, (5+(i*80)), 110, 70);
float tempFloat = (float)((float)LdDeBhf/(float)device.DataSpace);
if(LdDeBhf > device.DataSpace)
{
AppendLogFile("Memory Overfilled");
ConnectionScrollBuffer.fill(255);
ConnectionScrollBuffer.textSize(12);
ConnectionScrollBuffer.textAlign(CENTER);
ConnectionScrollBuffer.text("The Memory is over filled, remove Sequences.", 65, (15+(i*80)), 105, 70);
ConnectionScrollBuffer.textAlign(LEFT);			
}
else
{
ConnectionScrollBuffer.strokeWeight(2);		
ConnectionScrollBuffer.fill(0,255,0);	
ConnectionScrollBuffer.rect(68, (52+(i*80)), 94, 18);
ConnectionScrollBuffer.fill(cColButtonsHL);	
ConnectionScrollBuffer.rect(68, (52+(i*80)), tempFloat*94, 18);				
ConnectionScrollBuffer.noStroke();
ConnectionScrollBuffer.fill(255);
ConnectionScrollBuffer.textSize(12);
ConnectionScrollBuffer.textAlign(CENTER);
ConnectionScrollBuffer.text("Drag and Drop Sequence Here to Add It", 65, (10+(i*80)), 105, 70);
ConnectionScrollBuffer.fill(0);			
ConnectionScrollBuffer.text("Usage: "+LdDeBhf, 60, (57+(i*80)), 105, 70);
ConnectionScrollBuffer.textAlign(LEFT);
}
}
break; 
}
}
ConnectionScrollBuffer.endDraw();
} 
void DrawLinkedBuffer()
{
AppendLogFile("DrawLinkedBuffer()");
LinkedScrollBar.Value = 0;
LinkedScrollBar.Maximum = (slBNIJT[DIWlYpw].SeqFrameAmount*100) - 470;
if(slBNIJT[DIWlYpw].SeqFrameAmount == 0) slBNIJT[DIWlYpw].SeqFrameAmount = 1; 
if (LinkedScrollBuffer.height != (slBNIJT[DIWlYpw].SeqFrameAmount*105))
{
LinkedScrollBuffer = createGraphics(545, slBNIJT[DIWlYpw].SeqFrameAmount*105);
}
LinkedSliders = new SliderBar[slBNIJT[DIWlYpw].SeqFrameAmount]; 
LinkedCheckBox = new CheckBox[slBNIJT[DIWlYpw].SeqFrameAmount*2]; 
LinkedIterationFields = new TextField[slBNIJT[DIWlYpw].SeqFrameAmount];
LinkedScrollBuffer.beginDraw();
LinkedScrollBuffer.background(cBackgroundColor);
int LCBtemp = 0;
for (int i = 0; i != slBNIJT[DIWlYpw].SeqFrameAmount; i++)
{
LinkedScrollBuffer.stroke(255);
LinkedScrollBuffer.line(10, ((i+1)*100), (LinkedScrollBuffer.width-10), ((i+1)*100));
LinkedScrollBuffer.stroke(cStrokeColor);
LinkedScrollBuffer.fill(cWorkspaceFontColor);
LinkedScrollBuffer.textSize(36); 
LinkedScrollBuffer.textFont(fDigital, 48);
LinkedScrollBuffer.text((i+1)+"", 10, 60+(i*100));
LinkedScrollBuffer.noStroke();
LinkedScrollBuffer.textFont(fNormal, 48);
if (slBNIJT[DIWlYpw].DataFrames[0][i] != 0)
{
slBNIJT[slBNIJT[DIWlYpw].DataFrames[0][i]].displayIconC(60, (15+(i*100)));
LinkedSliders[i] = new SliderBar(200, 30+(i*100), 140, 16, 1, 1, 255, color(255), cColButtonsBG, color(128), color(0), true, false, 10);
LinkedSliders[i].displayLinked();
LinkedIterationFields[i] = new TextField(""+slBNIJT[DIWlYpw].SlideValues[i], 240, 60+(i*100), 60, 25, color(255), color(200, 40, 40), true, false);
LinkedIterationFields[i].displayLinked();			
LinkedCheckBox[LCBtemp] =  new CheckBox(465, 30+(i*100), 20, 20, color(255), color(0), color(0), false);
LinkedCheckBox[LCBtemp].displayLinked();
LinkedCheckBox[LCBtemp+1] =  new CheckBox(465, 60+(i*100), 20, 20, color(255), color(0), color(0), true);
LinkedCheckBox[LCBtemp+1].displayLinked();    
LCBtemp+=2;
LinkedScrollBuffer.textSize(14);
LinkedScrollBuffer.fill(cWorkspaceFontColor);
LinkedScrollBuffer.text("Loops/Iterations: ", 200, 20+(i*100));
LinkedScrollBuffer.text("Transition Type:", 400, 20+(i*100));
LinkedScrollBuffer.text("Instant:", 410, 45+(i*100));
LinkedScrollBuffer.text("Fast Fade:", 390, 75+(i*100));
}
else
{
LinkedScrollBuffer.fill(cBorderColor);
LinkedScrollBuffer.rect(60, (15+(i*100)), 110, 70);
LinkedScrollBuffer.fill(0);
LinkedScrollBuffer.textSize(12);
LinkedScrollBuffer.textAlign(CENTER);
LinkedScrollBuffer.text("Click this Icon and then Click on a Sequence Icon to add it", 65, (25+(i*100)), 105, 70);
LinkedScrollBuffer.textAlign(LEFT);
}
}
LinkedScrollBuffer.endDraw();
try 
{ 
for(int i = 0; i != slBNIJT[DIWlYpw].SeqFrameAmount; i++)
{
if(slBNIJT[DIWlYpw].SlideValues[i] == 0) slBNIJT[DIWlYpw].SlideValues[i] = 1;
LinkedSliders[i].Value = slBNIJT[DIWlYpw].SlideValues[i];
LinkedSliders[i].displayLinked();
AppendLogFile("attempting checkbox using "+slBNIJT[DIWlYpw].SpecialFrameVar[i]);
if(slBNIJT[DIWlYpw].SpecialFrameVar[i] == 0)
{
LinkedCheckBox[i*2].Selected = true;
LinkedCheckBox[(i*2)+1].Selected = false;
}
else 
{
LinkedCheckBox[i*2].Selected = false;
LinkedCheckBox[(i*2)+1].Selected = true;
}
LinkedCheckBox[i*2].displayLinked();
LinkedCheckBox[(i*2)+1].displayLinked();
}
}
catch(Exception e) { }
}
void DrawUserSeqIconBuffer(int methodArgument)
{
if(methodArgument == 9999) 
{	
AppendLogFile("DrawUserSeqIconBuffer() - Update All Icons");
if(slBNIJT.length > 1)
{
if(LMORxyF == 0 || LMORxyF == 1) 
SequenceScrollBar.Maximum = (slBNIJT.length)-5;
else
SequenceScrollBar.Maximum = (slBNIJT.length)-7;
if(SequenceScrollBar.Maximum < 1) SequenceScrollBar.Maximum = 1;
if(SequenceScrollBar.Value > SequenceScrollBar.Maximum) SequenceScrollBar.Value = SequenceScrollBar.Maximum;
}	
if (420 < ((slBNIJT.length-1)*80))
{
SeqIconBuffer = createGraphics(140, (slBNIJT.length)*80); 
}
SeqIconBuffer.beginDraw();
SeqIconBuffer.textFont(fNormal, 48); 
SeqIconBuffer.background(0, 0, 0, 0);
if(slBNIJT.length >= 1)
{	
for (int i = 1; i != slBNIJT.length; i++)
{
CalculateDataFrameAmt(i);   
SeqIconPreview[i] = createGraphics(500, cTLGraphBufH);
GenerateSeqPreview(SeqIconPreview[i], 0, i); 
slBNIJT[i].displayIcon(5, (5+((i-1)*80)));
}
}
if (slBNIJT.length <= cSoftwareMaxSequences)
{
SeqIconBuffer.stroke(0);
SeqIconBuffer.fill(cBorderColor);
SeqIconBuffer.rect(5, (5+((slBNIJT.length-1)*80)), 110, 70);
SeqIconBuffer.textSize(12);
SeqIconBuffer.textAlign(CENTER);
SeqIconBuffer.fill(0);
SeqIconBuffer.text("Click To Add Another Sequence", 10, (20+((slBNIJT.length-1)*80)), 105, 70);
SeqIconBuffer.textAlign(LEFT);
}
SeqIconBuffer.endDraw(); 	
}	
else
{
AppendLogFile("DrawUserSeqIconBuffer() - Single Icon Update "+methodArgument);
CalculateDataFrameAmt(methodArgument);   
SeqIconPreview[methodArgument] = createGraphics(500, cTLGraphBufH);
SeqIconBuffer.beginDraw();
GenerateSeqPreview(SeqIconPreview[methodArgument], 0, methodArgument); 
slBNIJT[methodArgument].displayIcon(5, (5+((methodArgument-1)*80)));
SeqIconBuffer.endDraw(); 
} 
}
void GenerateSeqPreview(PGraphics GBuffer, int PassedID, int SelSeq)
{
int tempChan = PassedID * MDmgrxQ;
int tempA = 500 / (slBNIJT[SelSeq].SeqFrameAmount+1);
if (PassedID == zQjfRqq) tempChan = PassedID;
GBuffer.beginDraw();
GBuffer.background(cBackgroundColor); 
GBuffer.noStroke();
if(slBNIJT[SelSeq].SeqMode == mLinked)
{
GBuffer.background(0, 0, 0, 0); 
GBuffer.endDraw();
return;
}
else if(slBNIJT[SelSeq].SeqMode == mPOV)
{
AppendLogFile("Generate as POV "+SelSeq+" : TotalColorChannels: "+zQjfRqq);
POVGraphicBuffer = createGraphics(slBNIJT[SelSeq].SeqFrameAmount+1, zQjfRqq);
POVGraphicBuffer.beginDraw();
POVGraphicBuffer.background(65); 
POVGraphicBuffer.noStroke();
int x = 0;
switch(slBNIJT[SelSeq].molKaUt)
{
case 0: 
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{
POVGraphicBuffer.fill(slBNIJT[SelSeq].DataFrames[q][x], slBNIJT[SelSeq].DataFrames[q][x+1], slBNIJT[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);					
x+=3;
} 
}
break;
case 1: 
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
x = 0;
for (int i=0; i != zQjfRqq;i++)
{		
POVGraphicBuffer.fill(slBNIJT[SelSeq].DataFrames[q][x], slBNIJT[SelSeq].DataFrames[q][x+1], slBNIJT[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}
break;
case 2: 
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
x = 0;
for (int i=zQjfRqq; i != 0;i--)
{		
POVGraphicBuffer.fill(slBNIJT[SelSeq].DataFrames[q][x], slBNIJT[SelSeq].DataFrames[q][x+1], slBNIJT[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}
break;
case 3: 
for (int q=0; q != slBNIJT[SelSeq].DataFrameAmount+1;q++)
{
x = 0;
for (int i = zQjfRqq; i != 0;i--)
{		
POVGraphicBuffer.fill(slBNIJT[SelSeq].DataFrames[q][x], slBNIJT[SelSeq].DataFrames[q][x+1], slBNIJT[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}
break;							
}
POVGraphicBuffer.endDraw();
GBuffer.image(POVGraphicBuffer,0,0,500,zQjfRqq);
GBuffer.endDraw();
return;
}
int qTemp = 0;
color ColorTemp = color(0);
color c = color(0);  
color zpfDQQc = color(0);
tempA = 500 / (slBNIJT[SelSeq].SeqFrameAmount+1);
if(slBNIJT[SelSeq].SeqMode == mCombo) tempA = 500 / (slBNIJT[SelSeq].DataFrameAmount+1);
if(slBNIJT[SelSeq].SeqMode != mCombo)for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++) arrayCopy(slBNIJT[SelSeq].DataFrames[q], HoldDataFrames[q]);
for (int q=0; q != slBNIJT[SelSeq].SeqFrameAmount+1;q++)
{
if (slBNIJT[SelSeq].FrameSpecial[q] > 29 && slBNIJT[SelSeq].FrameSpecial[q] < 90 && slBNIJT[SelSeq].SeqMode == mCombo) 
{
}
else
{
if (slBNIJT[SelSeq].FrameSpecial[q] > 9 && slBNIJT[SelSeq].FrameSpecial[q] < 20)
{
if (qTemp == slBNIJT[SelSeq].DataFrameAmount)
{		  
switch(slBNIJT[SelSeq].DataType)
{
case 0: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[0][tempChan]>>8));
else	ColorTemp = color(HoldDataFrames[0][tempChan]);   
break;
case 1: 
case 2: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[0][tempChan]>>8), (HoldDataFrames[0][tempChan+1]>>8), (HoldDataFrames[0][tempChan+2]>>8)); 
else	ColorTemp = color(HoldDataFrames[0][tempChan], HoldDataFrames[0][tempChan+1], HoldDataFrames[0][tempChan+2]);   
break;	
}
}
else 
{
switch(slBNIJT[SelSeq].DataType)
{
case 0: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8));
else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8), (HoldDataFrames[qTemp+1][tempChan+1]>>8), (HoldDataFrames[qTemp+1][tempChan+2]>>8));
else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan], HoldDataFrames[qTemp+1][tempChan+1], HoldDataFrames[qTemp+1][tempChan+2]);  
break;	
}		  		  
}						
float inter;
c = color(0);  
zpfDQQc = color(0);
switch(slBNIJT[SelSeq].DataType)
{
case 0: 
if(device.Bit16Capable == true)zpfDQQc = color((HoldDataFrames[qTemp][tempChan]>>8));
else zpfDQQc = color(HoldDataFrames[qTemp][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Capable == true)zpfDQQc = color((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
else zpfDQQc = color(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);
break;	
} 
/*
for (int i = 0; i <= tempA; i++) 
{
inter = map(i, 0, tempA, 0, 1);
switch(slBNIJT[SelSeq].DataType)
{
case 0: 
if(device.Bit16Capable == true)c = lerpColor(zpfDQQc, ColorTemp, inter);
elsec = lerpColor(zpfDQQc, ColorTemp, inter);
break;
case 1: 
case 2: 
if(device.Bit16Capable == true)c = lerpColor(color(zpfDQQc), ColorTemp, inter);
elsec = lerpColor(color(zpfDQQc), ColorTemp, inter);
break;	
} 
GBuffer.stroke(c); 
GBuffer.line(i+(qTemp*tempA), 0, i+(qTemp*tempA), cTLGraphBufH);
}
*/				
for (int i = 0; i <= tempA; i++) 
{
inter = map(i, 0, tempA, 0, 1);
if(slBNIJT[SelSeq].DataType == 0) c = lerpColor(zpfDQQc, ColorTemp, inter);
else c = lerpColor(color(zpfDQQc), ColorTemp, inter);
GBuffer.stroke(c); 
GBuffer.line(i+(qTemp*tempA), 0, i+(qTemp*tempA), cTLGraphBufH);
}			
if(slBNIJT[SelSeq].DataType == 2)  
{
GBuffer.noStroke();
GBuffer.fill(255);
for (int i = 0; i <= tempA; i++) 
{
inter = map(i, 0, tempA, 0, 1);
if(i == 0)
{
if(device.Bit16Capable == true) 
{
if ((qTemp+1) > slBNIJT[SelSeq].DataFrameAmount) ColorTemp = color((HoldDataFrames[0][tempChan+3]>>8));
else ColorTemp = color((HoldDataFrames[qTemp+1][tempChan+3]>>8));
}			 
else 
{
if ((qTemp+1) > slBNIJT[SelSeq].DataFrameAmount) ColorTemp = color(HoldDataFrames[0][tempChan+3]);
else ColorTemp = color(HoldDataFrames[qTemp+1][tempChan+3]);
}		
}	 
if(device.Bit16Capable == true)  c = lerpColor(color((HoldDataFrames[qTemp][tempChan+3]>>8)), ColorTemp, inter);
else	c = lerpColor(color(HoldDataFrames[qTemp][tempChan+3]), ColorTemp, inter);
GBuffer.stroke(c);
GBuffer.line(i+(qTemp*tempA), 10, i+(qTemp*tempA), cTLGraphBufH); 
}	
} 
}
else if (slBNIJT[SelSeq].FrameSpecial[q] > 19 && slBNIJT[SelSeq].FrameSpecial[q] < 30)
{
GBuffer.noStroke();
switch(slBNIJT[SelSeq].DataType)
{
case 0: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[qTemp][tempChan]>>8));	
else ColorTemp = color(HoldDataFrames[qTemp][tempChan]);	
break;
case 1: 
if(device.Bit16Capable == true)	ColorTemp = color((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
else ColorTemp = color(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);
break;	
case 2: 
if(device.Bit16Capable == true) ColorTemp = color((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
else ColorTemp = color(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);
break;
} 
GBuffer.fill(ColorTemp);
GBuffer.rect((tempA * qTemp), 0, tempA, cTLGraphBufH);
if(slBNIJT[SelSeq].DataType == 2) 
{
if(device.Bit16Capable == true) GBuffer.fill(color((HoldDataFrames[qTemp][tempChan+3]>>8)));
else GBuffer.fill(color(HoldDataFrames[qTemp][tempChan+3]));
GBuffer.rect((tempA * qTemp), 10, tempA, cTLGraphBufH);
}
}  
else if (slBNIJT[SelSeq].FrameSpecial[q] > 29 && slBNIJT[SelSeq].FrameSpecial[q] < 60) 
{
float tempC = (float)tempA /  (float)slBNIJT[SelSeq].SlideValues[q];
GBuffer.noStroke();
for (int i = 0; i !=  slBNIJT[SelSeq].SlideValues[q]; i++) 
{
if (i%2 == 0)
{
GBuffer.fill(100);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
}
else
{
GBuffer.fill(20);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
}
} 
GBuffer.fill(255, 0, 0);
for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 9, 15+(tempA * qTemp)+(zz*15), 1, 20+(tempA * qTemp)+(zz*15), 9);
}    
else if (slBNIJT[SelSeq].FrameSpecial[q] > 59 && slBNIJT[SelSeq].FrameSpecial[q] < 90) 
{
float tempC = (float)tempA /  (float)slBNIJT[SelSeq].SlideValues[q];
GBuffer.noStroke();
for (int i = 0; i != slBNIJT[SelSeq].SlideValues[q]; i++) 
{
if (i%2 == 0)
{
GBuffer.fill(100);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
}
else
{
GBuffer.fill(20);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, cTLGraphBufH);
}
}
GBuffer.fill(255, 0, 0);
for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 1, 15+(tempA * qTemp)+(zz*15), 9, 20+(tempA * qTemp)+(zz*15), 1);
GBuffer.noStroke();
} 
qTemp++;
}
} 
GBuffer.endDraw();
} 
void DisplayDragIndicator()
{
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0; 
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);  
TLStartIndicators[BKYieeA].ColBG = color(cColButtonsHL); 
TimeLineBuffer.beginDraw();
TimeLineBuffer.fill(cBackgroundColor); 
TimeLineBuffer.rect(TLStartIndicators[BKYieeA].xpos-(TLStartIndicators[BKYieeA].bSize)-1, TLStartIndicators[BKYieeA].ypos-1, (float)(TLStartIndicators[BKYieeA].bSize*2.25), (float)(TLStartIndicators[BKYieeA].bSize*1.3));
if(slBNIJT[DIWlYpw].SeqMode == mGradient) TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(BKYieeA*cTLChBufH), 500, cTLGraphBufH);
else TimeLineBuffer.image(PreviewBuffer[BKYieeA], 35, 5+(BKYieeA*cTLChBufH), 500, cTLGraphBufH);
TLStartIndicators[BKYieeA].xpos = yrsmlGD - 85;
if (TLStartIndicators[BKYieeA].xpos < 35)  TLStartIndicators[BKYieeA].xpos = 35;
else if (TLStartIndicators[BKYieeA].xpos > 532) TLStartIndicators[BKYieeA].xpos = 532;
TimeLineLabelButtons[BKYieeA].display();
int tempA = 500 / (slBNIJT[DIWlYpw].SeqFrameAmount+1); 
if(slBNIJT[DIWlYpw].SeqMode == mCombo) tempA = 500 / (slBNIJT[DIWlYpw].DataFrameAmount+1);
if(slBNIJT[DIWlYpw].SeqMode != mInstant)TLStartIndicators[BKYieeA].display();
TimeLineBuffer.endDraw();	
int tempFrameVar = floor((TLStartIndicators[BKYieeA].xpos - 35) / tempA);
float tempLocation = ((float)(TLStartIndicators[BKYieeA].xpos - 35) / (float)tempA) - tempFrameVar;
if(slBNIJT[DIWlYpw].SeqMode == mInstant)
{
TimeLineBuffer.beginDraw();	
TLStartIndicators[BKYieeA].xpos = 35+tempFrameVar * tempA;
TLStartIndicators[BKYieeA].display();
TimeLineBuffer.endDraw();	
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)] = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)] = tempFrameVar;
break;
case 2: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+3] = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+3];
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+3] = tempFrameVar;
case 1: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)] = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+1] = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+1]; 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+2] = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+2];
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)] = tempFrameVar;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+1] = tempFrameVar;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+2] = tempFrameVar;
break;
}
}
else
{
if(slBNIJT[DIWlYpw].SeqMode == mCombo)
{			
for(int q = 0; q != tempFrameVar+1;q++)
{
if (slBNIJT[DIWlYpw].FrameSpecial[q] > 29 && slBNIJT[DIWlYpw].FrameSpecial[q] < 90)
{
tempFrameVar++;		
}
else
{
}
}			
}
int tempDataFrameVar = 0; 
for(int q = 0; q != tempFrameVar+1;q++)
{
if (slBNIJT[DIWlYpw].FrameSpecial[q] > 29 && slBNIJT[DIWlYpw].FrameSpecial[q] < 90)
{
}
else
{
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].DataFrameVar[(BKYieeA*MDmgrxQ)] = tempDataFrameVar;
break;
case 2: 
slBNIJT[DIWlYpw].DataFrameVar[(BKYieeA*MDmgrxQ)+3] = tempDataFrameVar;
case 1: 
slBNIJT[DIWlYpw].DataFrameVar[(BKYieeA*MDmgrxQ)] = tempDataFrameVar;
slBNIJT[DIWlYpw].DataFrameVar[(BKYieeA*MDmgrxQ)+1] = tempDataFrameVar;
slBNIJT[DIWlYpw].DataFrameVar[(BKYieeA*MDmgrxQ)+2] = tempDataFrameVar;
break;
}
tempDataFrameVar++;
}
}			
switch(fYArHTo)
{
case 0: 
CurrentStartW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
break;
case 1: 
CurrentStartR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
CurrentStartG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+1];
CurrentStartB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+2];
break;
case 2: 
CurrentStartR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
CurrentStartG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+1];
CurrentStartB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+2];
CurrentStartW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+3]; 
break;
}
if (tempFrameVar < slBNIJT[DIWlYpw].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(fYArHTo)
{
case 0: 
CurrentEndW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
break;
case 1: 
CurrentEndR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
CurrentEndG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+1]; 
CurrentEndB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+2];
break;
case 2: 
CurrentEndR = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)];
CurrentEndG = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+1]; 
CurrentEndB = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+2];
CurrentEndW = slBNIJT[DIWlYpw].DataFrames[tempFrameVar][(BKYieeA*MDmgrxQ)+3]; 
break;
}
float RedLerp = lerp(CurrentStartR,CurrentEndR, tempLocation);
float GreenLerp = lerp(CurrentStartG,CurrentEndG, tempLocation);
float BlueLerp = lerp(CurrentStartB,CurrentEndB, tempLocation);
float WhiteLerp = lerp(CurrentStartW,CurrentEndW, tempLocation);
tempFrameVar = floor((TLStartIndicators[BKYieeA].xpos - 35) / tempA); 
switch(fYArHTo)
{
case 0: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)] = (int)WhiteLerp; 
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)] = tempFrameVar;
break;
case 2: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+3] = (int)WhiteLerp;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+3] = tempFrameVar;
case 1: 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)] = (int)RedLerp;
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+1] = (int)GreenLerp; 
slBNIJT[DIWlYpw].StartValues[(BKYieeA*MDmgrxQ)+2] = (int)BlueLerp;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)] = tempFrameVar;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+1] = tempFrameVar;
slBNIJT[DIWlYpw].SpecialFrameVar[(BKYieeA*MDmgrxQ)+2] = tempFrameVar;
break;
}
if(yrsmlGD < 125) yrsmlGD = 125;
else if(yrsmlGD > 540) yrsmlGD = 540;
textSize(12);
fill(cBorderColor);
stroke(cColButtonsHL);
rect(yrsmlGD-10, TLStartIndicators[BKYieeA].ypos+55-AeQGRRm, 90, 65);
fill(0);
noStroke();
text("Red: "+int(RedLerp)+"\nGreen "+int(GreenLerp)+"\nBlue: "+int(BlueLerp)+"\nWhite: "+int(WhiteLerp), yrsmlGD, TLStartIndicators[BKYieeA].ypos+70-AeQGRRm);
}
} 
void OpenLiveControlMenu()
{
xhPzZot = 60; 
hgwvVkk[0] = 1; 
if(LiveControlCheckBox[3].Selected == true)  hgwvVkk[1] = 1; 
else  hgwvVkk[1] = 0; 
hgwvVkk[2] = (yxtcfxi >> 8) & 0xFF;  
hgwvVkk[3] = yxtcfxi & 0xFF;   
RequestCommand();  
try {
ControlSliders = new SliderBar[yxtcfxi];
ControlRects = new ColorRect[yxtcfxi];
}
catch(Exception e)
{
return; 
}  
/*
int tSliderWidth = (570 / ceil((float)ControlSliders.length/20))-30; 
int tColumnSpace = tSliderWidth+30;
AppendLogFile(ceil((float)ControlSliders.length/20)+" : "+tSliderWidth+" : "+tColumnSpace);
if(tSliderWidth > 240) tSliderWidth = 240;
*/
int tempMaxVal = 255;
if(LiveControlCheckBox[3].Selected == true)
{
tempMaxVal = 0xFFFF;
}
float RectThUIWJw = 1;
if(yxtcfxi > 104 && yxtcfxi <= 130)
{
RectThUIWJw = 0.7;
}
else if(yxtcfxi > 130 && yxtcfxi <= 156)
{
RectThUIWJw = 0.6;
}			
else if(yxtcfxi > 156 && yxtcfxi <= 182)
{
RectThUIWJw = 0.48;
}		
else if(yxtcfxi > 182 && yxtcfxi <= 208)
{
RectThUIWJw = 0.38;
}	
else if(yxtcfxi > 208) RectThUIWJw = 0.29;
AppendLogFile("using: "+RectThUIWJw+" with "+yxtcfxi+" sliders");
int column = 0;
int row = 0;
for (int i = 0; i != ControlSliders.length; i++) 
{			
ControlSliders[i] = new SliderBar(110, 85, round(100*RectThUIWJw), 14, 0, 0, tempMaxVal, color(255), color(0), cBorderColor, color(0), true, false, 8);
if(column == 0) ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*RectThUIWJw)));
else if(RectThUIWJw == 0.29 && i > 233) { ControlSliders[i].xpos = 100; ControlSliders[i].ypos = 610; }
else  ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*RectThUIWJw))) + (35*column);
ControlSliders[i].ypos = ControlSliders[i].ypos + (row*19);		
row++;
if((row*19) > (490))
{
row = 0;
column++;
}
}
AppendLogFile("Sliders Built, Total: "+ControlSliders.length);
gsgdPHO = true;
}  
void DisplayFrameButtons()
{
if((wtkyhyk*30) > slBNIJT[DIWlYpw].SeqFrameAmount+1) wtkyhyk = 0;
if(((wtkyhyk+1)*30) > slBNIJT[DIWlYpw].SeqFrameAmount+1)
{
for (int i =(wtkyhyk*30); i != slBNIJT[DIWlYpw].SeqFrameAmount+1; i++) FrameButtons[i].display();   
}
else  
{
for (int i =(wtkyhyk*30); i != ((wtkyhyk+1)*30); i++) FrameButtons[i].display();    
} 
}
void BuildGradientMenu()
{
AppendLogFile("BuildGradientMenu()");
int tempSize = 30;
if ((tempSize+5)*(slBNIJT[DIWlYpw].SeqFrameAmount+1) > 540) 
{
tempSize = 20;
}
GradientRects = new ColorRect[slBNIJT[DIWlYpw].SeqFrameAmount+1];
for (int i =0; i != slBNIJT[DIWlYpw].SeqFrameAmount+1; i++) 
{ 
Ohsuixc = slBNIJT[DIWlYpw].DataFrames[i][0];
OfkiYaD = slBNIJT[DIWlYpw].DataFrames[i][1];
TmzyKzO = slBNIJT[DIWlYpw].DataFrames[i][2];
qeeOUAC = slBNIJT[DIWlYpw].DataFrames[i][3];
if(tempSize == 20 && i > 41)
{
GradientRects[i] = new ColorRect((90+((i-41)*(tempSize+5))), (600), (tempSize), (tempSize), (int)Ohsuixc, (int)OfkiYaD, (int)TmzyKzO, (int)qeeOUAC);
}
else if(tempSize == 20 && i > 20)
{
GradientRects[i] = new ColorRect((90+((i-21)*(tempSize+5))), (575), (tempSize), (tempSize), (int)Ohsuixc, (int)OfkiYaD, (int)TmzyKzO, (int)qeeOUAC);
}
else
{
GradientRects[i] = new ColorRect((90+(i*(tempSize+5))), (550), (tempSize), (tempSize), (int)Ohsuixc, (int)OfkiYaD, (int)TmzyKzO, (int)qeeOUAC);
}  
}
} 
void GraphicLayoutBuild()
{
AppendLogFile("============= GraphicLayoutBuild() with "+jgvztaS+"===================="+zQjfRqq);
CalcIMwZLgR();
int centX = 287;
int centY = 235;
int temp = 0;
INyauIU = MHixUhI*zQjfRqq;
LEDIcon = new LEDgraphic[INyauIU];
if(tDYkOHG.length != (MHixUhI*yxtcfxi))
{
tDYkOHG = new int[MHixUhI*yxtcfxi];
AppendLogFile("LEDGroupIDArray OVERWRITTEN");
}
if(INyauIU == 0 || yxtcfxi == 0) return;
GraphicLayoutBuffer = createGraphics(570, 475);
GraphicLayoutBuffer.beginDraw();
GraphicLayoutBuffer.background(cBackgroundColor);
if(jgvztaS == 0 || jgvztaS > 6) jgvztaS = 1;
switch(jgvztaS)
{
case 1:	
float degreeChange = (float)360 / (MHixUhI*zQjfRqq);
float Angle=0;
for (int i=0;i != (zQjfRqq*MHixUhI); i++)
{ 
temp = i%(yxtcfxi/MDmgrxQ);
double Xa = centX+(200*Math.sin(Angle*Math.PI/180));
double Ya = centY+(200*-Math.cos(Angle*Math.PI/180));
Angle = Angle + degreeChange; 
LEDIcon[i] = new LEDgraphic(temp, (int)Xa, (int)Ya, IMwZLgR, color(255)); 
LEDIcon[i].display();
}	
break;
case 2:	
if ((MHixUhI*zQjfRqq)%4 == 1) 
{
MHixUhI++;
MenuSliders[0].Value = MHixUhI;
}
int ShapeSize = (375);
float Spacing = (float)ShapeSize / ((float)(MHixUhI*zQjfRqq)/4);
int LEDCounter=0;
for (int i=0;i != (MHixUhI*zQjfRqq)/4;i++)
{    
temp = LEDCounter%(zQjfRqq);
LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)((centX-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), centY+(ShapeSize/2), IMwZLgR, color(255));
LEDIcon[LEDCounter].display();
LEDCounter++;
}
for (int i=0;i!=(MHixUhI*zQjfRqq)/4;i++)
{
temp = LEDCounter%zQjfRqq;
LEDIcon[LEDCounter] = new LEDgraphic(temp, (centX+(ShapeSize/2)), (int)((centY+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), IMwZLgR, color(255));
LEDIcon[LEDCounter].display();		
LEDCounter++;
}
for (int i=0;i != (MHixUhI*zQjfRqq)/4;i++)
{
temp = LEDCounter%zQjfRqq;
LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY-(ShapeSize/2)), IMwZLgR, color(255));
LEDIcon[LEDCounter].display();
LEDCounter++;
}
for (int i=0;i != (MHixUhI*zQjfRqq)/4;i++)
{   
temp = LEDCounter%zQjfRqq;
LEDIcon[LEDCounter] = new LEDgraphic(temp, centX-(ShapeSize/2), (int)((centY-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), IMwZLgR, color(255));
LEDIcon[LEDCounter].display();
LEDCounter++;
}
break;
case 3: 
LEDCounter = 0; 
IMwZLgR = 15;
int radius = 287;
int coils = 11; 
int rotation = 0;
final float thetaMax = coils * 2 * PI;
final float awayStep = radius / thetaMax;
final int chord = IMwZLgR+(IMwZLgR/2);
int iterationcounter=0;
for (float theta = chord / awayStep; theta <= thetaMax; ) 
{
if (iterationcounter == INyauIU) return; 
float away = awayStep * theta;
float around = theta + rotation;
int x = (int)round(centX + cos( around ) * away);
int y = (int)round(centY + sin( around ) * away);
temp = LEDCounter%zQjfRqq;
LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)x, (int)y, IMwZLgR, color(255)); 
if(LEDCounter > 1)
{
GraphicLayoutBuffer.stroke(255);
GraphicLayoutBuffer.strokeWeight(2);
GraphicLayoutBuffer.line(LEDIcon[LEDCounter-1].xpos, LEDIcon[LEDCounter-1].ypos, x, y);
GraphicLayoutBuffer.noStroke();
LEDIcon[LEDCounter-1].display();	
}
LEDIcon[LEDCounter].display();		
LEDCounter++;		
theta += chord / away;
iterationcounter++;
} 
break;   
case 4: 
ShapeSize = 500;
Spacing = ShapeSize / ((float)(MHixUhI*zQjfRqq));
LEDCounter=0;
for (int i=0;i != (MHixUhI*zQjfRqq);i++)
{
temp = LEDCounter%zQjfRqq;   
LEDIcon[LEDCounter] = new LEDgraphic(temp, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY), IMwZLgR, color(255));
LEDIcon[LEDCounter].display();  		
LEDCounter++;
}   
break; 
case 5:	
case 6:   
AppendLogFile("Building Graphic or Custom");
AppendLogFile("Should display "+PmuCQks+" : "+graphicImg.width+" : "+graphicImg.height);
AppendLogFile("Using "+(MHixUhI*zQjfRqq)+"  Coord Lengths: "+INyauIU);
for (int q = 0; q != INyauIU;q++)
{
try {	
if(IBzMEJI[q] != 0 || zppAzXD[q] != 0)
{	
LEDIcon[q] = new LEDgraphic(q%zQjfRqq, IBzMEJI[q], zppAzXD[q], IMwZLgR, color(255));
LEDIcon[q] .display();
}
}
catch(Exception e)
{	
AppendLogFile("Errror Building Graphic/Patch");
}
} 
if(jgvztaS == 5) break; 
imageMode(CENTER);
float imgScale = 1;
if(graphicImg.width > graphicImg.height)
{
imgScale =  570 / (float)graphicImg.width;			
}
else
{
AppendLogFile("Height is larger");	
imgScale = 480 / (float)graphicImg.height;		
}
AppendLogFile("FLOAT: "+imgScale+" so width will be: "+round(graphicImg.width*imgScale));
GraphicLayoutBuffer.beginDraw(); 
GraphicLayoutBuffer.image(graphicImg, round((570-round(graphicImg.width*imgScale))/2), round((480-round(graphicImg.height*imgScale))/2), round(graphicImg.width*imgScale), round(graphicImg.height*imgScale));	
imageMode(CORNER);
try 
{
for (int i=0;i != INyauIU;i++)if(i != xOaCPWV)LEDIcon[i].display(); 
}
catch(Exception e){	}
xOaCPWV = -1000;
break;			
}
try {	
for (int i = 0;i != INyauIU;i++)LEDIcon[i].GroupID = tDYkOHG[i];
}
catch(Exception e) {AppendLogFile("Error Assigning Group IDs"); }
GraphicLayoutBuffer.endDraw();
}
void CalcIMwZLgR()
{
if(SoftwareCheckBox[0].Selected == true)
{
IMwZLgR = 10;
tGrissw = 0;
}	
else if(SoftwareCheckBox[1].Selected == true)
{
IMwZLgR = 15;
tGrissw = 1;
}	
else if(SoftwareCheckBox[2].Selected == true)
{
IMwZLgR = 20;
tGrissw = 2;
}
}
void ImportCustomPatch()
{
AppendLogFile("ImportCustomPatch()");
String[] lines = loadStrings(glYkgZR); 
String[] WorkString = new String[3]; 
WorkString = split(lines[0], '\t');
int MaxPixels = int(WorkString[0]);
int MinX=1000;
int MinY=1000;
int MaxX=0;
int MaxY=0;
int countvar = 0; 
try 
{
for (int i=1;i != lines.length;i++)
{
WorkString = split(lines[i], '\t');
if (int(WorkString[0]) > MaxX) MaxX = int(WorkString[0]);
if (int(WorkString[0]) < MinX) MinX = int(WorkString[0]);
if (int(WorkString[1]) > MaxY) MaxY = int(WorkString[1]);
if (int(WorkString[1]) < MinY) MinY = int(WorkString[1]);
countvar++;
}
}
catch(Exception e)
{
AppendLogFile("Coordinates missing or other error with patch file, found "+countvar+" coordinates");
EBWUsXC = 17;
MaxPixels = countvar; 
}
int Xdifference = MaxX - MinX;
int Ydifference = MaxY - MinY;
AppendLogFile(Xdifference+" : "+Ydifference);
int tempSz = 0;
if(Xdifference >= Ydifference) tempSz =  530 / (Xdifference+1);
else tempSz = 435 / (Ydifference+1);
if(tempSz > IMwZLgR) tempSz = int((float)tempSz * 0.75);
int[] PatchCoordX = new int[MaxPixels]; 
int[] PatchCoordY = new int[MaxPixels];
for (int i=0;i != MaxPixels;i++)
{
WorkString = split(lines[i+1], '\t');   
PatchCoordX[i] = int(WorkString[0]) - MinX;
PatchCoordY[i] = int(WorkString[1]) - MinY;
} 
int offsetX = (530 - (tempSz * Xdifference)) / 2;
int offsetY = (435 - (tempSz * Ydifference)) / 2; 
zQjfRqq = MaxPixels;
IBzMEJI = new int[MaxPixels]; 
zppAzXD = new int[MaxPixels]; 
for (int i=0;i != MaxPixels;i++)
{
IBzMEJI[i] = offsetX+(PatchCoordX[i]*tempSz);
zppAzXD[i] = offsetY+(PatchCoordY[i]*tempSz);
}
AppendLogFile("set totalcolorchannels to "+MaxPixels);
GraphicLayoutBuild();	
}
class ColorRect
{
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int Red;
int Green;
int Blue;
int White;
ColorRect(int ixpos, int iypos, int ibWidth, int ibHeight, int iRed, int iGreen, int iBlue, int iWhite)
{
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
Red = iRed;
Green = iGreen;
Blue = iBlue;
White = iWhite;
}
void display()
{
strokeWeight(1);
stroke(cWorkspaceFont);
if(device.Bit16Capable == true)	fill((Red>>8), (Green>>8), (Blue>>8));	
else fill(Red, Green, Blue);
int holdPixelType = fYArHTo;
if(LMORxyF == 2 && RVeDwhC == 2) 
{
holdPixelType = FmxWQSR;
}	
switch(holdPixelType)
{
case 0: 
if(device.Bit16Capable == true)	fill((White>>8));
else fill(White);	
rect(xpos, ypos, bWidth, bHeight);
break;
case 1: 
rect(xpos, ypos, bWidth, bHeight);
break;	
case 2: 
rect(xpos, ypos, bWidth, bHeight); 
if(device.Bit16Capable == true)	fill((White>>8));
else fill(White); 
rect(xpos, ypos+(((float)bHeight/3)*2), bWidth, ((float)bHeight/3));	
break;
}	
noStroke();
}
boolean over() 
{
if (yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
} 
class ColorPickerObj
{
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int selPointX;
int selPointY;
int slRed;
int slGreen;
int slBlue;
int slWhite;
ColorPickerObj(int ixpos, int iypos, int ibWidth, int ibHeight, int iselPointX, int iselPointY, int islRed, int islGreen, int islBlue, int islWhite)
{
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
selPointX = iselPointX;
selPointY = iselPointY;
slRed = islRed;
slGreen = islGreen;
slBlue = islBlue;
slWhite = islWhite;
}
void display()
{
image(gradientImg, xpos, ypos, bWidth, bHeight);
int holdPixelType = fYArHTo;
if(LMORxyF == 2 && RVeDwhC == 2) 
{
holdPixelType = FmxWQSR;
}
switch(holdPixelType)
{
case 0: 
ColorSelectorSliders[0].Value = 0;
ColorSelectorSliders[1].Value = 0;
ColorSelectorSliders[2].Value = 0;		
ColorSelectorSliders[3].Value = slWhite; 
break;
case 1: 
ColorSelectorSliders[0].Value = slRed;
ColorSelectorSliders[1].Value = slGreen;
ColorSelectorSliders[2].Value = slBlue;	
ColorSelectorSliders[3].Value = 0;
break;	
case 2: 
ColorSelectorSliders[0].Value = slRed;
ColorSelectorSliders[1].Value = slGreen;
ColorSelectorSliders[2].Value = slBlue;	
ColorSelectorSliders[3].Value = slWhite;
break;
}
fill(255);
textSize(12);
textLeading(14);	
textAlign(RIGHT);
text("Red:\nGreen:\nBlue:\nWhite:", xpos+45, ypos+215);
text(slRed+"\n"+slGreen+"\n"+slBlue+"\n"+slWhite, xpos+85, ypos+215);
textAlign(LEFT);
if(fQlhEcU == 10000)     text("Coloring All",xpos+10, ypos+280);
else if(fQlhEcU > 10000)     text("Color Group: "+(fQlhEcU-10000),xpos+10, ypos+280);
else if(GraphicFuncPaintButton.Selected == true)  text("Paint Color",xpos+10, ypos+280);
else text("LED#: "+(UDMnaMJ+1),xpos+10, ypos+280);
text("Recent\nPalette:",xpos+20, ypos+185);		
textSize(10);	
textAlign(CENTER);
text("Selected", xpos+245, ypos+215);
textAlign(LEFT);
strokeWeight(1);
stroke(0);
for (int i=0; i != paletteColors.length;i++)
{
fill(paletteColors[i][0],paletteColors[i][1],paletteColors[i][2]);
rect(xpos+70+(i*30), ypos+175,25,25);		
}
switch(holdPixelType)
{
case 0: 
if(device.Bit16Capable == true)	fill((slWhite>>8));
else	fill(slWhite);
rect(xpos+230, ypos+220, 30, 30);	
break;
case 1: 
case 2: 
if(device.Bit16Capable == true)	fill((slRed>>8),(slGreen>>8),(slBlue>>8));
else	fill(slRed,slGreen,slBlue);
rect(xpos+230, ypos+220, 30, 30);
if(holdPixelType == 1) break;
if(device.Bit16Capable == true)	fill((slWhite>>8));
else fill(slWhite); 
rect(xpos+230, ypos+240, 30, 10);	
for (int i=0; i != paletteColors.length;i++)
{
fill(paletteColors[i][3]);
rect(xpos+70+(i*30), ypos+190,25,10);		
}			
break;
}	
noStroke();
switch(holdPixelType)
{
case 0: 
ColorSelectorSliders[3].display(); 
break;
case 1: 
ColorSelectorSliders[0].display();
ColorSelectorSliders[1].display();
ColorSelectorSliders[2].display();	
break;	
case 2: 
ColorSelectorSliders[0].display();
ColorSelectorSliders[1].display();
ColorSelectorSliders[2].display();
ColorSelectorSliders[3].display(); 	
break;
}
ColorSelectorApply.display();
ColorSelectorCancel.display();
TextFields[10].display();	
fill(0, 0, 0, 0); 
stroke(255);
rect(round(selPointX/ThUIWJw)-2, round(selPointY/ThUIWJw)-2, 4, 4);
stroke(0);
rect(round(selPointX/ThUIWJw)-3, round(selPointY/ThUIWJw)-3, 4, 4);
}
void InitPosition()
{
yrsmlGD = round((float)mouseX / ThUIWJw);
LWAPDwF = round((float)mouseY / ThUIWJw);  
this.xpos = yrsmlGD;
this.ypos = LWAPDwF;
if ((this.xpos+bWidth) > round(width/ThUIWJw)) this.xpos = round(width/ThUIWJw) - bWidth;
if ((this.ypos+bHeight) > round(height/ThUIWJw)) this.ypos = round(height/ThUIWJw) - bHeight;    
ColorSelectorSliders[0].xpos = this.xpos +90;
ColorSelectorSliders[0].ypos = this.ypos+205;
ColorSelectorSliders[1].xpos = this.xpos +90;
ColorSelectorSliders[1].ypos = this.ypos+220;
ColorSelectorSliders[2].xpos = this.xpos + 90;
ColorSelectorSliders[2].ypos = this.ypos+235;  
ColorSelectorSliders[3].xpos = this.xpos +90;
ColorSelectorSliders[3].ypos = this.ypos+250;  
TextFields[10].xpos = this.xpos +100;
TextFields[10].ypos = this.ypos+265; 
ColorSelectorApply.xpos = this.xpos+170;
ColorSelectorApply.ypos = this.ypos+265; 
ColorSelectorCancel.xpos = this.xpos+220;
ColorSelectorCancel.ypos = this.ypos+265; 
selPointX = xpos + (xpos/2);
selPointY = ypos + (ypos/2);
if(GraphicFuncPaintButton.Selected == true)
{
AppendLogFile("Ran color fill for paiting");	
ColorSelectorSliders[0].Value = lAAqduc[0];
ColorSelectorSliders[1].Value = lAAqduc[1];
ColorSelectorSliders[2].Value = lAAqduc[2];
ColorSelectorSliders[3].Value = lAAqduc[3];
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;		
}
else if(slBNIJT[DIWlYpw].SeqMode == mGradient)
{
ColorSelectorSliders[0].Value = GradientRects[lXrpjlY].Red;
ColorSelectorSliders[1].Value = GradientRects[lXrpjlY].Green;
ColorSelectorSliders[2].Value = GradientRects[lXrpjlY].Blue;
ColorSelectorSliders[3].Value = GradientRects[lXrpjlY].White;
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;	
}	
else if(fQlhEcU == 10000)
{
AppendLogFile("All the same no color setup - Color Sliders Not Initialized");
}
else if(LMORxyF == 2 && RVeDwhC == 2)
{
int holdPixelType = fYArHTo;
if(LMORxyF == 2 && RVeDwhC == 2) 
{
holdPixelType = FmxWQSR;
}
AppendLogFile("SelectedTLFrameButton: "+fQlhEcU);
switch(holdPixelType)
{
case 0: 
ColorSelectorSliders[3].Value = ControlSliders[fQlhEcU*QVhoOtU].Value;
slRed = 0;
slGreen = 0;
slBlue = 0;
slWhite = ControlSliders[fQlhEcU*QVhoOtU].Value;   
break;
case 1: 
ColorSelectorSliders[0].Value = ControlSliders[(fQlhEcU*QVhoOtU)].Value;
ColorSelectorSliders[1].Value = ControlSliders[(fQlhEcU*QVhoOtU)+1].Value;
ColorSelectorSliders[2].Value = ControlSliders[(fQlhEcU*QVhoOtU)+2].Value;
slRed = ControlSliders[(fQlhEcU*QVhoOtU)].Value;
slGreen = ControlSliders[(fQlhEcU*QVhoOtU)+1].Value;
slBlue = ControlSliders[(fQlhEcU*QVhoOtU)+2].Value;
slWhite	= 0;		
break;
case 2: 
AppendLogFile("This: "+fQlhEcU);
ColorSelectorSliders[0].Value = ControlSliders[(fQlhEcU*QVhoOtU)].Value;
ColorSelectorSliders[1].Value = ControlSliders[(fQlhEcU*QVhoOtU)+1].Value;
ColorSelectorSliders[2].Value = ControlSliders[(fQlhEcU*QVhoOtU)+2].Value;
ColorSelectorSliders[3].Value = ControlSliders[fQlhEcU*QVhoOtU+3].Value;
slRed = ControlSliders[(fQlhEcU*QVhoOtU)].Value;
slGreen = ControlSliders[(fQlhEcU*QVhoOtU)+1].Value;
slBlue = ControlSliders[(fQlhEcU*QVhoOtU)+2].Value;
slWhite = ControlSliders[fQlhEcU*QVhoOtU+3].Value;
break;
}
}	
else if(slBNIJT[DIWlYpw].SeqMode != mGradient)
{
int tempVar = (slBNIJT[DIWlYpw].SeqFrameAmount+1);
if(fQlhEcU > 9999)
{
AppendLogFile("Breaking Out - Sliders Init as 0s");
ColorSelectorSliders[0].Value = 0;
ColorSelectorSliders[1].Value = 0;
ColorSelectorSliders[2].Value = 0;
ColorSelectorSliders[3].Value = 0;
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;	
return;
}
switch(fYArHTo)
{
case 0: 
ColorSelectorSliders[3].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ];
slRed = 0;
slGreen = 0;
slBlue = 0;
slWhite = ColorSelectorSliders[3].Value;				
break;
case 1: 
ColorSelectorSliders[0].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ];
ColorSelectorSliders[1].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+1];
ColorSelectorSliders[2].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+2];
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = 0;		
break;
case 2: 
ColorSelectorSliders[0].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ];
ColorSelectorSliders[1].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+1];
ColorSelectorSliders[2].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+2];
ColorSelectorSliders[3].Value = slBNIJT[DIWlYpw].DataFrames[fQlhEcU % tempVar][(fQlhEcU / tempVar) * MDmgrxQ+3];
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;			
break;
}
}	  
if(fYArHTo == 0) SliderPointer = ColorSelectorSliders[3]; 
else SliderPointer = ColorSelectorSliders[0]; 
TextFields[10].Label = ""+SliderPointer.Value;
}
void PickColor()
{   
this.selPointX = mouseX;
this.selPointY = mouseY; 
zpfDQQc = get(mouseX, mouseY);      
Ohsuixc = zpfDQQc >> 16 & 0xFF; 
OfkiYaD = zpfDQQc >> 8 & 0xFF;
TmzyKzO = zpfDQQc & 0xFF;    
int holdPixelType = fYArHTo;
if(LMORxyF == 2 && RVeDwhC == 2) 
{
holdPixelType = FmxWQSR;
}	
if(device.Bit16Capable == true)
{
if(Ohsuixc != 0)Ohsuixc = (Ohsuixc+1) * 256;
if(OfkiYaD != 0)OfkiYaD = (OfkiYaD+1) * 256;
if(TmzyKzO != 0)TmzyKzO = (TmzyKzO+1) * 256;
if(qeeOUAC != 0)qeeOUAC = (qeeOUAC+1) * 256;
AppendLogFile("Color Picked Multiplied");
if(Ohsuixc > 0xFFFF)Ohsuixc = 0xFFFF;
if(OfkiYaD > 0xFFFF)OfkiYaD = 0xFFFF;
if(TmzyKzO > 0xFFFF)TmzyKzO = 0xFFFF;
if(qeeOUAC > 0xFFFF)qeeOUAC = 0xFFFF;
}
switch(holdPixelType)
{
case 0: 
this.slRed = 0;
this.slGreen = 0;
this.slBlue = 0;
this.slWhite = int((Ohsuixc+OfkiYaD+TmzyKzO)/3);
break;
case 1: 
this.slRed = (int)Ohsuixc;
this.slGreen = (int)OfkiYaD;
this.slBlue = (int)TmzyKzO;
this.slWhite = 0;		
break;	
case 2: 
this.slRed = (int)Ohsuixc;
this.slGreen = (int)OfkiYaD;
this.slBlue = (int)TmzyKzO;
break;
}	
} 
boolean over() 
{
if (yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
} 
boolean overPicker() 
{
if ( yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight-90) 
{      
return true;
} 
else {
return false;
}
}
}
class CheckBox
{
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
color ColOut;  
boolean Selected;
CheckBox(int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iSelected)
{
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = iSelected;
}
void display()
{
strokeWeight(1);
stroke(ColOut);
fill(ColBG);
rect(xpos, ypos, bWidth, bHeight);  
if (Selected==true)
{
line(xpos, ypos, xpos+bWidth, ypos+bHeight);
line(xpos+bWidth, ypos, xpos, ypos+bHeight);
}
}
void displayLinked()
{
LinkedScrollBuffer.strokeWeight(1);
LinkedScrollBuffer.stroke(ColOut);
LinkedScrollBuffer.fill(ColBG);
LinkedScrollBuffer.rect(xpos, ypos, bWidth, bHeight);  
if (Selected==true)
{
LinkedScrollBuffer.line(xpos, ypos, xpos+bWidth, ypos+bHeight);
LinkedScrollBuffer.line(xpos+bWidth, ypos, xpos, ypos+bHeight);
}
}
boolean overLinked() 
{
if ( yrsmlGD >= (xpos+85) && yrsmlGD <= (xpos+85+bWidth) && LWAPDwF >= 35+(ypos-LinkedScrollBar.Value) && LWAPDwF <= (35+bHeight)+(ypos-LinkedScrollBar.Value)) 
{      
return true;
} 
else {
return false;
}
}
boolean over() 
{
if ( yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
}
class TabButton
{
String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
color ColOut;  
boolean Selected;  
boolean ReqRefresh;
TabButton(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iSelected, boolean iReqRefresh)
{
Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = iSelected;
ReqRefresh = iReqRefresh;
}
void refresh()
{
this.ReqRefresh = false;
switch(LMORxyF)
{
case 0:
if (this == MenuTabs[0]) GraphicLayoutBuild();
else this.ReqRefresh = true;	
break;
case 1:
if (this == MenuTabs[1]) DrawTimeLineBuffer();
else this.ReqRefresh = true;	
break;		
case 2:
if (this == MenuTabs[2]) DrawIndexScrollArea();
else this.ReqRefresh = true;	
break;
default:
this.ReqRefresh = true;	
break;		
}
}
void display()
{
noStroke();
if (Selected==true)
{
fill(ColHL);
rect(xpos, ypos, bWidth, bHeight, bHeight/2);   
rect(xpos, ypos+(bHeight/1.75), bWidth, (float)bHeight/2.1);
}
else       
{
fill(ColBG, 128);
rect(xpos, ypos, bWidth, bHeight, bHeight/8);
}
fill(ColOut);
textSize((bHeight/1.75));
text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
}
boolean over() 
{
if ( yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
}
class DropDown
{
String[] Labels;
int numStrs;
int SelStr;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
color ColOut;  
boolean Selected;
DropDown(String[] iLabels, int inumStrs, int iSelStr, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iSelected)
{
Labels = iLabels; 
numStrs = inumStrs;
SelStr = iSelStr;
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = iSelected;
}
void displayNormal()
{
strokeWeight(1);
stroke(ColOut);
if (Selected==true) fill(ColHL);
else fill(ColBG);
rect(xpos, ypos, bWidth, bHeight);  
textAlign(LEFT);
fill(ColOut);
textSize((bHeight/1.75));
text(Labels[SelStr], xpos+(bWidth/20), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
fill(255);
int tempSize = (bWidth/4);
if(tempSize >  (bHeight/4)) tempSize = (bHeight);
triangle(xpos+(bWidth-tempSize), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/2), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/4), ypos+(bHeight/4)+(bHeight/2));
noStroke();
}
void selectDD()
{
if(vTJocgz == true)DropDownPointer.Selected = false; 
Selected =! Selected;	
if(Selected == true)
{	
DropDownPointer = this;
vTJocgz = true;
}
else
{
vTJocgz = false; 
}
}
void display()
{
if(Selected == false)
{
displayNormal();
}
else
{
fill(ColBG);
displayNormal();
strokeWeight(1);
stroke(ColOut);  
for (int i = 0; i != numStrs; i++)
{
fill(ColBG);
rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
fill(ColOut);
textSize((bHeight/1.75));
text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5)+(bHeight*(i+1)), bWidth, bHeight);
}   
noStroke();
}
}
void displayOpen()
{
fill(ColBG);
display();
strokeWeight(1);
stroke(ColOut);  
for (int i = 0; i != numStrs; i++)
{
fill(ColBG);
rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
fill(ColOut);
textSize((bHeight/1.75));
text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5)+(bHeight*(i+1)), bWidth, bHeight);
}	 
noStroke();
}
boolean over() 
{
if ( yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
int overOpen()
{
for (int i = 0; i != numStrs; i++)
{
if (yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos+(bHeight*(i+1)) && LWAPDwF <= ypos+bHeight+(bHeight*(i+1)))
{    
return (i+1);
}
}
return 0;
}
}
class TLButton
{
String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
color ColOut;  
boolean Toggle;
boolean Selected;
TLButton(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iToggle, boolean iSelected)
{
Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Toggle = iToggle;
Selected = iSelected;
}
void display() 
{
TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.stroke(ColOut);
if (Selected==true)  TimeLineBuffer.fill(ColHL);
else  TimeLineBuffer.fill(ColBG);
TimeLineBuffer.rect(xpos, ypos, bWidth, bHeight, bHeight/4);  
TimeLineBuffer.fill(ColOut);
TimeLineBuffer.textSize(bHeight*1.2); 
if(Label.length() > 2) TimeLineBuffer.textSize(bHeight/1.25);
TimeLineBuffer.textAlign(CENTER);
TimeLineBuffer.text(Label,xpos,ypos+((float)bHeight/3.5),bWidth,bHeight);
TimeLineBuffer.textAlign(LEFT);
TimeLineBuffer.noStroke();
if (Toggle==false) Selected = false;
}
boolean over() 
{
if ( yrsmlGD >= (xpos+cTLChBufX) && yrsmlGD <= (xpos+cTLChBufX+bWidth) && LWAPDwF >= cTLChBufY+(ypos-AeQGRRm) && LWAPDwF <= (cTLChBufY+bHeight)+(ypos-AeQGRRm)) 
{      
return true;
} 
else {
return false;
}
}
} 
class TLTriangle
{
String Label;
int xpos; 
int ypos ; 
int zpos ; 
int bSize;
color ColBG;
color ColHL;
color ColOut;  
boolean Toggle;
boolean Selected;
TLTriangle(String iLabel, int ixpos, int iypos, int izpos, int ibSize, color iColBG, color iColHL, color iColOut, boolean iToggle, boolean iSelected)
{
Label = iLabel; 
xpos = ixpos;
ypos = iypos; 
zpos = izpos;     
bSize = ibSize;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Toggle = iToggle;
Selected = iSelected;
}
void display()
{
TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.stroke(ColOut);
if (Selected==true)  TimeLineBuffer.fill(ColHL);
else  TimeLineBuffer.fill(ColBG);
TimeLineBuffer.stroke(255);
TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.triangle(xpos-(bSize), ypos, xpos+(bSize), ypos, xpos, ypos+bSize);
TimeLineBuffer.line(xpos,ypos+(bSize),xpos, ypos+(bSize)+8);
TimeLineBuffer.noStroke();
if (Toggle==false) Selected = false;
}
boolean over() 
{
if (yrsmlGD >= (xpos+85)-(bSize) && yrsmlGD <= (xpos+85+(bSize)) && LWAPDwF >= cTLChBufY+(ypos-AeQGRRm) && LWAPDwF <= (cTLChBufY+(bSize+8))+(ypos-AeQGRRm)) 
{      
return true;
} 
else {
return false;
}
}
} 
class Button
{
String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
color ColOut;  
boolean Toggle;
boolean Selected;
Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, color iColOut, boolean iToggle, boolean iSelected)
{
Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Toggle = iToggle;
Selected = iSelected;
}
void display()
{
strokeWeight(1);
stroke(ColOut);
if (Selected==true) fill(ColHL);
else  fill(ColBG);
textAlign(LEFT);
rect(xpos, ypos, bWidth, bHeight, bHeight/8);  
fill(ColOut);
textSize((bHeight/1.75));
text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
noStroke();
if (Toggle==false) Selected = false;
}
void displaySq()
{
strokeWeight(1);
stroke(ColOut);
if (Selected==true) fill(ColHL);
else  fill(ColBG);
rect(xpos, ypos, bWidth, bHeight);  
fill(ColOut);
textSize(12);
textAlign(CENTER);
text(Label, xpos+(bWidth/2), ypos+20);
textAlign(LEFT);   
noStroke();
if (Toggle==false) Selected = false;
} 
void displayIconDrag(int xposB, int yposB)
{
strokeWeight(1);
stroke(ColOut);
if (Selected==true) fill(ColHL);
else  fill(ColBG);
rect(xposB, yposB, bWidth, bHeight);  
fill(ColOut);
textSize(12);
textAlign(CENTER);
text(Label, xposB+(bWidth/2), yposB+20);
textAlign(LEFT);   
noStroke();
}
void displayIconB(int xposB, int yposB)
{
ConnectionScrollBuffer.strokeWeight(1);
ConnectionScrollBuffer.stroke(ColOut);
if (Selected==true) ConnectionScrollBuffer.fill(ColHL);
else  ConnectionScrollBuffer.fill(ColBG);
ConnectionScrollBuffer.rect(xposB, yposB, bWidth, bHeight);  
ConnectionScrollBuffer.fill(ColOut);
ConnectionScrollBuffer.textSize(12);
ConnectionScrollBuffer.textAlign(CENTER);
ConnectionScrollBuffer.text(Label, xposB+(bWidth/2), yposB+20);
ConnectionScrollBuffer.textAlign(LEFT);   
ConnectionScrollBuffer.noStroke();
}  
boolean over() 
{
if ( yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
} 
} 
class SliderBar
{
int xpos; 
int ypos ; 
int slWidth; 
int slHeight; 
int Value; 
int Minimum; 
int Maximum;
color BgColor;
color slHandleColor;
color slSelectColor; 
color slStrokeColor;
boolean CircleHandle;  
boolean HorizVertToggle;
int  SetNumber;
float temp1=slWidth;
float temp2=Maximum;
float temp3=Value;
float temp4=Minimum;
float MathVar=0;
SliderBar(int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, color iBgColor, color islHandleColor, color islSelectColor, color islStrokeColor, boolean iCircleHandle, boolean iHorizVertToggle, int  iSetNumber) 
{   
xpos = ixp;
ypos = iyp;  
slWidth = iw;
slHeight = ih;
Value=iValue;
Maximum=iMax;
Minimum=iMin;
BgColor=iBgColor;
slHandleColor=islHandleColor;
slSelectColor=islSelectColor;
slStrokeColor=islStrokeColor;
CircleHandle=iCircleHandle;     
HorizVertToggle=iHorizVertToggle;
SetNumber = iSetNumber;
}
void setValue(int passedVal)
{
Value = passedVal;
if (Value > Maximum) { 
Value = Maximum;
}
if (Value < Minimum) { 
Value=Minimum;
}
}
void move(int uX, int uY) 
{
if(HorizVertToggle == false) 
{
temp1 = slWidth;   
temp3 = Value;
temp4 = Minimum;
MathVar = (((uX-xpos) / temp1)-1) *-1; 
MathVar = Maximum - (MathVar*(Maximum-Minimum));   
if (MathVar > Maximum) { 
MathVar=Maximum;
}
if (MathVar < Minimum) { 
MathVar=Minimum;
}  
Value=int(MathVar); 
}
else
{
temp1 = slHeight - (slWidth * 2);   
temp3 = Value;
MathVar = ((((uY-ypos)-slWidth) / temp1)-1) *-1; 
MathVar = Maximum - (MathVar*(Maximum-Minimum));   
if (MathVar > Maximum) { 
MathVar=Maximum;
}
if (MathVar < Minimum) { 
MathVar=Minimum;
}  
Value=int(MathVar); 
}	
} 
void displayLinked()
{   
LinkedScrollBuffer.stroke(slStrokeColor);
LinkedScrollBuffer.strokeWeight(1);
LinkedScrollBuffer.fill(BgColor); 
LinkedScrollBuffer.rect(xpos, ypos, slWidth, slHeight);   
if (CircleHandle==true) temp1 = slWidth - slHeight;
else temp1=slWidth-(slWidth/20);
temp2=Maximum;  
temp3=Value;    
temp4 = Minimum;
float MathVar;
if (CircleHandle==true)
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
else  
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 
LinkedScrollBuffer.fill(color(slSelectColor)); 
LinkedScrollBuffer.rect(xpos, ypos, MathVar, slHeight);
LinkedScrollBuffer.fill(slHandleColor); 
if (CircleHandle==true)   LinkedScrollBuffer.ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); 
else   LinkedScrollBuffer.rect((xpos+MathVar), ypos, slWidth/20, slHeight); 
LinkedScrollBuffer.fill(cBackgroundColor);
LinkedScrollBuffer.noStroke();
LinkedScrollBuffer.rect(xpos+slWidth-25,ypos-25, 40, 20);
LinkedScrollBuffer.fill(cWorkspaceFontColor);
LinkedScrollBuffer.text(""+Value,xpos+slWidth-25,ypos-10);
}
void display() 
{   
if(HorizVertToggle == false) 
{ 
stroke(slStrokeColor);
strokeWeight(1);
fill(BgColor); 
rect(xpos, ypos, slWidth, slHeight);   
if (CircleHandle==true) temp1 = slWidth - slHeight;
else temp1=slWidth-(slWidth/20);
temp2=Maximum;  
temp3=Value;    
temp4 = Minimum;
float MathVar;
if (CircleHandle==true)
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
else  
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 
fill(color(slSelectColor)); 
rect(xpos, ypos, MathVar, slHeight);
fill(slHandleColor); 
if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); 
else   rect((xpos+MathVar), ypos, slWidth/20, slHeight); 
}
else
{
stroke(slStrokeColor);
strokeWeight(1);
fill(BgColor); 
rect(xpos, ypos, slWidth, slHeight);  
fill(200); 
rect(xpos+(slWidth/10), ypos+(slWidth/10)+slWidth, slWidth-(slWidth/5), (slHeight-(slWidth/5))-(slWidth*2));   
rect(xpos+(slWidth/10), ypos+(slWidth/10), slWidth-(slWidth/5), slWidth-(slWidth/5));   
rect(xpos+(slWidth/10), ypos+(slWidth/10)+slHeight-slWidth, slWidth-(slWidth/5), slWidth-(slWidth/5));   
stroke(slStrokeColor);
fill(slHandleColor);
strokeWeight(1);
triangle(xpos+(slWidth/5), ypos+(slWidth/4)+(slWidth/2), xpos+(slWidth/2), ypos+(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+(slWidth/2));
triangle(xpos+(slWidth/5), ypos+(slWidth/4)+slHeight-slWidth, xpos+(slWidth/2), ypos+slHeight-(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+slHeight-slWidth);
temp1 = (slHeight - (slWidth*3));
temp2 = Maximum;  
temp3 = Value;    
temp4 = Minimum;
float MathVar;
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slWidth/2+slWidth;
fill(slHandleColor); 
ellipse(xpos+(slWidth/2), ypos+MathVar, slWidth-2, slWidth-2); 
noStroke();
}
}
void selectSlider()
{
SliderPointer = this;
qAuRcYr = true;
}
boolean overLinked() 
{
if ( yrsmlGD >= (xpos+85) && yrsmlGD <= (xpos+85+slWidth) && LWAPDwF >= 35+(ypos-LinkedScrollBar.Value) && LWAPDwF <= (35+slHeight)+(ypos-LinkedScrollBar.Value)) 
{      
return true;
} 
else {
return false;
}
}
boolean over() 
{
if (yrsmlGD >= xpos && yrsmlGD <= xpos+slWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+slHeight) 
{          
return true;
} 
else {
return false;
}
}
}
class TextField
{
String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
color ColBG;
color ColHL;
boolean Toggle;
boolean Selected;
TextField(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, color iColBG, color iColHL, boolean iToggle, boolean iSelected)
{
Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
Toggle = iToggle;
Selected = iSelected;
}
void display()
{
translate(0, 0);
strokeWeight(2);
fill(ColBG);
if (Selected==true)
{
stroke(ColHL); 
rect(xpos, ypos, bWidth, bHeight);
}
else       
{
stroke(0, 0, 255);
rect(xpos, ypos, bWidth, bHeight);
}
noStroke();
fill(0);
textSize((bHeight/1.75));
textAlign(LEFT);
text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
if (Toggle==false) Selected = false;
}
void displayLinked()
{
LinkedScrollBuffer.strokeWeight(2);
LinkedScrollBuffer.fill(ColBG);
if (Selected==true)
{
LinkedScrollBuffer.stroke(ColHL); 
LinkedScrollBuffer.rect(xpos, ypos, bWidth, bHeight);
}
else       
{
LinkedScrollBuffer.stroke(0, 0, 255);
LinkedScrollBuffer.rect(xpos, ypos, bWidth, bHeight);
}
LinkedScrollBuffer.noStroke();
LinkedScrollBuffer.fill(0);
LinkedScrollBuffer.textSize((bHeight/1.75));
LinkedScrollBuffer.textAlign(LEFT);
LinkedScrollBuffer.text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5), bWidth, bHeight);
if (Toggle==false) Selected = false;		
}
void SelectField(int passedID)
{
try {
TextFields[yJIRxDo].Selected = false; 
LinkedIterationFields[yJIRxDo].Selected = false;
}
catch(Exception e) { }
yJIRxDo = passedID;
BTVNeSA = false;
QzQTRuy = true;
TextFields[yJIRxDo].Label = "";
TextFields[yJIRxDo].Selected = true; 
}
void QFfuPVTField(int passedID)
{
try {
TextFields[yJIRxDo].Selected = false; 
LinkedIterationFields[yJIRxDo].Selected = false;
LinkedIterationFields[yJIRxDo].displayLinked(); 
}
catch(Exception e) { }
yJIRxDo = passedID;
BTVNeSA = true;
QzQTRuy = true;
LinkedIterationFields[yJIRxDo].Label = "";
LinkedIterationFields[yJIRxDo].Selected = true;
}	
boolean overLinked() 
{
if (yrsmlGD >= (xpos+85) && yrsmlGD <= (xpos+85+bWidth) && LWAPDwF >= 35+(ypos-LinkedScrollBar.Value) && LWAPDwF <= (35+bHeight)+(ypos-LinkedScrollBar.Value)) 
{      
return true;
} 
else {
return false;
}
}
boolean over() 
{
if (yrsmlGD >= xpos && yrsmlGD <= xpos+bWidth && LWAPDwF >= ypos && LWAPDwF <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}
}
} 
class LEDgraphic
{
int ChanID;
int xpos; 
int ypos ; 
int bSize;
color cColor;
int GroupID;
LEDgraphic(int iChanID, int ixpos, int iypos, int ibSize, color icColor)
{
ChanID=iChanID; 
xpos = ixpos;
ypos = iypos;  
bSize = ibSize;
cColor = icColor;
}
void displayGroup()
{
fill(IconGroupColors[GroupID]);
ellipse(xpos+cImgBufferX, ypos+cImgBufferY, bSize, bSize); 	  
pushStyle();
fill(255);
textSize((bSize/1.75));
textAlign(CENTER, CENTER); 
text(GroupID, xpos+85, (ypos+35));
textAlign(LEFT, BASELINE);
noStroke();	  
popStyle();	  
}
void display()
{   
GraphicLayoutBuffer.beginDraw();
GraphicLayoutBuffer.noStroke();
switch(fYArHTo)
{
case 0: 
Ohsuixc =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID)* MDmgrxQ];
OfkiYaD =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ];
TmzyKzO =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ];
GraphicLayoutBuffer.fill(color(slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ]));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.3, bSize*1.3);	
break;
case 1: 
Ohsuixc =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID)* MDmgrxQ];
OfkiYaD =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ+1];
TmzyKzO =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ+2];
GraphicLayoutBuffer.fill(color(slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ], slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ+1], slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ+2]));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.3, bSize*1.3);
break;	
case 2: 
Ohsuixc =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID)* MDmgrxQ];
OfkiYaD =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ+1];
TmzyKzO =  slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ+2];
qeeOUAC = slBNIJT[DIWlYpw].DataFrames[lXrpjlY][(ChanID) * MDmgrxQ+3];
GraphicLayoutBuffer.fill(color(slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ], slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ+1], slBNIJT[DIWlYpw].StartValues[(ChanID)* MDmgrxQ+2]));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.3, bSize*1.3); 
GraphicLayoutBuffer.stroke(qeeOUAC);
GraphicLayoutBuffer.strokeWeight(6);
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize, bSize);
GraphicLayoutBuffer.noStroke();
break;
}	
GraphicLayoutBuffer.strokeWeight(1); 
GraphicLayoutBuffer.stroke((255 - Ohsuixc), (255 - OfkiYaD), (255 - TmzyKzO));
if ((Ohsuixc < 170 && Ohsuixc > 80) || (OfkiYaD < 170 && OfkiYaD > 80) || (TmzyKzO < 170 && TmzyKzO > 80))stroke(255);
GraphicLayoutBuffer.fill(color(Ohsuixc, OfkiYaD, TmzyKzO));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize, bSize); 
GraphicLayoutBuffer.fill((255 - Ohsuixc), (255 - OfkiYaD), (255 - TmzyKzO));
if ((Ohsuixc < 170 && Ohsuixc > 80) || (OfkiYaD < 170 && OfkiYaD > 80) || (TmzyKzO < 170 && TmzyKzO > 80))
{
GraphicLayoutBuffer.fill(255);
}  
GraphicLayoutBuffer.textSize((bSize/1.75));
GraphicLayoutBuffer.textAlign(CENTER, CENTER); 
GraphicLayoutBuffer.text((ChanID+1), xpos, ypos-(bSize/10));
GraphicLayoutBuffer.textAlign(LEFT, BASELINE);
GraphicLayoutBuffer.noStroke();
GraphicLayoutBuffer.endDraw();
}
boolean over() 
{
if (yrsmlGD >= (xpos+85)-(bSize/2) && yrsmlGD <= (xpos+85)+(bSize/2) && LWAPDwF >= ypos+35-(bSize/2) && LWAPDwF <= (ypos+35)+(bSize/2)) 
{      
return true;
} 
else {
return false;
}
}
}